/*
 *	dq12decode.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"

/* hSNGXgIEII̕R[h\(VOoCg) */
static const char *tbl_charcode[] =
{
	" ",  "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "H",  "M",  "P",  "G",  "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z", "\",
	"^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z", "}",
	"~", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "b",
	"", "", "", "@", "B", "F", "H", "[", "?",  "!",  "", "", "", "", "", "",
	"", "/",  "K", "J", ":",  "Ex", "Lv", "\", "*",  "B", ".",  "u", "c", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "E",  "",
	"", "I",  "II", "A",  "B",  "C",  "D",  "E",  "F",  "G",  "H",  "I",  "J",  "K",  "L",  "M",
	"N",  "O",  "P",  "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
};

static const char *tbl_dakuten[] =
{
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", NULL, NULL, NULL, NULL, NULL, "", "", "", "", "", NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, "K", "M", "O", "Q", "S", "U", "W", "Y", "[", "]",
	"_", "a", "d", "f", "h", NULL, NULL, NULL, NULL, NULL, "o", "r", "u", "x", "{", NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
};

static const char *tbl_handakuten[] =
{
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "", "", "", "", "", NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "p", "s", "v", "y", "|", NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
};

/* hSNGXgIEII̕R[h\(bZ[WpE}`oCg1oCg) */
static const char *tbl_charcode_mb1[] =
{
	" ",  "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "H",  "M",  "P",  "G",  "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z", "\",
	"^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z", "}",
	"~", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "b",
	"", "", "", "@", "B", "F", "H", "[", "?",  "!",  " ",  "", "", "", "", "",
	" ",  "/",  "p", "s", ":",  "v", "y", "|", "*",  "B", ",",  "u", "c", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "K", "M", "O", "Q", "S", "U", "W", "Y", "[", "]", "_", "a", "d", "f", "h",
	"o", "r", "u", "x", "{", "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",  
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",  
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",  
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",  
	"\n", "",   "",   "",   "(O)", "",   "",   "",   "",   "",   "",   "",   "",   "",   "\n", "\n",
};

/* hSNGXgIEII̕R[h\(bZ[WpE}`oCg2oCg) */
static const char *tbl_charcode_mb2[] =
{
	/* 0xd0 */
	"", "", "", "", "", "", "", "", "_", "", "\", "", "q", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "E", "", "",
	"", "", "x", "P", "", "", "o", "", "K", "v", "", "", "l", "", "a", "",
	"S", "", "", "x", "g", "\", "", "", "", "", "", "", "", "", "", "",
	"", "l", "", "q", "", "", "", "", "n", "", "", "f", "", "J", "C", "",
	"", "", "", "{", "", "S", "", "E", "", "`", "", "", "", "g", "", "",
	"", "", "", "", "", "", "", "`", "", "L", "^", "", "V", "", "", "L",
	"V",  "", "m", "", "", "", "", "m", "", "", "^", "", "h", "", "", "",
	"", "N", "F", "", "o", "", "", "", "", "", "", "", "", "z", "", "",
	"", "", "S", "x", "N", "", "", "", "b", "v", "", "", "h", "", "", "",
	"n", "b", "", "J", "", "z", "", "", "", "", "", "", "", "s", "s", "X",
	"y", "", "", "]", "", "s", "g", "Y", "", "", "s", "", "", "", "", "A",
	"r", " ",  "L", "", "", "", "", "", "E", "", "", "", "`", "m", "", "Z",
	"", "I", "", "", "", "", "", "i", "", "M", "", "", "", "", "", "",
	"O", "", "n", "", "", "k", "C", "", "", "", "", "", "", "v", "", "",
	"N", "", "", "", "", "", "", "", "", "d", "", "", "", "c", "", "",

	/* 0xd1 */
	"", "", "C", "", "", "r", "", "", "", "A", "", "", "F", "c", "", "",
	"", "", "", "", "j", "", "d", "", "X", "u", "", "", "", "K", "C", "",
	"", "O", "", "", "", "O", "|", "", "", "_", "l", "", "_", "", "", "A",
	"", "", "\", "w", "", "t", "", "Z", "", "p", "@", "", "", "", "", "d",
	"", "", "", "", "", "p", "", "", "S", "", "", "", "", "[", "H", "F",
	"", "", "a", "V", "", "", "", "", "", "", "", "^", "", "", "", "",
	"", "", "", "", "", "", "i", "a", "K", "i", "p", "Y", "F", "", "~", "",
	"l", "", "", "", "z", "", "e", "F",  "", "", "", "", "", "", "", "X",
	"R", "", "", "", "", "", "", "i", "", "", "", "", "", "", "", "",
	"U", "", "", "", "", "", "@", "", "", "", "", "", "B", "u", "a", "",
	"A",  "B",  "", "D",  "C",  "v", "", "", "", "", "~", "", "c", "", "", "R",
	"c", "", "", "", "O",  "", "", "", "h", "", "V", "", "", "^", "H", "f",
	"", "", "M", "p", "L", "", "`", "", "t", "M", "", "D", "(",  ")",  "", "",
	"r", "", "R", "W", "", "", "F", "j", "Y", "J", "", "", "", "", "", "q",
	"d", "", "", "^", "n", "I", "", "", "}", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "D", "@", "",

	/* 0xd2 */
	"H", "", " ",  "", "", "", " ",  "", "", "", "", "o", "", "Q", "", "D",
	"G", "w", "N",  "N",  " ",  "", "", "", "C", "", "I",  "", "", "", "t", "",
	"~", "", "", "", "", "", "Z", "t", "", "", "", "", "[", "", "g",  "o",
	"s",  "u",  "b",  "", ".",  "z", "", "", "", "", "q", "P", "i", "", "F", "",
	"W", "", "", "", "", "p",  "S", "", "}", "", "", "", "", "", "G", "",
	">",  "", "_",  "n", "", "", "", "", "", "", "t", "F", "", "", "B", "]",
	"", "", "", "", "", "", "", "", "", "", "|", "", "z", "", "", "",
	"Z", "", "|", "", "_", "", "", "", "X", "", "\", "c", "", "", "e", "x",
	"X",  "", "i", "j", "v", "[", "", "", "", "", "", "", "", "", "", "",
	"", "", "", " ",  "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, int flag_multibyte)
{
	int i;
	char *buf_dstbuf = NULL;
	char *ptr_buf = NULL;
	const size_t len_buf = srcbufsize * 4;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_dakuten) / sizeof(tbl_dakuten[0]) == 256);
	assert(sizeof(tbl_handakuten) / sizeof(tbl_handakuten[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 768);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	if (!flag_multibyte)
	{
		for (i = 0; i < (int)srcbufsize; i++)
		{
			if (ptr_srcbuf[i + 1] == 0x83 && i + 1 < (int)srcbufsize && tbl_dakuten[ptr_srcbuf[i]] != NULL)			/* _̏ */
			{
				strcat(buf_dstbuf, tbl_dakuten[ptr_srcbuf[i]]);
				i++;
			}
			else if (ptr_srcbuf[i + 1] == 0x82 && i + 1 < (int)srcbufsize && tbl_handakuten[ptr_srcbuf[i]] != NULL)	/* _̏ */
			{
				strcat(buf_dstbuf, tbl_handakuten[ptr_srcbuf[i]]);
				i++;
			}
			else
				strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
		}
	}
	else
	{
		for (i = 0; i < (int)srcbufsize; i++)
		{
			if (0xd0 <= ptr_srcbuf[i] && ptr_srcbuf[i] <= 0xd2)	/* }`oCg */
			{
				strcat(buf_dstbuf, tbl_charcode_mb2[((ptr_srcbuf[i] - 0xd0) << 8) | ptr_srcbuf[i + 1]]);
				i++;
			}
			else
				strcat(buf_dstbuf, tbl_charcode_mb1[ptr_srcbuf[i]]);
		}
	}

	/* ̋󔒂 */
	while ((ptr_buf = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr_buf + 1) == '\0')
		*ptr_buf = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_multibyte)
{
	int ch;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_dakuten) / sizeof(tbl_dakuten[0]) == 256);
	assert(sizeof(tbl_handakuten) / sizeof(tbl_handakuten[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 768);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read = NULL;
		return 0;
	}

	/* fR[h */
	if (!flag_multibyte)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (0xd0 <= ch && ch <= 0xd2)	/* }`oCg */
			{
				int ch2;
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				fputs(tbl_charcode_mb2[((ch - 0xd0) << 8) | ch2], fp_write);
			}
			else
				fputs(tbl_charcode_mb1[ch], fp_write);
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
