/*
 *	dq12item.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq12decode.h"
#include "dq12item.h"

#define NUM_ITEM_DQ1		35
#define NUM_ITEM_DQ2		65

#if defined(MODE_DQ1)
#define NUM_ITEM			NUM_ITEM_DQ1
#else /* MODE_DQ1 */
#define NUM_ITEM			NUM_ITEM_DQ2
#endif /* MODE_DQ1 */

#define FILEPOS_ITEMDATA_ADDR	0x04e303
#define FILEPOS_ITEMNAME_BANK	0x000000
#define FILEPOS_ITEMDATA_BANK	0x040000
#define SIZEOF_ITEMDATA			8
#define SIZEOF_OFFSETADDR		2

static void item_setname(void);

static char tbl_itemname[NUM_ITEM][256];	/* ̖Oi[e[u */
static int flag_setitemname = 0;			/* tbl_itemnameɃf[^i[Ă邩ǂ */

const char *item_getname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_ITEM <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_setitemname)
		item_setname();

	return tbl_itemname[index];
}

static void item_setname(void)
{
	int i;
	int tbl_offset[NUM_ITEM];

	/* ̖Of[^ */
	for (i = 0; i < NUM_ITEM; i++)
		*tbl_itemname[i] = '\0';

	/* ̖Of[^i[ĂAhX(ւ̃ItZbg)ǂݍ */
	for (i = 0; i < NUM_ITEM; i++)
	{
		int offset;
		unsigned char buf_addr[SIZEOF_OFFSETADDR];
		unsigned char buf[SIZEOF_ITEMDATA];

#if defined(MODE_DQ1)
		file_read_sfc(buf_addr, FILEPOS_ITEMDATA_ADDR + SIZEOF_OFFSETADDR * i, SIZEOF_OFFSETADDR);
#else /* MODE_DQ1 */
		file_read_sfc(buf_addr, FILEPOS_ITEMDATA_ADDR + SIZEOF_OFFSETADDR * (i + NUM_ITEM_DQ1), SIZEOF_OFFSETADDR);
#endif /* MODE_DQ1 */

		offset = (buf_addr[1] << 8) | buf_addr[0];

		file_read_sfc(buf, FILEPOS_ITEMDATA_BANK + offset, SIZEOF_ITEMDATA);
		tbl_offset[i] = (buf[4] << 8) | buf[3];
	}

	/* ̖Of[^ǂݍ */
	for (i = 0; i < NUM_ITEM; i++)
	{
		unsigned char buf[256];
		unsigned char *ptr_term = buf;

		file_read_sfc(buf, FILEPOS_ITEMNAME_BANK + tbl_offset[i], sizeof(buf));

		if ((ptr_term = memchr(buf, 0xff, sizeof(buf))) == NULL)
			break;

		dec_string(tbl_itemname[i], buf, sizeof(tbl_itemname[i]), ptr_term - buf, 0);
	}

	flag_setitemname = 1;
}
