/*
 *	dq12monster.h
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(DQ12MONSTER_H)
#define DQ12MONSTER_H

typedef struct mondata_tag
{
	int hit_point;			/* qbg|Cg */
	int magic_power;		/* }WbNp[ */
	long experience_point;	/* lol */
	int gold;				/* S[h */
	int attack_power;		/* U */
	int defense_power;		/* h */
	int agility;			/* f */

	int regist_damage;		/* _[WnU(MnEoMEgpʂȂǂ܂)̑ϐ  */
	int regist_sleep;		/* z[̑ϐ */
	int regist_stopspell;	/* }zg[̑ϐ */
	int regist_defeat;		/* UL̑ϐ */
	int regist_surround;	/* }k[T̑ϐ */
	int regist_defense;		/* Jȋϐ */

	int item_no;			/* 󔠂̓̔ԍ */
	int item_get;			/* 󔠓̓Փx */
	int evade_rate;			/*  */
	int action_type;		/* s̃[e[V^Cv */
	int judgment;			/* f */

	int action[8];			/* sp^[ */
} mondata_t;

#if defined(MODE_DQ1)
typedef struct monenc_tag
{
	int level;				/* X^[p[eBx */
	int monster_no[5];		/* oX^[ */
} monenc_t;
#else /* MODE_DQ1 */
typedef struct monenc_tag
{
	int level;				/* X^[p[eBx */
	int monster_no[6];		/* oX^[ */
	int subparty[4];		/* Tup[eB̃X^[ */
} monenc_t;
#endif /* MODE_DQ1 */

typedef struct monmap_tag
{
	int area[16][16];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeregist(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);

#endif /* DQ12MONSTER_H */
