/*
 *	dq3character.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq3define.h"
#include "dq3character.h"

#define FILEPOS_CHRLVUP		0x04179e
#define NUM_CHRCLASS		9
#define SIZEOF_CHRLVUP		371
#define SIZEOF_CHREX		3

static void chr_setclassnameindex(void);

static int tbl_chrclassnameindex[NUM_CHRCLASS];	/* EƖ\̃CfbNXi[e[u */
static int flag_chrclassnameindex = 0;			/* tbl_chrclassnameindexɃf[^i[Ă邩ǂ */

const char *chr_getclassname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_CHRCLASS <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_chrclassnameindex)
		chr_setclassnameindex();

	return str_getdef(tbl_chrclassnameindex[index]);
}

static void chr_setclassnameindex(void)
{
	int i;

	/* EƖ̃CfbNXǂݍ */
	for (i = 0; i < NUM_CHRCLASS; i++)
	{
		unsigned char buf[SIZEOF_CHRLVUP];

		file_read_sfc(buf, FILEPOS_CHRLVUP + SIZEOF_CHRLVUP * i, SIZEOF_CHRLVUP);
		tbl_chrclassnameindex[i] = (buf[ 1] << 8) | buf[ 0];
	}

	flag_chrclassnameindex = 1;
}

chrlvup_t *chr_readlvup(void)
{
	int i, j;
	chrlvup_t *buf_chrlvup = NULL;

	/* LN^f[^i[obt@mۂ */
	if ((buf_chrlvup = malloc(sizeof(chrlvup_t) * NUM_CHRCLASS)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* LN^̃f[^ǂݍ */
	for (i = 0; i < NUM_CHRCLASS; i++)
	{
		unsigned char buf[SIZEOF_CHRLVUP];

		file_read_sfc(buf, FILEPOS_CHRLVUP + SIZEOF_CHRLVUP * i, SIZEOF_CHRLVUP);

		/* Kvolf[^ */
		for (j = 0; j < NUM_CHRLV; j++)
		{
			buf_chrlvup[i].level[j].experience_point = (j == 0) ? 0 :
				(buf[SIZEOF_CHREX * (j - 1) + 17] << 16) | (buf[SIZEOF_CHREX * (j - 1) + 16] << 8) | buf[SIZEOF_CHREX * (j - 1) + 15];
		}

		/*  */
		for (j = 0; j < NUM_CHRLV; j++)
		{
			buf_chrlvup[i].level[j].hit_point    = 0;
			buf_chrlvup[i].level[j].magic_power  = 0;
			buf_chrlvup[i].level[j].strength     = 0;
			buf_chrlvup[i].level[j].agility      = 0;
			buf_chrlvup[i].level[j].stamina      = 0;
			buf_chrlvup[i].level[j].intelligence = 0;
			buf_chrlvup[i].level[j].luck         = 0;
		}
	}

	return buf_chrlvup;
}

int chr_writelvup(const char *ptr_filename, const chrlvup_t *ptr_chrlvup)
{
	int i, j;
	FILE *fp = NULL;

	/* `FbN */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_chrlvup == NULL)
	{
		assert(0);
		return 0;
	}

	/* LN^f[^o͂t@CJ */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* LN^f[^o͂ */
	for (i = 0; i < NUM_CHRCLASS; i++)
	{
		if (i != 0)
			fputc('\n', fp);

		fprintf(fp, "[No.%03d(%02X): %s]\n", i, i,
				chr_getclassname(i));

		/* f[^ */
		fprintf(fp, "LV  őHP őMP "
					"              ^    ol\n");
		for (j = 0; j < NUM_CHRLV; j++)
		{
			fprintf(fp, "%2d:  %5d, %5d, %3d, %3d, %3d, %3d, %3d, %8ld\n", j + 1,
					ptr_chrlvup[i].level[j].hit_point,
					ptr_chrlvup[i].level[j].magic_power,
					ptr_chrlvup[i].level[j].strength,
					ptr_chrlvup[i].level[j].agility,
					ptr_chrlvup[i].level[j].stamina,
					ptr_chrlvup[i].level[j].intelligence,
					ptr_chrlvup[i].level[j].luck,
					ptr_chrlvup[i].level[j].experience_point);
		}
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
