/*
 *	dq3define.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq3decode.h"
#include "dq3define.h"

#define FILEPOS_STRING	0x3ecfb7
#define NUM_STRING		958

#define STR_FLAG_TRUE	""
#define STR_FLAG_FALSE	"~"

static void str_setdef(void);

static char tbl_string[NUM_STRING][256];	/* Q[Ŏgp镶̃e[u */
static int flag_setstring = 0;				/* tbl_stringɃf[^i[Ă邩ǂ */

const char *str_getflag(int flag)
{
	return (flag != 0x00) ? STR_FLAG_TRUE : STR_FLAG_FALSE;
}

const char *str_getdef(int index)
{
	/* `FbN */
	if (index < 0 || NUM_STRING <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_setstring)
		str_setdef();

	return tbl_string[index];
}

static void str_setdef(void)
{
	int i;
	long filepos;

	/* Q[Ŏgp镶f[^ */
	for (i = 0; i < NUM_STRING; i++)
		*tbl_string[i] = '\0';

	/* Q[Ŏgp镶f[^ǂݍ */
	filepos = FILEPOS_STRING;
	for (i = 0; i < NUM_STRING; i++)
	{
		unsigned char buf[256];
		unsigned char *ptr_buf = buf;
		size_t srcsize;

		for (;;)
		{
			unsigned char byte;

			filepos += file_read_sfc(&byte, filepos, 1);
			if (byte == 0xac || (size_t)(ptr_buf - buf) >= sizeof(buf))
				break;

			*ptr_buf++ = byte;
		}

		srcsize = (size_t)(ptr_buf - buf);
		if (srcsize > 0)
			dec_string(tbl_string[i], buf, sizeof(tbl_string[i]), srcsize, 0);
	}

	flag_setstring = 1;
}
