/*
 *	dq3item.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq3define.h"
#include "dq3item.h"

#define FILEPOS_ITEMDATA	0x040043
#define NUM_ITEM			229
#define SIZEOF_ITEMDATA		19

static void item_setnameindex(void);

static int tbl_itemnameindex[NUM_ITEM];	/* \̃CfbNXi[e[u */
static int flag_itemnameindex = 0;		/* tbl_itemnameindexɃf[^i[Ă邩ǂ */

const char *item_getname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_ITEM <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_itemnameindex)
		item_setnameindex();

	return str_getdef(tbl_itemnameindex[index]);
}

static void item_setnameindex(void)
{
	int i;

	/* ̖Of[^ǂݍ */
	for (i = 0; i < NUM_ITEM; i++)
	{
		unsigned char buf[SIZEOF_ITEMDATA];

		file_read_sfc(buf, FILEPOS_ITEMDATA + SIZEOF_ITEMDATA * i, SIZEOF_ITEMDATA);
		tbl_itemnameindex[i] = (buf[ 1] << 8) | buf[ 0];
	}

	flag_itemnameindex = 1;
}

itemdata_t *item_readdata(void)
{
	int i;
	itemdata_t *buf_itemdata = NULL;

	/* ̊ef[^i[obt@mۂ */
	if ((buf_itemdata = malloc(sizeof(itemdata_t) * NUM_ITEM)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ̊ef[^ǂݍ */
	for (i = 0; i < NUM_ITEM; i++)
	{
		unsigned char buf[SIZEOF_ITEMDATA];

		file_read_sfc(buf, FILEPOS_ITEMDATA + SIZEOF_ITEMDATA * i, SIZEOF_ITEMDATA);

		/* lnf[^ */
		buf_itemdata[i].name_index     = (buf[ 1] << 8) | buf[ 0];
		buf_itemdata[i].price          = (buf[12] << 16) | (buf[11] << 8) | buf[10];
		buf_itemdata[i].increase_value = (buf[ 5] << 8) | buf[ 4];
		buf_itemdata[i].increase_param = buf[ 3];
		buf_itemdata[i].personality    = buf[18];

		/* tOnf[^ */
		buf_itemdata[i].bits_equip_class = ((buf[ 7] & 0x01) << 8) | buf[ 6];
		buf_itemdata[i].equip_gender     = (buf[ 7] & 0xc0) >> 6;
	}

	return buf_itemdata;
}

int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata)
{
	int i;
	FILE *fp = NULL;

	/* `FbN */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_itemdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ̐lnf[^o͂t@CJ */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ̐lnf[^o͂ */
	fprintf(fp, "No.      O                 "
				"  i U  f   ̗        ^\n");
	for (i = 0; i < NUM_ITEM; i++)
	{
		fprintf(fp, "%03d(%02X): %-18s : %6ld, %5d, %5d, %5d, %5d, %5d, %5d\n", i, i,
				item_getname(i),
				ptr_itemdata[i].price,
				(ptr_itemdata[i].increase_param == 0x01) ? ptr_itemdata[i].increase_value : 0,
				(ptr_itemdata[i].increase_param == 0x03) ? ptr_itemdata[i].increase_value : 0,
				(ptr_itemdata[i].increase_param == 0x02) ? ptr_itemdata[i].increase_value : 0,
				(ptr_itemdata[i].increase_param == 0x06) ? ptr_itemdata[i].increase_value : 0,
				(ptr_itemdata[i].increase_param == 0x04) ? ptr_itemdata[i].increase_value : 0,
				(ptr_itemdata[i].increase_param == 0x05) ? ptr_itemdata[i].increase_value : 0);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
