/*
 *	dq3monster.h
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(DQ3MONSTER_H)
#define DQ3MONSTER_H

typedef struct mondata_tag
{
	int name_index;			/* X^[\̃CfbNX */
	int level;				/* X^[x */
	int hit_point;			/* qbg|Cg */
	int magic_power;		/* }WbNp[ */
	long experience_point;	/* lol */
	int gold;				/* S[h */
	int attack_power;		/* U */
	int defense_power;		/* h */
	int agility;			/* f */

	int regist_fire;		/* EMECInȆϐ  */
	int regist_ice;			/* qhn̑ϐ */
	int regist_infernos;	/* oMn̑ϐ */
	int regist_lightning;	/* fCn̑ϐ */
	int regist_defeat;		/* ULn̑ϐ */
	int regist_sacrifice;	/* Kȇϐ */
	int regist_sleep;		/* z[̑ϐ */
	int regist_stopspell;	/* }zg[̑ϐ */
	int regist_defense;		/* Jin̑ϐ */
	int regist_surround;	/* }k[T̑ϐ */
	int regist_robmagic;	/* }zg̑ϐ */
	int regist_chaos;		/* _pj̑ϐ */
	int regist_slow;		/* {~IX̑ϐ */
	int regist_expell;		/* jt̑ϐ */

	int flag_type_dragon;	/* hSnł邩ǂ */
	int flag_type_zombie;	/* Afbhnł邩ǂ */
	int flag_intensive;		/* WUsǂ */

	int item_no;			/* 󔠂̓̔ԍ */
	int item_get;			/* 󔠓̓Փx */
	int evade_rate;			/*  */
	int auto_healing;		/* R */
	int repeatedly_action;	/* s */
	int action_type;		/* s̃[e[V^Cv */
	int judgment;			/* f */

	int action[8];			/* sp^[ */
} mondata_t;

typedef struct monenc_tag
{
	int level;				/* X^[p[eBx */
	struct
	{
		int monster_no;		/* oX^[ */
	} mon[12];
} monenc_t;

typedef struct monmap_tag
{
	int area[16][16];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeregist(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);

#endif /* DQ3MONSTER_H */
