/*
 *	dq3spell.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq3define.h"
#include "dq3spell.h"

#define FILEPOS_SPELLDATA	0x021860
#define FILEPOS_SPELLRANGE	0x023b44
#define NUM_SPELL			274
#define NUM_SPELLRANGE		50
#define SIZEOF_SPELLDATA	29
#define SIZEOF_SPELLRANGE	5

static void spell_setnameindex(void);

static int tbl_spellnameindex[NUM_SPELL];	/* \̃CfbNXi[e[u */
static int flag_spellnameindex = 0;			/* tbl_spellnameindexɃf[^i[Ă邩ǂ */

const char *spell_getname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_spellnameindex)
		spell_setnameindex();

	return str_getdef(tbl_spellnameindex[index]);
}

static void spell_setnameindex(void)
{
	int i;

	/* ̃CfbNXǂݍ */
	for (i = 0; i < NUM_SPELL; i++)
	{
		unsigned char buf[SIZEOF_SPELLDATA];

		file_read_sfc(buf, FILEPOS_SPELLDATA + SIZEOF_SPELLDATA * i, SIZEOF_SPELLDATA);
		tbl_spellnameindex[i] = (buf[ 1] << 8) | buf[ 0];
	}

	flag_spellnameindex = 1;
}

const char *spell_getdesc(int index)
{
	static const char *str_desc[/* NUM_SPELL */] =
	{
		/* 000 */	"",
		/* 001 */	"U",
		/* 002 */	"ɍ̈ꌂ",
		/* 003 */	"U",
		/* 004 */	"ōU",
		/* 005 */	"}qU",
		/* 006 */	"",
		/* 007 */	"",
		/* 008 */	"",
		/* 009 */	"",
		/* 00a */	"",
		/* 00b */	"",
		/* 00c */	"",
		/* 00d */	"",
		/* 00e */	"",
		/* 00f */	"",
		/* 010 */	"",
		/* 011 */	"",
		/* 012 */	"",
		/* 013 */	"",
		/* 014 */	"",
		/* 015 */	"",
		/* 016 */	"",
		/* 017 */	"",
		/* 018 */	"",
		/* 019 */	"",
		/* 01a */	"",
		/* 01b */	"",
		/* 01c */	"",
		/* 01d */	"",
		/* 01e */	"",
		/* 01f */	"",
		/* 020 */	"",
		/* 021 */	"",
		/* 022 */	"",
		/* 023 */	"",
		/* 024 */	"",
		/* 025 */	"",
		/* 026 */	"",
		/* 027 */	"",
		/* 028 */	"",
		/* 029 */	"",
		/* 02a */	"",
		/* 02b */	"",
		/* 02c */	"",
		/* 02d */	"",
		/* 02e */	"",
		/* 02f */	"",
		/* 030 */	"",
		/* 031 */	"",
		/* 032 */	"",
		/* 033 */	"",
		/* 034 */	"",
		/* 035 */	"",
		/* 036 */	"",
		/* 037 */	"",
		/* 038 */	"",
		/* 039 */	"",
		/* 03a */	"",
		/* 03b */	"",
		/* 03c */	"",
		/* 03d */	"",
		/* 03e */	"",
		/* 03f */	"",
		/* 040 */	"",
		/* 041 */	"",
		/* 042 */	"",
		/* 043 */	"",
		/* 044 */	"",
		/* 045 */	"",
		/* 046 */	"",
		/* 047 */	"",
		/* 048 */	"",
		/* 049 */	"GS",
		/* 04a */	" Ƃ܂!",
		/* 04b */	" ݂ ꂽ!",
		/* 04c */	"ƂĂȂ 낵̂ тĂ܂!",
		/* 04d */	"X^[ т肵!",
		/* 04e */	"GS",
		/* 04f */	"GSӂU",
		/* 050 */	"S̍US̈ꌂɂȂ",
		/* 051 */	"SԂ",
		/* 052 */	"GSĂ",
		/* 053 */	"GS̃}WbNp[ׂĒD",
		/* 054 */	"Ȃт !",
		/* 055 */	"܂тƂȂ  Ђт킽!",
		/* 056 */	"S̃qbg|Cg񕜂 & Ԃ",
		/* 057 */	"Ђ̂",
		/* 058 */	"̂",
		/* 059 */	"͂ق̂",
		/* 05a */	"߂",
		/* 05b */	"",
		/* 05c */	"ӂԂ",
		/* 05d */	"ǂ̂",
		/* 05e */	"܂",
		/* 05f */	"₯",
		/* 060 */	"ԂĂ()",
		/* 061 */	"ԂĂ(zC~XC)",
		/* 062 */	"ԂĂ(܂)",
		/* 063 */	"ԂĂ()",
		/* 064 */	"ԂĂ(炭傤)",
		/* 065 */	"ԂĂ(]r}X^[)",
		/* 066 */	"ӂȂǂ",
		/* 067 */	"Ă͂ǂ",
		/* 068 */	"h",
		/* 069 */	"悤 ݂ĂB",
		/* 06a */	"",
		/* 06b */	"() !  Ȃɂ Ȃ!",
		/* 06c */	"",
		/* 06d */	"",
		/* 06e */	"",
		/* 06f */	"",
		/* 070 */	"",
		/* 071 */	"",
		/* 072 */	"",
		/* 073 */	"",
		/* 074 */	"",
		/* 075 */	"",
		/* 076 */	"",
		/* 077 */	"",
		/* 078 */	"",
		/* 079 */	"",
		/* 07a */	"",
		/* 07b */	"",
		/* 07c */	"",
		/* 07d */	"",
		/* 07e */	"",
		/* 07f */	"",
		/* 080 */	"",
		/* 081 */	"",
		/* 082 */	"",
		/* 083 */	"",
		/* 084 */	"",
		/* 085 */	"",
		/* 086 */	"",
		/* 087 */	"",
		/* 088 */	"",
		/* 089 */	"",
		/* 08a */	"",
		/* 08b */	"",
		/* 08c */	"",
		/* 08d */	"",
		/* 08e */	"",
		/* 08f */	"",
		/* 090 */	"",
		/* 091 */	"",
		/* 092 */	"",
		/* 093 */	"",
		/* 094 */	"",
		/* 095 */	"",
		/* 096 */	"",
		/* 097 */	"",
		/* 098 */	"",
		/* 099 */	"",
		/* 09a */	"",
		/* 09b */	"",
		/* 09c */	"",
		/* 09d */	"",
		/* 09e */	"",
		/* 09f */	"",
		/* 0a0 */	"",
		/* 0a1 */	"",
		/* 0a2 */	"",
		/* 0a3 */	"",
		/* 0a4 */	"",
		/* 0a5 */	"",
		/* 0a6 */	"΃][}",
		/* 0a7 */	"΃][}",
		/* 0a8 */	"΃][}",
		/* 0a9 */	"΃][}",
		/* 0aa */	"",
		/* 0ab */	"",
		/* 0ac */	"",
		/* 0ad */	"",
		/* 0ae */	"",
		/* 0af */	"",
		/* 0b0 */	"",
		/* 0b1 */	"",
		/* 0b2 */	"Ƃ  Ԃ ݂ ܂Ă!",
		/* 0b3 */	"Ȃɂ  Ƃ肠 悤 ݂Ă!",
		/* 0b4 */	"Ȃ܂ !   тȂ܂ ܂ł Ȃ!",
		/* 0b5 */	"Ȃ ɂ!  ܂肱܂Ă܂!",
		/* 0b6 */	"ӂ悤Ƃ ł܂!",
		/* 0b7 */	"ɂ ققł!",
		/* 0b8 */	"Ƃ ̂΂ ꂱ! Ȃ ˂ Ă͂߂!",
		/* 0b9 */	"̂ւ Ă  Ђ Ă܂ ͂߂B",
		/* 0ba */	"悤  ǂĂ!",
		/* 0bb */	"悭 񂩂!",
		/* 0bc */	"݂ꂽ ݂ !",
		/* 0bd */	"̃Y 킹 ^bv_X ͂߂!",
		/* 0be */	"߂̂܂ т NN ܂킵!",
		/* 0bf */	"Ȃ !",
		/* 0c0 */	"݂ Ƃ肾 ̂т 傤Ȃ ĂB",
		/* 0c1 */	"Ƃ ̂΂ ꂱ! Ȃ ˂ Ă͂߂! Ȃ΂ 悤!",
		/* 0c2 */	"ł߂  ƂȂĂ݂!",
		/* 0c3 */	"Ă ̂!  ܂ ǂł Ȃ!",
		/* 0c4 */	"܂ ӂ 񂪂 悬B Ȃɂ ԂԂ Ă!",
		/* 0c5 */	"낢  !",
		/* 0c6 */	"ނ TCR ӂ!",
		/* 0c7 */	" ! (   Ђт! / Ђǂ!)",
		/* 0c8 */	" ! (Ђǂ!)",
		/* 0c9 */	"Gb`ȂƂ ׂ!",
		/* 0ca */	"Ƃ  ݂ !",
		/* 0cb */	"Ȃɂ  Ƃ Ƃ ͂߂!",
		/* 0cc */	"` Ȃ߂ !",
		/* 0cd */	"ނ 킢͂Ȃ ͂߂B",
		/* 0ce */	"ǂ炩 Ƃ肾 Ԃ!",
		/* 0cf */	"` nCq[Ƃ肾 储܂ ǂ!",
		/* 0d0 */	"  ̂т Ă ߂!",
		/* 0d1 */	"Ƃ 悤 炢!",
		/* 0d2 */	"݂Ȃ ͂܂!(͂܂ ݂Ȃ 邫 ӂꂠ!)",
		/* 0d3 */	"݂Ȃ ͂܂!(͂܂ ݂Ȃ 邫 ΂Ă܂!)",
		/* 0d4 */	"Ă   ݂̂ق!",
		/* 0d5 */	"т 邮 ͂Ȃ!(肭! /  ӂ LY!)",
		/* 0d6 */	"т 邮 ͂Ȃ!( ӂ LY!)",
		/* 0d7 */	"񂵂̂ ߂ Ȃ ܂ Ȃ!",
		/* 0d8 */	"ςӂςӂ ĂB   邢!",
		/* 0d9 */	"ςӂςӂ ĂB  悳!",
		/* 0da */	"  Ђ킴 ͂Ȃ!",
		/* 0db */	" Ȃт ͂߂!",
		/* 0dc */	"Ă ݂ Ђ т͂߂!",
		/* 0dd */	"Ƃ ₳ ꂽ! ̂ ݂Ȃ Ă!",
		/* 0de */	"",
		/* 0df */	"",
		/* 0e0 */	"",
		/* 0e1 */	"",
		/* 0e2 */	"",
		/* 0e3 */	"",
		/* 0e4 */	"",
		/* 0e5 */	"",
		/* 0e6 */	"",
		/* 0e7 */	"",
		/* 0e8 */	"",
		/* 0e9 */	"",
		/* 0ea */	"",
		/* 0eb */	"",
		/* 0ec */	"",
		/* 0ed */	"",
		/* 0ee */	"",
		/* 0ef */	"",
		/* 0f0 */	"",
		/* 0f1 */	"",
		/* 0f2 */	"",
		/* 0f3 */	"",
		/* 0f4 */	"",
		/* 0f5 */	"",
		/* 0f6 */	"",
		/* 0f7 */	"",
		/* 0f8 */	"",
		/* 0f9 */	"",
		/* 0fa */	"",
		/* 0fb */	"",
		/* 0fc */	"",
		/* 0fd */	"",
		/* 0fe */	"",
		/* 0ff */	"",
		/* 100 */	"",
		/* 101 */	"",
		/* 102 */	"",
		/* 103 */	"",
		/* 104 */	"",
		/* 105 */	"",
		/* 106 */	"",
		/* 107 */	"",
		/* 108 */	"",
		/* 109 */	"",
		/* 10a */	"",
		/* 10b */	"",
		/* 10c */	"",
		/* 10d */	"Ⴍ˂",
		/* 10e */	"ɂ݂!",
		/* 10f */	"ǂLo ݂!",
		/* 110 */	" ̂Ă!",
		/* 111 */	"",
	};

	assert(sizeof(str_desc) / sizeof(str_desc[0]) == NUM_SPELL);

	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	return str_desc[index];
}

spelldata_t *spell_readdata(void)
{
	int i;
	spelldata_t *buf_spelldata = NULL;
	struct range_tag
	{
		int range_min_enemy;	/* Gɗ^_[W̍ŏl */
		int range_max_enemy;	/* Gɗ^_[W̍ől */
		int range_min_party;	/* 󂯂_[W̍ŏl */
		int range_max_party;	/* 󂯂_[W̍ől */
	};
	struct range_tag tbl_range[NUM_SPELLRANGE];

	/* ̊ef[^i[obt@mۂ */
	if ((buf_spelldata = malloc(sizeof(spelldata_t) * NUM_SPELL)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ̃_[W͈̓f[^ǂݍ */
	for (i = 0; i < NUM_SPELLRANGE; i++)
	{
		unsigned char buf[SIZEOF_SPELLRANGE];

		file_read_sfc(buf, FILEPOS_SPELLRANGE + SIZEOF_SPELLRANGE * i, SIZEOF_SPELLRANGE);

		tbl_range[i].range_min_enemy = ((buf[1] & 0x03) << 8) | buf[0];
		tbl_range[i].range_min_party = ((buf[2] & 0x0f) << 6) | ((buf[1] & 0xfc) >> 2);
		tbl_range[i].range_max_enemy = ((buf[3] & 0x3f) << 4) | ((buf[2] & 0xf0) >> 4);
		tbl_range[i].range_max_party = (buf[4] << 2) | ((buf[3] & 0xc0) >> 6);
	}

	/* ̊ef[^ǂݍ */
	for (i = 0; i < NUM_SPELL; i++)
	{
		unsigned char buf[SIZEOF_SPELLDATA];

		file_read_sfc(buf, FILEPOS_SPELLDATA + SIZEOF_SPELLDATA * i, SIZEOF_SPELLDATA);

		/* lnf[^ */
		buf_spelldata[i].name_index      = (buf[ 1] << 8) | buf[ 0];
		buf_spelldata[i].magic_power     = (buf[21] & 0xfc) >> 2;
		buf_spelldata[i].range_min_enemy = tbl_range[buf[18]].range_min_enemy;
		buf_spelldata[i].range_max_enemy = tbl_range[buf[18]].range_max_enemy;
		buf_spelldata[i].range_min_party = tbl_range[buf[18]].range_min_party;
		buf_spelldata[i].range_max_party = tbl_range[buf[18]].range_max_party;
	}

	return buf_spelldata;
}

int spell_writeparam(const char *ptr_filename, const spelldata_t *ptr_spelldata)
{
	int i;
	FILE *fp = NULL;

	/* `FbN */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spelldata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ̐lnf[^o͂t@CJ */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ̐lnf[^o͂ */
	fprintf(fp, "No.       O                 "
				"MP Gŏ Gő ŏ ő\n");
	for (i = 0; i < NUM_SPELL; i++)
	{
		fprintf(fp, "%03d(%03X): %-18s :  %5d, %5d, %5d, %5d, %5d\n", i, i,
				spell_getname(i),
				ptr_spelldata[i].magic_power,
				ptr_spelldata[i].range_min_enemy,
				ptr_spelldata[i].range_max_enemy,
				ptr_spelldata[i].range_min_party,
				ptr_spelldata[i].range_max_party);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
