/*
 *	dq5decode.c
 *		Copyright (C)2001-2004 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "dq5decode.h"

/* hSNGXgV̕R[h\(VXep) */
static const char *tbl_charcode[] =
{
	" ",  " ",  "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "H",  "M",  "P",  "G",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z",
	"\", "^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z",
	"}", "~", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"b", "", "", "", "@", "B", "F", "H", "[", "?",  "!",  "", "", "", "", "",
	"", "", "/",  "K", "J", ":",  "Ex", "Lv", "\", "*",  "E",  "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
};

static const char *tbl_dakuten[] =
{
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", NULL, NULL, NULL, NULL, NULL, "", "", "", "", "", NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, "", NULL, NULL, "K", "M", "O", "Q", "S", "U", "W", "Y", "[",
	"]", "_", "a", "d", "f", "h", NULL, NULL, NULL, NULL, NULL, "o", "r", "u", "x", "{",
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
};

static const char *tbl_handakuten[] =
{
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "", "", "", "", "", NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "p", "s", "v", "y", "|",
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
};

/* hSNGXgV̕R[h\(bZ[Wp) */
static const char *tbl_charcode_mes[] =
{
	/* 0x00 */
	"", "", "n", "", "", "", "", "C", "", "S", "s", "", "", "", "", "@",
	"", "", "", "", "", "D", "J", "K", "", "K", "O", "T", "l", "s", "z", "",
	"", "Z", "", "", "", "", "A", "L", "N", "", "", "", "", "", "", "",
	"", "", "", "", "", "R", "", "", "", "", "", "d", "m", "v", "w", "~",
	"", "", "", "", "", "S", "}", "V", "c", "", "v", "", "", "", "", "",
	"", "e", "h", "i", "p", "", "", "", "", "", "h", "j", "s", "t", "w", "z",
	"{", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "K", "P",
	"S", "X", "\", "]", "`", "a", "i", "n", "", "", "", "", "", "", "", "",
	"", "@", "K", "L", "V", "Y", "[", "]", "h", "k", "{", "t", "v", "w", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "C", "E", "F", "G", "O",
	"i", "m", "o", "w", "y", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "Y", "`", "b", "h", "i", "n", "o", "p", "v", "y", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",

	/* 0x01 */
	"", "", "", "", "", "@", "C", "F", "G", "M", "V", "Z", "]", "c", "q", "v",
	"x", "}", "~", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "D", "K", "L", "R", "U", "`", "l", "q", "r", "s", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "N", "P",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "M", "N", "O", "", "C", "F",
	"Y", "\", "_", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "A", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "H", "J", "S", "V", "^", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "E", "Q", "U", "Y", "c", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "D", "I", "O", "P", "R", "S", "g", "j", "n", "o", "p",
	"q", "u", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "C", "E", "I", "K", "M", "W", "Z", "\", "d", "h", "j",

	/* 0x02 */
	"o", "t", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "F", "H", "M", "Q", "V", "X", "[", "^", "_", "e", "g", "i", "c", "f",
	"m", "q", "`", "{", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "N",
	"P", "T", "a", "c", "f", "i", "j", "k", "", "", "", "", "", "G", "I", "S",
	"X", "_", "`", "a", "l", "m", "n", "u", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "n", "r", "s", "x",
	"y", "z", "|", "~", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "E", "^",
	"_", "a", "b", "f", "r", "", "", "", "", "", "\", "]", "^", "a", "c", "d",
	"l", "n", "p", "r", "t", "x", "{", "~", "", "E", "F", "L", "R", "T", "V", "Y",
	"[", "0",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "$",  "g", "", "1",  "A",  "H",
	"K",  "Q",  "T",  "V",  "h",  "", "", "", "", "", "", "", "", "", "", "",
	"m", "q", "", "", "B",  "E",  "F",  "L",  "O",  "P",  "S",  "b",  "d",  "", "", "",

	/* 0x03 */
	"", "", "", "", "", "~", "", "C",  "D",  "G",  "*",  "", "M",  "W",  "X",  "Y",
	"+",  "", "", "", "", "", "", "", "", "", "", "", "Z", "", "", "",
	"", "", "", "M", "", "", "U",  "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "A", "V", "c", "e", "", "", "a",  "o",  "", "", "",
	"@", "c",  "e",  "i",  "l",  "j",  "g", "h", "m",  "n",  "u",  "p",  "", "r",  "s",  "t",
	"X", "V",  "", "W",  "", "G", "B", ",",  ".",  "?",  "!",  "", "@",  "E", "J", "^",
	"[", "{",  "}",  "u", "-",  "", "c", "<",  ">",  "%",  "", "", "I", "L", "P", "`",
	"i", "", "", "", "", "b", "l", "&",  "C", "N", "^", "h", "", "", "", "`",
	"", "", "", "", "", "@", "", "", "", "t", "", "n", "", "", "", "",
	"C", "", "", "\", "", "H", "b", "", "", "", "n", "", "", "", "", "",
	"", "M", "Q", "S", "U", "Y", "]", "_", "a", "d", "o", "p", "r", "u", "v", "x",
	"{", "|", "", "", "", "", "", "", "", "", "", "", "", "W", "[", "f",
	"", "", "", "", "}", "", "", "", "R", "X", "\", "k", "t", "", "", "B",
	"", "", "F", "j", "", "w", "y", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
};

/* nt}f[^pe[u */
struct hufftbl_t
{
	int flag_term;	/* I[tO */
	int value;		/* R[h(I[) / ̃CfbNXl(p) */
};

/* nt}f[^pe[u(rbgON) */
static const struct hufftbl_t tbl_decode_on[] =
{
	{1, 0x0204},	/*  */
	{1, 0x0108},	/* G */
	{1, 0x010a},	/* V */
	{1, 0x0042},	/*  */
	{1, 0x010c},	/* ] */
	{1, 0x0089},	/*  */
	{1, 0x0231},	/* q */
	{1, 0x0119},	/*  */
	{1, 0x0235},	/*  */
	{1, 0x023c},	/*  */
	{1, 0x0048},	/* c */
	{1, 0x0024},	/*  */
	{1, 0x012b},	/*  */
	{1, 0x025e},	/*  */
	{1, 0x0264},	/* f */
	{1, 0x0271},	/* _ */
	{1, 0x013c},	/* r */
	{1, 0x009f},	/*  */
	{1, 0x0141},	/*  */
	{1, 0x0289},	/*  */
	{1, 0x028b},	/*  */
	{1, 0x0051},	/* e */
	{1, 0x0294},	/*  */
	{1, 0x014b},	/*  */
	{1, 0x029d},	/*  */
	{1, 0x02a4},	/*  */
	{1, 0x02ae},	/* E */
	{1, 0x0055},	/*  */
	{1, 0x0159},	/*  */
	{1, 0x0056},	/*  */
	{1, 0x02c3},	/* r */
	{1, 0x0058},	/*  */
	{1, 0x02cd},	/* T */
	{1, 0x0168},	/*  */
	{1, 0x02de},	/* A */
	{1, 0x005c},	/* s */
	{1, 0x005d},	/* t */
	{1, 0x02f4},	/* B */
	{1, 0x0307},	/* C */
	{1, 0x0181},	/*  */
	{1, 0x0188},	/*  */
	{1, 0x00c7},	/*  */
	{1, 0x0193},	/* H */
	{1, 0x019d},	/*  */
	{1, 0x01a0},	/*  */
	{1, 0x00d1},	/* m */
	{1, 0x0374},	/*  */
	{1, 0x00d5},	/*  */
	{1, 0x01ae},	/*  */
	{1, 0x01b0},	/*  */
	{1, 0x0395},	/* H */
	{1, 0x0006},	/*  */
	{1, 0x0037},	/*  */
	{1, 0x03a8},	/* a */
	{1, 0x01c0},	/*  */
	{1, 0x01c4},	/*  */
	{1, 0x00e7},	/* b */
	{1, 0x0074},	/*  */
	{1, 0x01d3},	/*  */
	{1, 0x03d7},	/*  */
	{1, 0x00ec},	/* p */
	{1, 0x00ee},	/* y */
	{1, 0x100f},
	{1, 0x1103},
	{1, 0x1106},
	{1, 0x110b},
	{1, 0x00f6},	/*  */
	{1, 0x007b},	/*  */
	{1, 0x01f4},	/*  */
	{1, 0x01f9},	/* M */
	{0,     38},
	{1, 0x0102},	/*  */
	{1, 0x0105},	/* @ */
	{1, 0x0001},	/*  */
	{1, 0x0084},	/* ` */
	{0,      0},
	{0,      7},
	{1, 0x0221},	/*  */
	{0,      3},
	{0,      4},
	{0,      6},
	{0,     15},
	{0,      8},
	{1, 0x0123},	/*  */
	{1, 0x0124},	/*  */
	{0,     10},
	{1, 0x012e},	/*  */
	{1, 0x012f},	/*  */
	{1, 0x0136},	/* L */
	{1, 0x026f},	/* S */
	{0,     22},
	{1, 0x027f},	/*  */
	{1, 0x0283},	/*  */
	{0,     16},
	{1, 0x0147},	/*  */
	{1, 0x0292},	/* | */
	{1, 0x029a},	/*  */
	{0,     20},
	{0,     27},
	{1, 0x0151},	/*  */
	{1, 0x0054},	/* p */
	{0,     24},
	{0,     26},
	{1, 0x02be},	/* c */
	{0,     32},
	{1, 0x02c5},	/* x */
	{0,     29},
	{0,     30},
	{0,     31},
	{1, 0x02d7},	/* 7 */
	{1, 0x00b6},	/*  */
	{0,     33},
	{1, 0x02e3},	/* V */
	{0,     36},
	{1, 0x02f7},	/* L */
	{0,     42},
	{1, 0x0005},	/*  */
	{1, 0x0324},	/*  */
	{1, 0x0031},	/*  */
	{0,     41},
	{0,     40},
	{0,     46},
	{1, 0x0364},	/* - */
	{0,     43},
	{1, 0x01a7},	/* Q */
	{1, 0x006a},	/*  */
	{1, 0x0383},	/*  */
	{1, 0x03d6},	/* y */
	{1, 0x01b6},	/*  */
	{1, 0x00db},	/*  */
	{1, 0x00dc},	/*  */
	{0,     51},
	{0,     52},
	{1, 0x00e5},	/* Y */
	{1, 0x0073},	/*  */
	{0,     56},
	{1, 0x00ea},	/* n */
	{0,     57},
	{0,     59},
	{1, 0x101d},
	{1, 0x00f2},	/*  */
	{0,     61},
	{0,     62},
	{1, 0x1110},
	{0,     63},
	{1, 0x1117},
	{0,     65},
	{0,     66},
	{1, 0x0206},	/*  */
	{1, 0x0082},	/* \ */
	{1, 0x0109},	/* M */
	{1, 0x0214},	/*  */
	{1, 0x010d},	/* c */
	{1, 0x023a},	/*  */
	{1, 0x00f5},	/*  */
	{1, 0x0092},	/* K */
	{1, 0x012d},	/*  */
	{1, 0x0012},	/*  */
	{1, 0x026b},	/*  */
	{1, 0x009b},	/* t */
	{1, 0x0281},	/*  */
	{1, 0x028e},	/* s */
	{1, 0x0155},	/*  */
	{1, 0x00ac},	/*  */
	{1, 0x015c},	/*  */
	{1, 0x016a},	/* M */
	{1, 0x005e},	/* w */
	{1, 0x0060},	/* { */
	{1, 0x00c9},	/*  */
	{1, 0x0357},	/* , */
	{1, 0x01a5},	/*  */
	{1, 0x038b},	/* n */
	{1, 0x01d6},	/*  */
	{1, 0x039c},	/*  */
	{1, 0x00e0},	/*  */
	{1, 0x1104},
	{1, 0x00fa},	/*  */
	{1, 0x007f},	/* P */
	{1, 0x0104},	/*  */
	{0,     71},
	{0,     73},
	{1, 0x007a},	/*  */
	{0,     74},
	{1, 0x0044},	/*  */
	{1, 0x022d},	/* i */
	{0,     76},
	{0,     78},
	{0,     88},
	{0,     84},
	{0,     81},
	{0,     82},
	{1, 0x0079},	/*  */
	{1, 0x0268},	/*  */
	{0,     87},
	{1, 0x013b},	/* q */
	{0,     90},
	{0,     92},
	{0,     91},
	{1, 0x0297},	/*  */
	{0,     93},
	{1, 0x0053},	/* i */
	{1, 0x0029},	/*  */
	{0,    101},
	{0,     97},
	{1, 0x02b4},	/* r */
	{0,     99},
	{0,    102},
	{1, 0x02cb},	/* L */
	{0,    113},
	{0,    105},
	{0,    110},
	{1, 0x016f},	/* F */
	{1, 0x017b},	/*  */
	{1, 0x017e},	/*  */
	{1, 0x0180},	/*  */
	{1, 0x00c2},	/*  */
	{0,    115},
	{1, 0x0191},	/*  */
	{0,    118},
	{1, 0x0340},	/* @ */
	{0,    117},
	{0,    121},
	{1, 0x00d0},	/* i */
	{0,    120},
	{1, 0x00d3},	/* w */
	{1, 0x0380},	/*  */
	{0,    123},
	{1, 0x0390},	/* C */
	{1, 0x01b5},	/*  */
	{0,    126},
	{0,    146},
	{0,    137},
	{0,    130},
	{0,    132},
	{0,    136},
	{0,    135},
	{1, 0x01e0},	/*  */
	{0,    139},
	{0,    140},
	{0,    145},
	{1, 0x00fb},	/*  */
	{1, 0x021f},	/*  */
	{1, 0x0229},	/* ^ */
	{1, 0x022f},	/* f */
	{1, 0x0246},	/*  */
	{1, 0x0251},	/*  */
	{1, 0x025d},	/*  */
	{1, 0x0277},	/* u */
	{1, 0x0004},	/*  */
	{1, 0x1101},
	{1, 0x029b},	/*  */
	{1, 0x02b6},	/*  */
	{1, 0x02bb},	/* ] */
	{1, 0x0161},	/*  */
	{1, 0x02d4},	/* 4 */
	{1, 0x0309},	/* G */
	{1, 0x0187},	/*  */
	{1, 0x0065},	/*  */
	{1, 0x0032},	/*  */
	{1, 0x0389},	/* t */
	{1, 0x038d},	/*  */
	{1, 0x00dd},	/*  */
	{1, 0x03d4},	/*  */
	{1, 0x01c9},	/* R */
	{1, 0x01d4},	/*  */
	{1, 0x0078},	/*  */
	{1, 0x00fe},	/*  */
	{0,    150},
	{0,    166},
	{0,    149},
	{1, 0x010f},	/* v */
	{1, 0x023b},	/*  */
	{1, 0x023f},	/*  */
	{1, 0x024e},	/*  */
	{1, 0x012a},	/*  */
	{1, 0x00f4},	/*  */
	{0,    157},
	{1, 0x009e},	/* ~ */
	{1, 0x004f},	/*  */
	{1, 0x0142},	/*  */
	{0,    162},
	{1, 0x0154},	/*  */
	{0,    161},
	{0,    165},
	{1, 0x0170},	/* Y */
	{0,    164},
	{1, 0x0183},	/*  */
	{1, 0x018e},	/*  */
	{0,    172},
	{0,    169},
	{0,    171},
	{1, 0x039f},	/*  */
	{0,    173},
	{1, 0x01db},	/*  */
	{1, 0x0201},	/* t */
	{1, 0x0227},	/* X */
	{1, 0x0120},	/*  */
	{1, 0x0265},	/* i */
	{1, 0x0133},	/*  */
	{1, 0x0013},	/*  */
	{1, 0x0052},	/* h */
	{1, 0x02ba},	/* \ */
	{1, 0x030c},	/* M */
	{1, 0x0195},	/* S */
	{1, 0x019f},	/*  */
	{1, 0x0069},	/*  */
	{1, 0x01cd},	/* n */
	{1, 0x01e3},	/*  */
	{0,    179},
	{0,    177},
	{0,    181},
	{0,    193},
	{0,    182},
	{0,    186},
	{1, 0x024d},	/*  */
	{0,    188},
	{0,    187},
	{0,    192},
	{0,    189},
	{1, 0x009d},	/* w */
	{0,    212},
	{0,    194},
	{1, 0x0299},	/*  */
	{0,    195},
	{0,    198},
	{0,    200},
	{0,    201},
	{0,    202},
	{0,    204},
	{1, 0x02d6},	/* 6 */
	{0,    206},
	{0,    211},
	{0,    209},
	{0,    213},
	{0,    219},
	{0,    215},
	{0,    217},
	{1, 0x0372},	/*  */
	{1, 0x038e},	/*  */
	{0,    224},
	{0,    223},
	{0,    225},
	{0,    227},
	{1, 0x03b2},	/*  */
	{0,    229},
	{0,    233},
	{0,    232},
	{0,    236},
	{0,    235},
	{0,    238},
	{1, 0x010b},	/* Z */
	{1, 0x025a},	/*  */
	{1, 0x0097},	/* ] */
	{1, 0x0167},	/*  */
	{1, 0x00b8},	/*  */
	{1, 0x017a},	/*  */
	{1, 0x036a},	/*  */
	{1, 0x03be},	/* [ */
	{1, 0x01fd},	/* d */
	{1, 0x0209},	/*  */
	{0,    241},
	{1, 0x0237},	/*  */
	{0,    242},
	{0,    246},
	{1, 0x004a},	/* v */
	{1, 0x026d},	/* G */
	{0,    254},
	{0,    251},
	{0,    247},
	{0,    250},
	{0,    249},
	{0,    252},
	{1, 0x018c},	/*  */
	{0,    256},
	{0,    255},
	{0,    257},
	{0,    259},
	{0,    261},
	{0,    265},
	{0,    263},
	{1, 0x01f7},	/* I */
	{1, 0x0113},	/*  */
	{1, 0x0284},	/*  */
	{1, 0x02a0},	/*  */
	{1, 0x02d8},	/* 8 */
	{1, 0x1005},
	{1, 0x0202},	/*  */
	{0,    270},
	{1, 0x0085},	/* a */
	{1, 0x02a9},	/*  */
	{0,    269},
	{0,    268},
	{0,    273},
	{0,    276},
	{1, 0x0132},	/*  */
	{0,    274},
	{0,    277},
	{0,    278},
	{0,    279},
	{1, 0x02ca},	/* F */
	{0,    281},
	{0,    283},
	{1, 0x0017},	/* K */
	{0,    286},
	{1, 0x0394},	/*  */
	{0,    293},
	{0,    287},
	{0,    288},
	{1, 0x01da},	/*  */
	{1, 0x01ff},	/* j */
	{0,    294},
	{1, 0x0114},	/*  */
	{1, 0x0091},	/* @ */
	{1, 0x0153},	/*  */
	{1, 0x02cc},	/* R */
	{1, 0x0196},	/* V */
	{1, 0x0371},	/*  */
	{1, 0x01c6},	/* I */
	{1, 0x01e2},	/*  */
	{1, 0x01f1},	/*  */
	{0,    307},
	{0,    301},
	{0,    297},
	{1, 0x026c},	/*  */
	{1, 0x004e},	/*  */
	{1, 0x0028},	/* N */
	{0,    299},
	{0,    302},
	{1, 0x0197},	/* ^ */
	{0,    304},
	{1, 0x01ca},	/* S */
	{1, 0x1007},
	{1, 0x01fa},	/* W */
	{1, 0x0222},	/* F */
	{1, 0x0127},	/*  */
	{1, 0x00a2},	/*  */
	{1, 0x00a7},	/*  */
	{1, 0x0059},	/*  */
	{1, 0x01ac},	/*  */
	{0,    311},
	{1, 0x02aa},	/*  */
	{0,    309},
	{1, 0x0128},	/*  */
	{0,    313},
	{0,    349},
	{0,    315},
	{0,    316},
	{0,    321},
	{0,    319},
	{0,    325},
	{0,    322},
	{0,    324},
	{0,    326},
	{0,    327},
	{0,    330},
	{1, 0x031f},	/*  */
	{0,    334},
	{0,    333},
	{0,    335},
	{1, 0x01a9},	/* Y */
	{0,    338},
	{1, 0x038a},	/*  */
	{0,    339},
	{0,    342},
	{0,    343},
	{0,    346},
	{1, 0x01f5},	/* C */
	{0,    347},
	{1, 0x0095},	/* Y */
	{1, 0x0139},	/* ` */
	{1, 0x002e},	/*  */
	{1, 0x0063},	/*  */
	{1, 0x01ad},	/*  */
	{1, 0x1018},
	{1, 0x020e},	/*  */
	{0,    351},
	{0,    358},
	{1, 0x0098},	/* h */
	{1, 0x01e4},	/*  */
	{1, 0x02d3},	/* 3 */
	{0,    353},
	{1, 0x00c0},	/*  */
	{1, 0x037d},	/*  */
	{1, 0x01ed},	/*  */
	{1, 0x00b1},	/*  */
	{1, 0x0027},	/* L */
	{1, 0x028f},	/* x */
	{1, 0x0169},	/*  */
	{1, 0x03d2},	/* F */
	{0,    371},
	{0,    359},
	{0,    364},
	{0,    363},
	{0,    366},
	{1, 0x0050},	/*  */
	{0,    367},
	{0,    369},
	{0,    375},
	{0,    374},
	{0,    377},
	{1, 0x00d4},	/* y */
	{1, 0x021a},	/*  */
	{1, 0x00ef},	/*  */
	{1, 0x0172},	/* _ */
	{1, 0x0041},	/*  */
	{1, 0x0088},	/*  */
	{0,    382},
	{0,    383},
	{0,    385},
	{1, 0x00e4},	/*  */
	{1, 0x007c},	/*  */
	{0,    386},
	{1, 0x022e},	/* c */
	{1, 0x03a4},	/* U */
	{1, 0x0019},	/* K */
	{1, 0x01aa},	/* c */
	{0,    394},
	{0,    389},
	{0,    388},
	{0,    391},
	{0,    390},
	{0,    392},
	{0,    396},
	{0,    398},
	{0,    399},
	{1, 0x0295},	/*  */
	{0,    402},
	{0,    401},
	{0,    406},
	{0,    404},
	{1, 0x0263},	/* c */
	{1, 0x001d},	/* s */
	{0,    409},
	{1, 0x0286},	/*  */
	{1, 0x037c},	/*  */
	{0,    414},
	{1, 0x0219},	/*  */
	{1, 0x019b},	/*  */
	{1, 0x00a6},	/*  */
	{1, 0x0164},	/*  */
	{0,    419},
	{1, 0x0002},	/* n */
	{1, 0x01b1},	/*  */
	{1, 0x03b8},	/*  */
	{1, 0x01cf},	/* p */
	{0,    417},
	{1, 0x0186},	/*  */
	{1, 0x0107},	/* F */
	{0,    432},
	{0,    423},
	{0,    422},
	{1, 0x0270},	/* X */
	{0,    425},
	{0,    428},
	{0,    431},
	{0,    430},
	{1, 0x020a},	/*  */
	{1, 0x00bc},	/*  */
	{0,    433},
	{0,    436},
	{0,    434},
	{0,    435},
	{0,    437},
	{1, 0x00b9},	/*  */
	{0,    445},
	{0,    442},
	{0,    441},
	{0,    467},
	{0,    443},
	{0,    446},
	{0,    447},
	{0,    451},
	{0,    453},
	{0,    455},
	{0,    456},
	{0,    457},
	{0,    460},
	{0,    466},
	{0,    462},
	{0,    465},
	{1, 0x0148},	/*  */
	{1, 0x00e3},	/*  */
	{1, 0x01fb},	/* Z */
	{0,    468},
	{0,    469},
	{0,    473},
	{0,    471},
	{1, 0x0224},	/* M */
	{1, 0x0126},	/*  */
	{1, 0x0157},	/*  */
	{0,    480},
	{0,    475},
	{0,    477},
	{1, 0x0347},	/* h */
	{1, 0x01c2},	/*  */
	{0,    483},
	{1, 0x005f},	/* z */
	{1, 0x0035},	/* R */
	{0,    486},
	{1, 0x0011},	/*  */
	{1, 0x02a5},	/*  */
	{1, 0x00b0},	/*  */
	{1, 0x01b9},	/*  */
	{1, 0x1004},
	{1, 0x01f2},	/*  */
	{1, 0x0023},	/*  */
	{1, 0x0189},	/*  */
	{1, 0x020f},	/*  */
	{0,    489},
	{0,    492},
	{0,    493},
	{0,    497},
	{0,    496},
	{0,    498},
	{1, 0x0346},	/* g */
	{1, 0x0250},	/*  */
	{1, 0x039b},	/*  */
	{1, 0x013a},	/* l */
	{1, 0x0130},	/*  */
	{0,    503},
	{1, 0x0040},	/*  */
	{1, 0x0388},	/*  */
	{0,    505},
	{1, 0x024b},	/*  */
	{0,    507},
	{0,    508},
	{1, 0x008d},	/*  */
	{1, 0x0234},	/*  */
	{1, 0x01bf},	/*  */
	{0,    513},
	{1, 0x036e},	/* P */
	{0,    512},
	{1, 0x038f},	/*  */
	{1, 0x01f0},	/*  */
	{1, 0x01c5},	/* D */
	{1, 0x001f},	/*  */
	{0,    518},
	{0,    519},
	{0,    524},
	{0,    523},
	{0,    525},
	{1, 0x0338},	/* e */
	{0,    527},
	{0,    529},
	{0,    531},
	{1, 0x0184},	/* A */
	{1, 0x015e},	/*  */
	{1, 0x02b1},	/* a */
	{1, 0x003a},	/*  */
	{0,    533},
	{1, 0x0355},	/* G */
	{1, 0x1019},
	{1, 0x1011},
	{0,    535},
	{0,    545},
	{0,    537},
	{0,    541},
	{0,    542},
	{1, 0x006f},	/*  */
	{1, 0x0003},	/*  */
	{0,    547},
	{0,    548},
	{1, 0x0173},	/*  */
	{0,    549},
	{0,    550},
	{0,    555},
	{0,    553},
	{1, 0x02a6},	/*  */
	{1, 0x02f1},	/* q */
	{0,    557},
	{0,    558},
	{1, 0x100a},
	{1, 0x01cb},	/* g */
	{0,    559},
	{0,    560},
	{1, 0x0207},	/*  */
	{1, 0x0010},	/*  */
	{0,    563},
	{0,    564},
	{1, 0x00ba},	/*  */
	{0,    566},
	{0,    569},
	{0,    572},
	{0,    570},
	{0,    573},
	{1, 0x1015},
	{0,    578},
	{0,    577},
	{0,    582},
	{1, 0x01b7},	/*  */
	{1, 0x001c},	/* l */
	{1, 0x03a5},	/* Y */
	{0,    584},
	{0,    586},
	{0,    587},
	{0,    589},
	{1, 0x039a},	/* n */
	{1, 0x02d2},	/* 2 */
	{0,    594},
	{0,    591},
	{0,    597},
	{1, 0x03cf},	/* B */
	{1, 0x03ae},	/* v */
	{0,    604},
	{0,    599},
	{0,    603},
	{1, 0x03bc},	/*  */
	{1, 0x0254},	/*  */
	{0,    605},
	{0,    606},
	{1, 0x0030},	/*  */
	{1, 0x011d},	/*  */
	{0,    611},
	{0,    608},
	{0,    612},
	{0,    614},
	{0,    615},
	{0,    616},
	{1, 0x03c8},	/* R */
	{1, 0x02f3},	/*  */
	{0,    620},
	{0,    621},
	{1, 0x008b},	/*  */
	{0,    625},
	{0,    622},
	{1, 0x0018},	/*  */
	{0,    628},
	{0,    627},
	{0,    633},
	{0,    630},
	{0,    629},
	{0,    634},
	{1, 0x03af},	/* x */
	{1, 0x02dd},	/* 1 */
	{1, 0x03b0},	/* { */
	{0,    636},
	{0,    643},
	{0,    641},
	{1, 0x0150},	/*  */
	{0,    644},
	{1, 0x0045},	/* S */
	{0,    649},
	{1, 0x014a},	/*  */
	{0,    648},
	{0,    651},
	{1, 0x00f0},	/*  */
	{0,    652},
	{0,    654},
	{0,    657},
	{1, 0x0043},	/*  */
	{1, 0x0397},	/*  */
	{0,    659},
	{0,    661},
	{1, 0x01ef},	/*  */
	{0,    664},
	{0,    666},
	{0,    667},
	{1, 0x03ad},	/* u */
	{1, 0x027a},	/*  */
	{1, 0x0200},	/* o */
	{1, 0x0365},	/*  */
	{0,    670},
	{0,    671},
	{1, 0x0094},	/* V */
	{0,    673},
	{1, 0x02d1},	/* 0 */
	{0,    675},
	{0,    676},
	{1, 0x001a},	/* O */
	{1, 0x033a},	/*  */
	{0,    678},
	{0,    687},
	{0,    681},
	{0,    683},
	{0,    685},
	{1, 0x0249},	/*  */
	{0,    690},
	{0,    689},
	{1, 0x02c9},	/* E */
	{1, 0x038c},	/*  */
	{0,    691},
	{0,    693},
	{1, 0x03c0},	/*  */
	{0,    696},
	{1, 0x0379},	/* N */
	{0,    697},
	{0,    698},
	{0,    699},
	{1, 0x000c},	/*  */
	{1, 0x0311},	/*  */
	{0,    702},
	{0,    705},
	{0,    703},
	{0,    706},
	{0,    707},
	{0,    709},
	{0,    710},
	{0,    714},
	{0,    713},
	{0,    716},
	{0,    717},
	{1, 0x03a7},	/* _ */
	{0,    719},
	{0,    721},
	{1, 0x01c7},	/* O */
	{0,    723},
	{0,    725},
	{0,    726},
	{1, 0x00ad},	/*  */
	{0,    728},
	{0,    729},
	{0,    732},
	{0,    735},
	{0,    736},
	{0,    737},
	{0,    740},
	{0,    743},
	{1, 0x0332},	/*  */
	{0,    745},
	{0,    746},
	{0,    747},
	{0,    748},
	{1, 0x0179},	/*  */
	{1, 0x03da},	/*  */
	{0,    752},
	{1, 0x0149},	/*  */
	{1, 0x036f},	/* ` */
	{0,    755},
	{1, 0x00f8},	/*  */
	{1, 0x03d5},	/* w */
	{0,    759},
	{0,    761},
	{0,    763},
	{1, 0x025b},	/*  */
	{0,    766},
	{1, 0x03bd},	/* W */
	{0,    769},
	{0,    770},
	{0,    774},
	{0,    773},
	{0,    776},
	{0,    778},
	{0,    780},
	{0,    782},
	{0,    783},
	{1, 0x03b5},	/*  */
	{0,    785},
	{0,    786},
	{0,    789},
	{0,    790},
	{1, 0x01d0},	/* q */
	{0,    792},
	{1, 0x03cc},	/* t */
	{1, 0x0318},	/*  */
	{1, 0x03ce},	/*  */
	{1, 0x03ba},	/*  */
	{0,    797},
	{0,    800},
	{0,    801},
	{0,    803},
	{0,    805},
	{0,    806},
	{0,    807},
	{1, 0x03ac},	/* r */
	{0,    810},
	{0,    811},
	{0,    814},
	{0,    815},
	{0,    816},
	{0,    817},
	{0,    819},
	{0,    821},
	{0,    823},
	{0,    825},
	{0,    826},
	{0,    828},
	{0,    829},
	{1, 0x032d},	/*  */
	{0,    832},
	{0,    834},
	{1, 0x03c4},	/* } */
	{1, 0x1006},
	{0,    836},
	{0,    839},
	{0,    840},
	{0,    842},
	{1, 0x0301},	/*  */
	{1, 0x03c9},	/* X */
	{0,    845},
	{1, 0x035e},	/* J */
	{0,    848},
	{1, 0x031e},	/*  */
	{1, 0x0339},	/*  */
	{1, 0x1012},
	{0,    853},
	{1, 0x0335},	/* A */
	{0,    855},
	{0,    857},
	{0,    859},
	{0,    861},
	{0,    863},
	{0,    865},
	{1, 0x033e},	/*  */
	{1, 0x032b},	/*  */
	{0,    868},
	{1, 0x0354},	/*  */
	{1, 0x0328},	/*  */
	{0,    871},
	{1, 0x02e5},	/*  */
	{0,    873},
	{1, 0x0313},	/*  */
	{1, 0x02e7},	/*  */
	{0,    877},
	{0,    879},
	{0,    881},
	{0,    883},
	{0,    885},
	{1, 0x0304},	/*  */
	{0,    888},
	{0,    889},
	{0,    890},
	{0,    892},
	{0,    894},
	{0,    896},
	{0,    898},
	{1, 0x0360},	/* [ */
	{1, 0x02fe},	/*  */
	{1, 0x032c},	/*  */
	{0,    903},
	{1, 0x0303},	/*  */
	{0,    906},
	{0,    907},
	{1, 0x02eb},	/*  */
	{1, 0x02ec},	/*  */
	{1, 0x02ee},	/*  */
	{0,    911},
	{0,    912},
	{1, 0x0327},	/*  */
	{0,    914},
	{0,    915},
	{1, 0x0363},	/* u */
	{1, 0x02ff},	/*  */
	{1, 0x034c},	/*  */
	{0,    918},
	{0,    919},
	{0,    920},
	{0,    921},
	{0,    922},
	{1, 0x0366},	/* c */
	{1, 0x1001},
	{1, 0x02fd},	/*  */
	{1, 0x03c6},	/*  */
	{1, 0x02e8},	/*  */
	{1, 0x032a},	/*  */
	{1, 0x03c3},	/*  */
	{1, 0x0300},	/*  */
	{0,    930},
	{0,    932},
	{0,    934},
	{0,    935},
	{1, 0x0330},	/*  */
	{0,    938},
	{0,    939},
	{0,    941},
	{1, 0x0399},	/*  */
	{0,    944},
	{0,    946},
	{1, 0x0398},	/*  */
	{0,    949},
	{0,    950},
	{0,    952},
	{0,    954},
	{0,    956},
	{0,    958},
	{0,    960},
	{1, 0x1000},
	{0,    963},
	{0,    965},
	{0,    967},
	{0,    968},
	{0,    970},
	{0,    972},
	{0,    974},
	{0,    976},
	{0,    978},
	{0,    980},
	{0,    982},
	{0,    984},
	{0,    986},
	{0,    988},
};

/* nt}f[^pe[u(rbgOFF) */
static const struct hufftbl_t tbl_decode_off[] =
{
	{1, 0x0100},	/*  */
	{1, 0x0205},	/*  */
	{1, 0x0211},	/*  */
	{1, 0x0216},	/*  */
	{1, 0x0217},	/*  */
	{1, 0x0087},	/* n */
	{1, 0x0230},	/* m */
	{1, 0x0232},	/* ` */
	{1, 0x0233},	/* { */
	{1, 0x011b},	/*  */
	{1, 0x0122},	/*  */
	{1, 0x024c},	/*  */
	{1, 0x0129},	/*  */
	{1, 0x0257},	/*  */
	{1, 0x0260},	/* P */
	{1, 0x0269},	/*  */
	{1, 0x0274},	/* l */
	{1, 0x027c},	/*  */
	{1, 0x0280},	/*  */
	{1, 0x0143},	/*  */
	{1, 0x0145},	/*  */
	{1, 0x0146},	/*  */
	{1, 0x0293},	/* ~ */
	{1, 0x00a5},	/*  */
	{1, 0x029c},	/*  */
	{1, 0x02a1},	/*  */
	{1, 0x02a7},	/*  */
	{1, 0x002a},	/*  */
	{1, 0x00ab},	/*  */
	{1, 0x02b3},	/* f */
	{1, 0x0015},	/* D */
	{1, 0x02c6},	/* { */
	{1, 0x02c8},	/*  */
	{1, 0x02cf},	/* Y */
	{1, 0x016d},	/*  */
	{1, 0x002d},	/*  */
	{1, 0x0175},	/*  */
	{1, 0x00bb},	/*  */
	{1, 0x0306},	/*  */
	{1, 0x0308},	/* D */
	{1, 0x00c1},	/*  */
	{1, 0x0323},	/* M */
	{1, 0x0190},	/*  */
	{1, 0x0358},	/* . */
	{1, 0x019e},	/*  */
	{1, 0x036b},	/*  */
	{1, 0x01a4},	/*  */
	{1, 0x037e},	/*  */
	{1, 0x0384},	/*  */
	{1, 0x01af},	/*  */
	{1, 0x006c},	/*  */
	{1, 0x01bb},	/*  */
	{1, 0x000d},	/*  */
	{1, 0x00df},	/*  */
	{1, 0x03a9},	/* d */
	{1, 0x00e1},	/*  */
	{1, 0x01c8},	/* P */
	{1, 0x00e8},	/* h */
	{1, 0x00e9},	/* i */
	{1, 0x01d5},	/*  */
	{1, 0x03d8},	/*  */
	{1, 0x00ed},	/* v */
	{1, 0x100b},
	{1, 0x000e},	/*  */
	{1, 0x00f3},	/*  */
	{1, 0x110a},
	{1, 0x110c},
	{1, 0x1115},
	{1, 0x01f3},	/*  */
	{1, 0x01f8},	/* K */
	{0,     69},
	{0,      2},
	{1, 0x0103},	/*  */
	{1, 0x0083},	/* ] */
	{1, 0x0215},	/*  */
	{0,      1},
	{1, 0x021d},	/*  */
	{1, 0x0220},	/*  */
	{0,      5},
	{1, 0x008c},	/*  */
	{1, 0x011a},	/*  */
	{1, 0x023e},	/*  */
	{0,     11},
	{1, 0x011f},	/*  */
	{1, 0x0248},	/*  */
	{1, 0x0255},	/*  */
	{0,      9},
	{0,     12},
	{1, 0x026a},	/*  */
	{0,     14},
	{0,     13},
	{0,     18},
	{1, 0x0282},	/*  */
	{0,     17},
	{0,     19},
	{1, 0x0290},	/* y */
	{0,     21},
	{1, 0x014d},	/*  */
	{1, 0x029e},	/*  */
	{1, 0x014f},	/* P */
	{0,     23},
	{1, 0x0156},	/*  */
	{0,     25},
	{1, 0x015b},	/*  */
	{0,     37},
	{1, 0x02c1},	/* n */
	{1, 0x0162},	/*  */
	{0,     28},
	{1, 0x02d0},	/* [ */
	{1, 0x00b5},	/*  */
	{1, 0x02d9},	/* 9 */
	{1, 0x016e},	/* C */
	{1, 0x005b},	/* j */
	{1, 0x0176},	/*  */
	{0,     34},
	{0,     35},
	{1, 0x0312},	/*  */
	{1, 0x00c3},	/*  */
	{1, 0x00c6},	/*  */
	{0,     39},
	{1, 0x019a},	/*  */
	{0,     49},
	{1, 0x0067},	/*  */
	{1, 0x01a1},	/*  */
	{1, 0x0068},	/*  */
	{0,     45},
	{1, 0x01ab},	/*  */
	{0,     44},
	{0,     47},
	{0,     48},
	{1, 0x01b8},	/*  */
	{0,     68},
	{0,     50},
	{0,     53},
	{0,     60},
	{1, 0x01d1},	/* u */
	{0,     54},
	{0,     55},
	{1, 0x01d8},	/*  */
	{0,     58},
	{1, 0x01e5},	/*  */
	{0,     64},
	{1, 0x1107},
	{1, 0x110f},
	{1, 0x1112},
	{1, 0x1116},
	{0,     67},
	{1, 0x01f6},	/* E */
	{1, 0x0007},	/* C */
	{1, 0x0081},	/* X */
	{1, 0x0212},	/*  */
	{1, 0x0213},	/*  */
	{1, 0x0218},	/*  */
	{1, 0x0238},	/*  */
	{1, 0x008e},	/*  */
	{1, 0x008f},	/*  */
	{1, 0x110e},
	{1, 0x025c},	/*  */
	{1, 0x0131},	/*  */
	{1, 0x0137},	/* R */
	{1, 0x013e},	/* ~ */
	{1, 0x0288},	/*  */
	{1, 0x014e},	/* N */
	{1, 0x02ab},	/*  */
	{1, 0x015a},	/*  */
	{1, 0x002b},	/*  */
	{1, 0x02df},	/* H */
	{1, 0x00be},	/*  */
	{1, 0x0320},	/*  */
	{1, 0x00ca},	/*  */
	{1, 0x01a2},	/*  */
	{1, 0x006b},	/*  */
	{1, 0x01b2},	/*  */
	{1, 0x006d},	/*  */
	{1, 0x03a6},	/* ] */
	{1, 0x00e6},	/* ` */
	{1, 0x1105},
	{0,    114},
	{1, 0x0080},	/* S */
	{0,     79},
	{0,    147},
	{0,     70},
	{0,     72},
	{1, 0x0225},	/* Q */
	{1, 0x0228},	/* [ */
	{1, 0x0022},	/*  */
	{0,     75},
	{0,     77},
	{1, 0x0121},	/*  */
	{0,     80},
	{1, 0x0093},	/* L */
	{0,     83},
	{1, 0x01e8},	/*  */
	{0,     85},
	{0,     86},
	{0,     89},
	{1, 0x028c},	/* n */
	{1, 0x00a3},	/*  */
	{0,     95},
	{0,     94},
	{0,     96},
	{1, 0x02a2},	/*  */
	{1, 0x0152},	/*  */
	{0,     98},
	{1, 0x02b0},	/* _ */
	{0,    100},
	{0,    104},
	{0,    103},
	{0,    108},
	{0,    106},
	{0,    107},
	{0,    109},
	{0,    111},
	{0,    112},
	{0,    129},
	{1, 0x0182},	/*  */
	{1, 0x0185},	/*  */
	{1, 0x018b},	/*  */
	{1, 0x0192},	/*  */
	{0,    116},
	{1, 0x0198},	/*  */
	{1, 0x0066},	/*  */
	{1, 0x0033},	/*  */
	{0,    119},
	{0,    124},
	{1, 0x01a8},	/* U */
	{0,    122},
	{0,    128},
	{0,    125},
	{0,    127},
	{1, 0x01be},	/*  */
	{0,    131},
	{1, 0x01cc},	/* j */
	{0,    134},
	{0,    133},
	{1, 0x00eb},	/* o */
	{0,    143},
	{0,    138},
	{0,    142},
	{0,    141},
	{0,    144},
	{1, 0x0208},	/*  */
	{1, 0x0111},	/* } */
	{1, 0x0116},	/*  */
	{1, 0x0240},	/*  */
	{1, 0x0008},	/*  */
	{1, 0x0256},	/*  */
	{1, 0x026e},	/* I */
	{1, 0x0278},	/*  */
	{1, 0x028a},	/*  */
	{1, 0x0291},	/* z */
	{1, 0x00a9},	/*  */
	{1, 0x015d},	/*  */
	{1, 0x02bc},	/* ^ */
	{1, 0x00b2},	/*  */
	{1, 0x00b4},	/*  */
	{1, 0x030a},	/* * */
	{1, 0x0064},	/*  */
	{1, 0x00ce},	/* G */
	{1, 0x0382},	/*  */
	{1, 0x00d7},	/*  */
	{1, 0x00d9},	/*  */
	{1, 0x00de},	/*  */
	{1, 0x01c1},	/*  */
	{1, 0x03d0},	/*  */
	{1, 0x1013},
	{1, 0x01fc},	/* \ */
	{1, 0x003f},	/* ~ */
	{0,    176},
	{0,    148},
	{0,    152},
	{0,    151},
	{1, 0x011e},	/*  */
	{0,    158},
	{0,    154},
	{0,    153},
	{0,    155},
	{0,    156},
	{1, 0x027e},	/*  */
	{1, 0x00a0},	/*  */
	{0,    159},
	{0,    160},
	{1, 0x0158},	/*  */
	{1, 0x0160},	/*  */
	{0,    163},
	{1, 0x0174},	/*  */
	{1, 0x00bf},	/*  */
	{1, 0x01b3},	/*  */
	{0,    167},
	{0,    168},
	{1, 0x01b4},	/*  */
	{0,    170},
	{1, 0x01bd},	/*  */
	{0,    175},
	{0,    174},
	{1, 0x021e},	/*  */
	{1, 0x008a},	/*  */
	{1, 0x01e9},	/*  */
	{1, 0x0267},	/* k */
	{1, 0x0138},	/* U */
	{1, 0x028d},	/* r */
	{1, 0x014c},	/*  */
	{1, 0x0178},	/*  */
	{1, 0x00c4},	/*  */
	{1, 0x0391},	/*  */
	{1, 0x00d2},	/* o */
	{1, 0x00d8},	/*  */
	{1, 0x0077},	/*  */
	{0,    185},
	{0,    178},
	{0,    240},
	{0,    180},
	{0,    184},
	{0,    183},
	{1, 0x0247},	/*  */
	{1, 0x0253},	/*  */
	{1, 0x0049},	/*  */
	{1, 0x0262},	/* a */
	{0,    190},
	{0,    191},
	{1, 0x027d},	/*  */
	{0,    197},
	{1, 0x0296},	/*  */
	{0,    196},
	{0,    203},
	{1, 0x02a8},	/*  */
	{0,    199},
	{1, 0x02b7},	/*  */
	{1, 0x02c7},	/* ~ */
	{0,    207},
	{0,    205},
	{0,    208},
	{0,    210},
	{1, 0x000b},	/*  */
	{0,    214},
	{0,    216},
	{0,    218},
	{0,    228},
	{0,    220},
	{1, 0x01a6},	/* E */
	{0,    221},
	{0,    222},
	{0,    226},
	{0,    230},
	{0,    239},
	{1, 0x01ce},	/* o */
	{0,    231},
	{1, 0x00f1},	/*  */
	{0,    234},
	{0,    237},
	{1, 0x0203},	/*  */
	{1, 0x024a},	/*  */
	{1, 0x0096},	/* [ */
	{1, 0x00aa},	/*  */
	{1, 0x00b7},	/*  */
	{1, 0x02f9},	/* P */
	{1, 0x017d},	/*  */
	{1, 0x01c3},	/*  */
	{1, 0x003e},	/* w */
	{1, 0x000f},	/* @ */
	{0,    266},
	{1, 0x0117},	/*  */
	{1, 0x0239},	/*  */
	{1, 0x0242},	/*  */
	{0,    244},
	{0,    243},
	{0,    245},
	{0,    248},
	{1, 0x0144},	/*  */
	{1, 0x02af},	/* ^ */
	{1, 0x02b8},	/*  */
	{1, 0x02c4},	/* t */
	{0,    253},
	{1, 0x0062},	/*  */
	{1, 0x0199},	/*  */
	{0,    260},
	{0,    258},
	{1, 0x006e},	/*  */
	{1, 0x00e2},	/*  */
	{0,    262},
	{0,    264},
	{1, 0x1118},
	{1, 0x0009},	/* S */
	{1, 0x101c},
	{1, 0x02b9},	/*  */
	{1, 0x0171},	/* \ */
	{1, 0x1114},
	{0,    267},
	{1, 0x0020},	/*  */
	{1, 0x0086},	/* i */
	{1, 0x01eb},	/*  */
	{1, 0x0046},	/* } */
	{1, 0x0245},	/*  */
	{0,    271},
	{0,    272},
	{0,    275},
	{0,    284},
	{1, 0x02a3},	/*  */
	{0,    280},
	{1, 0x02c0},	/* l */
	{1, 0x00b3},	/*  */
	{0,    282},
	{0,    285},
	{1, 0x0076},	/*  */
	{1, 0x018a},	/*  */
	{1, 0x0194},	/* J */
	{0,    290},
	{0,    289},
	{0,    291},
	{0,    292},
	{1, 0x0101},	/*  */
	{1, 0x0112},	/* ~ */
	{1, 0x1113},
	{1, 0x004b},	/*  */
	{1, 0x02ac},	/*  */
	{1, 0x016c},	/* O */
	{1, 0x018f},	/*  */
	{1, 0x01d7},	/*  */
	{1, 0x03cb},	/* k */
	{1, 0x003b},	/* d */
	{1, 0x007e},	/* K */
	{1, 0x020d},	/*  */
	{1, 0x01de},	/*  */
	{0,    295},
	{0,    296},
	{0,    298},
	{1, 0x1100},
	{0,    300},
	{1, 0x0321},	/*  */
	{0,    303},
	{1, 0x00d6},	/*  */
	{0,    306},
	{0,    305},
	{1, 0x00ff},	/*  */
	{1, 0x0115},	/*  */
	{1, 0x012c},	/*  */
	{1, 0x0298},	/*  */
	{1, 0x02ce},	/* V */
	{1, 0x03d9},	/*  */
	{1, 0x00f7},	/*  */
	{0,    308},
	{0,    310},
	{0,    314},
	{0,    312},
	{0,    318},
	{1, 0x0014},	/*  */
	{0,    317},
	{0,    331},
	{1, 0x01e6},	/*  */
	{1, 0x029f},	/*  */
	{0,    323},
	{0,    320},
	{1, 0x000a},	/* s */
	{0,    328},
	{1, 0x005a},	/* h */
	{0,    329},
	{0,    332},
	{1, 0x00cb},	/* C */
	{0,    336},
	{0,    341},
	{1, 0x037f},	/* ` */
	{0,    337},
	{0,    340},
	{0,    348},
	{1, 0x03ca},	/* \ */
	{0,    344},
	{0,    345},
	{1, 0x00fc},	/*  */
	{1, 0x0236},	/*  */
	{1, 0x0261},	/* T */
	{1, 0x00a8},	/*  */
	{1, 0x017c},	/*  */
	{1, 0x00cd},	/* F */
	{1, 0x0072},	/*  */
	{1, 0x007d},	/*  */
	{0,    355},
	{1, 0x033f},	/*  */
	{0,    350},
	{1, 0x0273},	/* a */
	{1, 0x0057},	/*  */
	{0,    354},
	{0,    352},
	{0,    357},
	{0,    356},
	{1, 0x013f},	/*  */
	{1, 0x0134},	/* D */
	{1, 0x0163},	/*  */
	{1, 0x01ba},	/*  */
	{1, 0x01a3},	/*  */
	{0,    360},
	{0,    380},
	{0,    361},
	{0,    362},
	{1, 0x0279},	/*  */
	{0,    365},
	{0,    368},
	{0,    370},
	{0,    372},
	{0,    373},
	{0,    376},
	{0,    379},
	{0,    378},
	{1, 0x0243},	/*  */
	{1, 0x03a0},	/*  */
	{1, 0x02d5},	/* 5 */
	{0,    384},
	{1, 0x0025},	/*  */
	{0,    381},
	{1, 0x031c},	/* Z */
	{1, 0x0352},	/*  */
	{1, 0x0325},	/*  */
	{1, 0x0258},	/*  */
	{1, 0x0223},	/* H */
	{1, 0x00a4},	/*  */
	{1, 0x02bf},	/* d */
	{1, 0x0070},	/*  */
	{1, 0x00f9},	/*  */
	{1, 0x0226},	/* V */
	{0,    387},
	{1, 0x0244},	/*  */
	{1, 0x024f},	/*  */
	{0,    393},
	{0,    400},
	{0,    395},
	{0,    397},
	{1, 0x0016},	/* J */
	{1, 0x017f},	/*  */
	{0,    408},
	{0,    403},
	{0,    405},
	{1, 0x0039},	/*  */
	{0,    407},
	{1, 0x0370},	/* i */
	{1, 0x004d},	/*  */
	{1, 0x00da},	/*  */
	{0,    410},
	{1, 0x0210},	/*  */
	{0,    411},
	{0,    412},
	{0,    413},
	{1, 0x02f0},	/* m */
	{0,    415},
	{1, 0x0034},	/*  */
	{1, 0x0350},	/* X */
	{0,    416},
	{0,    418},
	{1, 0x01ea},	/*  */
	{0,    420},
	{1, 0x0381},	/*  */
	{0,    426},
	{1, 0x023d},	/*  */
	{0,    421},
	{0,    424},
	{1, 0x0099},	/* k */
	{0,    427},
	{0,    429},
	{1, 0x01fe},	/* h */
	{1, 0x00cf},	/* O */
	{1, 0x01ec},	/*  */
	{1, 0x0166},	/*  */
	{1, 0x0135},	/* K */
	{1, 0x0252},	/*  */
	{0,    438},
	{0,    439},
	{1, 0x01df},	/*  */
	{1, 0x0125},	/*  */
	{0,    440},
	{0,    444},
	{0,    454},
	{1, 0x03a1},	/* M */
	{0,    449},
	{0,    448},
	{0,    450},
	{0,    452},
	{0,    461},
	{0,    458},
	{1, 0x0387},	/*  */
	{0,    459},
	{0,    463},
	{1, 0x001e},	/* z */
	{0,    464},
	{1, 0x01ee},	/*  */
	{1, 0x01e1},	/*  */
	{0,    470},
	{1, 0x0110},	/* x */
	{1, 0x0393},	/* \ */
	{1, 0x015f},	/*  */
	{0,    472},
	{0,    474},
	{1, 0x0276},	/* n */
	{0,    481},
	{0,    476},
	{0,    479},
	{0,    478},
	{0,    482},
	{1, 0x010e},	/* q */
	{1, 0x027b},	/*  */
	{1, 0x019c},	/*  */
	{1, 0x0071},	/*  */
	{0,    488},
	{0,    484},
	{1, 0x1017},
	{0,    485},
	{1, 0x0385},	/* @ */
	{0,    487},
	{1, 0x021c},	/*  */
	{1, 0x0165},	/*  */
	{1, 0x03a2},	/* Q */
	{0,    491},
	{0,    490},
	{0,    495},
	{0,    494},
	{0,    500},
	{1, 0x03d1},	/*  */
	{0,    499},
	{1, 0x00af},	/*  */
	{0,    501},
	{1, 0x004c},	/*  */
	{1, 0x011c},	/*  */
	{0,    502},
	{1, 0x02ad},	/*  */
	{0,    504},
	{0,    510},
	{0,    506},
	{1, 0x0061},	/*  */
	{0,    509},
	{1, 0x0259},	/*  */
	{1, 0x0241},	/*  */
	{1, 0x00c8},	/*  */
	{0,    511},
	{1, 0x025f},	/* N */
	{1, 0x02bd},	/* a */
	{0,    515},
	{0,    514},
	{0,    516},
	{1, 0x0075},	/*  */
	{0,    520},
	{0,    517},
	{0,    521},
	{1, 0x0386},	/*  */
	{0,    522},
	{0,    526},
	{0,    530},
	{0,    528},
	{1, 0x0140},	/*  */
	{1, 0x002f},	/*  */
	{0,    534},
	{0,    532},
	{1, 0x0392},	/*  */
	{1, 0x1016},
	{1, 0x101a},
	{1, 0x035d},	/* E */
	{0,    539},
	{1, 0x022c},	/* g */
	{0,    536},
	{0,    540},
	{0,    538},
	{0,    544},
	{0,    543},
	{1, 0x030b},	/*  */
	{1, 0x0266},	/* j */
	{0,    546},
	{1, 0x013d},	/* s */
	{1, 0x0337},	/* c */
	{1, 0x022b},	/* e */
	{0,    551},
	{0,    552},
	{0,    554},
	{0,    556},
	{1, 0x02c2},	/* p */
	{1, 0x0177},	/*  */
	{1, 0x0118},	/*  */
	{1, 0x0287},	/*  */
	{1, 0x020b},	/*  */
	{0,    562},
	{0,    561},
	{1, 0x00bd},	/*  */
	{1, 0x003c},	/* m */
	{1, 0x0375},	/* b */
	{1, 0x0305},	/* ~ */
	{0,    567},
	{0,    565},
	{0,    568},
	{0,    571},
	{0,    575},
	{0,    574},
	{0,    576},
	{0,    579},
	{0,    580},
	{1, 0x009c},	/* v */
	{0,    581},
	{1, 0x0021},	/* Z */
	{1, 0x0285},	/*  */
	{0,    583},
	{0,    585},
	{1, 0x0090},	/*  */
	{0,    588},
	{1, 0x03b1},	/* | */
	{0,    590},
	{0,    592},
	{0,    593},
	{0,    595},
	{0,    596},
	{0,    598},
	{0,    601},
	{0,    600},
	{0,    602},
	{1, 0x031d},	/*  */
	{0,    607},
	{1, 0x016b},	/* N */
	{1, 0x036d},	/* L */
	{0,    610},
	{0,    609},
	{0,    613},
	{1, 0x00ae},	/*  */
	{1, 0x01d9},	/*  */
	{1, 0x03aa},	/* o */
	{1, 0x02b5},	/*  */
	{0,    617},
	{0,    618},
	{0,    619},
	{1, 0x01bc},	/*  */
	{1, 0x0026},	/* A */
	{1, 0x0047},	/* V */
	{0,    623},
	{0,    624},
	{1, 0x01dd},	/*  */
	{0,    626},
	{1, 0x039e},	/*  */
	{1, 0x0331},	/*  */
	{0,    631},
	{0,    632},
	{1, 0x00fd},	/*  */
	{0,    635},
	{0,    639},
	{0,    637},
	{0,    638},
	{0,    640},
	{1, 0x00c5},	/*  */
	{0,    642},
	{0,    645},
	{1, 0x100d},
	{0,    646},
	{0,    647},
	{1, 0x0038},	/*  */
	{0,    650},
	{1, 0x0272},	/* ` */
	{0,    653},
	{0,    655},
	{0,    656},
	{1, 0x03d3},	/* j */
	{0,    658},
	{0,    660},
	{0,    662},
	{1, 0x03b3},	/*  */
	{0,    663},
	{0,    665},
	{0,    668},
	{1, 0x03b9},	/*  */
	{1, 0x02b2},	/* b */
	{0,    669},
	{1, 0x03c1},	/*  */
	{0,    672},
	{1, 0x0373},	/*  */
	{1, 0x020c},	/*  */
	{0,    674},
	{1, 0x01dc},	/*  */
	{1, 0x03b4},	/*  */
	{0,    677},
	{1, 0x03a3},	/* S */
	{0,    679},
	{0,    680},
	{0,    682},
	{0,    684},
	{0,    686},
	{1, 0x03bf},	/* f */
	{0,    688},
	{1, 0x0334},	/*  */
	{1, 0x0336},	/* V */
	{1, 0x022a},	/* _ */
	{1, 0x02f2},	/*  */
	{0,    692},
	{0,    694},
	{0,    695},
	{1, 0x037a},	/* ^ */
	{1, 0x0036},	/*  */
	{1, 0x003d},	/* v */
	{1, 0x021b},	/*  */
	{1, 0x009a},	/* { */
	{0,    700},
	{0,    701},
	{1, 0x0275},	/* m */
	{0,    704},
	{1, 0x002c},	/*  */
	{1, 0x03bb},	/*  */
	{0,    708},
	{1, 0x0317},	/*  */
	{0,    711},
	{0,    712},
	{0,    715},
	{1, 0x00cc},	/* E */
	{0,    718},
	{1, 0x00a1},	/*  */
	{0,    720},
	{1, 0x018d},	/*  */
	{0,    722},
	{0,    724},
	{0,    727},
	{1, 0x0315},	/*  */
	{1, 0x1008},
	{0,    730},
	{0,    731},
	{0,    733},
	{0,    734},
	{0,    738},
	{0,    739},
	{0,    741},
	{0,    742},
	{0,    744},
	{1, 0x0106},	/* C */
	{1, 0x02db},	/* g */
	{1, 0x0396},	/* b */
	{0,    749},
	{0,    750},
	{0,    751},
	{0,    753},
	{1, 0x0316},	/*  */
	{0,    754},
	{0,    756},
	{0,    757},
	{0,    758},
	{0,    760},
	{0,    762},
	{0,    764},
	{0,    765},
	{0,    767},
	{0,    768},
	{1, 0x01e7},	/*  */
	{0,    771},
	{0,    772},
	{0,    775},
	{0,    777},
	{0,    779},
	{0,    781},
	{1, 0x03b6},	/*  */
	{0,    784},
	{1, 0x036c},	/* I */
	{0,    787},
	{0,    788},
	{1, 0x03c7},	/*  */
	{0,    791},
	{1, 0x0378},	/* C */
	{0,    793},
	{0,    794},
	{0,    795},
	{0,    796},
	{0,    798},
	{0,    799},
	{1, 0x03b7},	/*  */
	{0,    802},
	{0,    804},
	{1, 0x037b},	/* h */
	{1, 0x0319},	/*  */
	{0,    808},
	{0,    809},
	{1, 0x0376},	/* l */
	{0,    812},
	{0,    813},
	{1, 0x01d2},	/*  */
	{1, 0x001b},	/* T */
	{0,    818},
	{0,    820},
	{0,    822},
	{0,    824},
	{1, 0x03cd},	/*  */
	{0,    827},
	{1, 0x02dc},	/*  */
	{0,    830},
	{0,    831},
	{0,    833},
	{1, 0x02ed},	/*  */
	{0,    835},
	{1, 0x0322},	/*  */
	{0,    837},
	{0,    838},
	{0,    841},
	{0,    843},
	{0,    844},
	{1, 0x1010},
	{0,    846},
	{0,    847},
	{0,    849},
	{0,    850},
	{0,    851},
	{0,    852},
	{1, 0x03ab},	/* p */
	{0,    854},
	{0,    856},
	{0,    858},
	{0,    860},
	{0,    862},
	{0,    864},
	{1, 0x0333},	/*  */
	{0,    866},
	{0,    867},
	{1, 0x0314},	/*  */
	{0,    869},
	{0,    870},
	{0,    872},
	{1, 0x0359},	/* ? */
	{0,    874},
	{0,    875},
	{0,    876},
	{0,    878},
	{0,    880},
	{0,    882},
	{0,    884},
	{0,    886},
	{0,    887},
	{1, 0x02e6},	/*  */
	{1, 0x031b},	/*  */
	{0,    891},
	{0,    893},
	{0,    895},
	{0,    897},
	{0,    899},
	{0,    900},
	{0,    901},
	{0,    902},
	{0,    904},
	{0,    905},
	{1, 0x031a},	/*  */
	{0,    908},
	{1, 0x0329},	/*  */
	{0,    909},
	{0,    910},
	{1, 0x03c5},	/*  */
	{0,    913},
	{1, 0x02ea},	/*  */
	{1, 0x032f},	/*  */
	{1, 0x1003},
	{0,    916},
	{1, 0x035a},	/* ! */
	{0,    917},
	{1, 0x03c2},	/*  */
	{1, 0x039d},	/*  */
	{1, 0x1002},
	{1, 0x0302},	/*  */
	{0,    923},
	{1, 0x02e9},	/*  */
	{0,    924},
	{1, 0x02ef},	/*  */
	{0,    925},
	{0,    926},
	{0,    927},
	{0,    928},
	{0,    929},
	{0,    931},
	{0,    933},
	{1, 0x033d},	/*  */
	{0,    936},
	{0,    937},
	{1, 0x032e},	/*  */
	{0,    940},
	{0,    942},
	{0,    943},
	{0,    945},
	{0,    947},
	{0,    948},
	{1, 0x0356},	/* B */
	{0,    951},
	{0,    953},
	{0,    955},
	{0,    957},
	{0,    959},
	{0,    961},
	{0,    962},
	{0,    964},
	{0,    966},
	{1, 0x0000},	/*  */
	{0,    969},
	{0,    971},
	{0,    973},
	{0,    975},
	{0,    977},
	{0,    979},
	{0,    981},
	{0,    983},
	{0,    985},
	{0,    987},
	{1, 0x0056},	/*  */
	{1, 0x0065},	/*  */
	{1, 0x0005},	/*  */
	{1, 0x00ec},	/* p */
	{0,      1},
	{1, 0x005e},	/* w */
	{0,      0},
	{1, 0x00e7},	/* b */
	{1, 0x0045},	/* S */
	{1, 0x0053},	/* i */
	{1, 0x0046},	/* } */
	{0,      4},
	{0,      5},
	{0,      8},
	{0,      6},
	{0,      7},
	{1, 0x0062},	/*  */
	{0,      9},
	{1, 0x0071},	/*  */
	{1, 0x00fa},	/*  */
	{0,     11},
	{0,     12},
	{1, 0x0068},	/*  */
	{0,     13},
	{0,     15},
	{0,     16},
	{1, 0x0063},	/*  */
	{1, 0x00ee},	/* y */
	{1, 0x0042},	/*  */
	{1, 0x0054},	/* p */
	{1, 0x00f9},	/*  */
	{0,     19},
	{1, 0x00ac},	/*  */
	{1, 0x0061},	/*  */
	{1, 0x002c},	/*  */
	{0,     21},
	{1, 0x0041},	/*  */
	{0,     24},
	{0,     25},
	{0,     26},
	{0,     28},
	{1, 0x004d},	/*  */
	{1, 0x0040},	/*  */
	{0,     29},
	{0,     31},
	{1, 0x003f},	/* ~ */
	{0,     32},
	{1, 0x0043},	/*  */
	{1, 0x003a},	/*  */
	{1, 0x00fb},	/*  */
	{0,     35},
	{1, 0x009c},	/* v */
	{0,     37},
	{0,     38},
	{1, 0x00f5},	/*  */
	{1, 0x0020},	/*  */
	{1, 0x0031},	/*  */
	{1, 0x002f},	/*  */
	{0,     42},
	{0,     43},
	{0,     45},
	{0,     46},
	{1, 0x001a},	/* O */
	{0,     48},
	{1, 0x003b},	/* d */
	{0,     50},
	{1, 0x0013},	/*  */
	{1, 0x00f2},	/*  */
	{1, 0x002a},	/*  */
	{1, 0x0038},	/*  */
	{0,     54},
	{1, 0x0039},	/*  */
	{0,     57},
	{0,     58},
	{1, 0x0018},	/*  */
	{1, 0x0021},	/* Z */
	{0,     61},
	{1, 0x0037},	/*  */
	{1, 0x0019},	/* K */
	{0,     63},
	{0,     64},
	{1, 0x003d},	/* v */
	{0,     66},
	{0,     67},
	{1, 0x00ff},	/*  */
	{0,     70},
	{1, 0x0016},	/* J */
	{0,     72},
	{1, 0x003c},	/* m */
	{0,     74},
	{0,     75},
	{1, 0x0022},	/*  */
	{0,     77},
	{0,     79},
	{0,     81},
	{0,     83},
	{0,     84},
	{1, 0x001b},	/* T */
	{0,     87},
	{1, 0x00f7},	/*  */
	{1, 0x0029},	/*  */
	{0,     91},
	{1, 0x00fe},	/*  */
	{1, 0x0015},	/* D */
	{0,     94},
	{0,     95},
	{0,     97},
	{1, 0x0084},	/* ` */
	{0,    100},
	{0,    102},
	{1, 0x0001},	/*  */
	{0,    105},
	{0,    107},
	{0,    109},
	{0,    111},
	{0,    113},
	{0,    115},
	{1, 0x0004},	/*  */
	{1, 0x0060},	/* { */
	{1, 0x0073},	/*  */
	{1, 0x00eb},	/* o */
	{0,      3},
	{1, 0x005c},	/* s */
	{1, 0x006c},	/*  */
	{0,      2},
	{1, 0x0026},	/* A */
	{1, 0x004b},	/*  */
	{1, 0x00a7},	/*  */
	{1, 0x0047},	/* V */
	{1, 0x0064},	/*  */
	{1, 0x006b},	/*  */
	{1, 0x00ea},	/* n */
	{1, 0x00f4},	/*  */
	{1, 0x0049},	/*  */
	{1, 0x0070},	/*  */
	{1, 0x004c},	/*  */
	{0,     10},
	{1, 0x0069},	/*  */
	{1, 0x00ed},	/* v */
	{1, 0x0034},	/*  */
	{1, 0x0089},	/*  */
	{1, 0x00ef},	/*  */
	{0,     14},
	{1, 0x0048},	/* c */
	{0,     17},
	{1, 0x00fd},	/*  */
	{1, 0x0051},	/* e */
	{1, 0x005d},	/* t */
	{0,     18},
	{1, 0x006a},	/*  */
	{1, 0x0027},	/* L */
	{0,     20},
	{1, 0x0030},	/*  */
	{0,     22},
	{1, 0x00af},	/*  */
	{0,     23},
	{1, 0x004e},	/*  */
	{1, 0x002d},	/*  */
	{0,     27},
	{1, 0x001d},	/* s */
	{1, 0x005b},	/* j */
	{0,     30},
	{1, 0x005f},	/* z */
	{1, 0x0079},	/*  */
	{1, 0x0055},	/*  */
	{1, 0x0035},	/* R */
	{0,     33},
	{0,     34},
	{1, 0x0078},	/*  */
	{1, 0x0033},	/*  */
	{0,     36},
	{1, 0x009d},	/* w */
	{1, 0x001e},	/* z */
	{0,     39},
	{0,     41},
	{0,     40},
	{1, 0x006f},	/*  */
	{0,     44},
	{1, 0x0083},	/* ] */
	{0,     47},
	{0,     49},
	{1, 0x009a},	/* { */
	{1, 0x002b},	/*  */
	{0,     51},
	{0,     52},
	{0,     53},
	{1, 0x0010},	/*  */
	{1, 0x0032},	/*  */
	{0,     55},
	{0,     56},
	{1, 0x001c},	/* l */
	{0,     59},
	{0,     60},
	{1, 0x0012},	/*  */
	{1, 0x0014},	/*  */
	{0,     62},
	{1, 0x0017},	/* K */
	{1, 0x0036},	/*  */
	{0,     65},
	{1, 0x002e},	/*  */
	{1, 0x0025},	/*  */
	{0,     68},
	{0,     69},
	{0,     71},
	{1, 0x0023},	/*  */
	{0,     73},
	{1, 0x0028},	/* N */
	{1, 0x0024},	/*  */
	{0,     76},
	{1, 0x003e},	/* w */
	{0,     78},
	{0,     80},
	{0,     82},
	{1, 0x0011},	/*  */
	{0,     85},
	{0,     86},
	{0,     88},
	{0,     89},
	{0,     90},
	{1, 0x007a},	/*  */
	{0,     92},
	{0,     93},
	{1, 0x001f},	/*  */
	{0,     96},
	{0,     98},
	{0,     99},
	{0,    101},
	{0,    103},
	{0,    104},
	{0,    106},
	{0,    108},
	{0,    110},
	{0,    112},
	{0,    114},
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, int flag_message)
{
	int i;
	char *buf_dstbuf = NULL;
	char *ptr_buf = NULL;
	const size_t len_buf = srcbufsize * 4;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_dakuten) / sizeof(tbl_dakuten[0]) == 256);
	assert(sizeof(tbl_handakuten) / sizeof(tbl_handakuten[0]) == 256);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	if (!flag_message)
	{
		for (i = 0; i < (int)srcbufsize; i++)
		{
			if (ptr_srcbuf[i] == 0x84 && i + 1 < (int)srcbufsize && tbl_dakuten[ptr_srcbuf[i + 1]] != NULL)			/* _̏ */
			{
				strcat(buf_dstbuf, tbl_dakuten[ptr_srcbuf[i + 1]]);
				i++;
			}
			else if (ptr_srcbuf[i] == 0x83 && i + 1 < (int)srcbufsize && tbl_handakuten[ptr_srcbuf[i + 1]] != NULL)	/* _̏ */
			{
				strcat(buf_dstbuf, tbl_handakuten[ptr_srcbuf[i + 1]]);
				i++;
			}
			else
				strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
		}
	}
	else
	{
		/* }`oCg͖T|[g */
		assert(0);
	}

	/* ̋󔒂 */
	while ((ptr_buf = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr_buf + 1) == '\0')
		*ptr_buf = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_message)
{
	int ch;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_dakuten) / sizeof(tbl_dakuten[0]) == 256);
	assert(sizeof(tbl_handakuten) / sizeof(tbl_handakuten[0]) == 256);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read = NULL;
		return 0;
	}

	/* fR[h */
	if (!flag_message)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		int index = 0x03dd;		/* lݒ */
		assert(0x03dd == sizeof(tbl_decode_on) / sizeof(tbl_decode_on[0]) - 1);

		while ((ch = fgetc(fp_read)) != EOF)
		{
			int index_bit = 0;

			while (index_bit < 8)
			{
				/* 1rbgǂŁAQƂe[u肷 */
				const int bit = ((ch & (1U << index_bit)) != 0);
				const struct hufftbl_t *ptr_tbl = (bit) ? tbl_decode_on : tbl_decode_off;

				index_bit++;

				/* CfbNX̒l̓e[u̗vfɎ܂Ă邩? */
				assert(!bit || (0 <= index && index < sizeof(tbl_decode_on)  / sizeof(tbl_decode_on[0])));
				assert(bit  || (0 <= index && index < sizeof(tbl_decode_off) / sizeof(tbl_decode_off[0])));

				/* m肵Ȃꍇ́ACfbNXݒ肵ďp */
				if (!ptr_tbl[index].flag_term)
				{
					/* e[uQƐCfbNXݒ肷 */
					index = ptr_tbl[index].value;
					continue;
				}

				/* o͂ */
				if ((ptr_tbl[index].value & 0x1000) != 0)	/* 12rbgڂZbgĂꍇ͐R[h */
				{
					switch (ptr_tbl[index].value & ~0x1000)
					{
					case 0x00:	/* s */
					case 0x07:	/* ? */
						fprintf(fp_write, "\n");
						break;
					case 0x02:	/* ͑҂ */
						fprintf(fp_write, "\n\n");
						break;
					case 0x01:	/* bZ[W̏I */
					case 0x10:
					case 0x18:
						fprintf(fp_write, "\n\n");
						break;
					case 0x03:	/* ŏ"*u"\Ȃ */
					case 0x06:
						break;
					case 0x04:
						fprintf(fp_write, "(l)");
						break;
					case 0x05:	/* ` */
						fprintf(fp_write, "()");
						break;
					case 0x08:
						fprintf(fp_write, "(LN^)");
						break;
					case 0x0a:
						fprintf(fp_write, "()");
						break;
					case 0x0b:
						fprintf(fp_write, "()");
						break;
					case 0x0d:	/* EFCg */
						break;
					case 0x0f:
						fprintf(fp_write, "(X^[)");
						break;
					case 0x11:
						fprintf(fp_write, "(擪LN^̖O)");
						break;
					case 0x12:
						fprintf(fp_write, "(l̖O)");
						break;
					case 0x13:
						fprintf(fp_write, "(L[pT[̖O)");
						break;
					case 0x15:
						fprintf(fp_write, "(Ȃ̖O)");
						break;
					case 0x16:
						fprintf(fp_write, "(q̖O)");
						break;
					case 0x17:
						fprintf(fp_write, "(̖O)");
						break;
					default:
/*						fprintf(fp_write, "[%02x]", ptr_tbl[index].value);	*/
						break;
					}
				}
				else if (ptr_tbl[index].value == 0x0000)	/*  */
					fprintf(fp_write, " ");
				else
					fprintf(fp_write, "%s", tbl_charcode_mes[ptr_tbl[index].value & 0x03ff]);

				index = 0x03dd;		/* lݒ */
			}
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
