/*
 *	dq5spell.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq5decode.h"
#include "dq5spell.h"

#define FILEPOS_SPELLNAME	0x110000
#define FILEPOS_SPELLRANGE	0x138071
#define FILEPOS_SPELLMP		0x109bb4
#define NUM_SPELL			219
#define NUM_SPELLNAME		170
#define NUM_SPELLRANGE		64
#define SIZEOF_SPELLRANGE	2
#define SIZEOF_SPELLMP		1

static void spell_setname(void);

static char tbl_spellname[NUM_SPELL][256];	/* ̖Oi[e[u */
static int flag_setspellname = 0;			/* tbl_spellnameɃf[^i[Ă邩ǂ */

const char *spell_getname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_setspellname)
		spell_setname();

	return tbl_spellname[index];
}

static void spell_setname(void)
{
	int i;
	long filepos;

	/* ̕e[u */
	for (i = 0; i < NUM_SPELL; i++)
		*tbl_spellname[i] = '\0';

	/* ̕ǂݍ */
	filepos = FILEPOS_SPELLNAME;
	for (i = 0; i < NUM_SPELLNAME; i++)
	{
		unsigned char byte;
		unsigned char buf[256];
		size_t readsize = 0;

		filepos += file_read_sfc(&byte, filepos, 1);
		readsize = (size_t)byte;

		if (readsize > 0)
		{
			filepos += file_read_sfc(buf, filepos, readsize);
			dec_string(tbl_spellname[i], buf, sizeof(tbl_spellname[i]), readsize, 0);
		}
	}

	flag_setspellname = 1;
}

const char *spell_getdesc(int index)
{
	static const char *tbl_strdesc[/* NUM_SPELL */] =
	{
		/* 00 */	"{[bƂĂB",
		/* 01 */	"LN^p",
		/* 02 */	"LN^p",
		/* 03 */	"LN^p",
		/* 04 */	"LN^p",
		/* 05 */	"LN^p",
		/* 06 */	"LN^p",
		/* 07 */	"LN^p",
		/* 08 */	"LN^p",
		/* 09 */	"LN^p",
		/* 0a */	"LN^p",
		/* 0b */	"LN^p",
		/* 0c */	"LN^p",
		/* 0d */	"LN^p",
		/* 0e */	"LN^p",
		/* 0f */	"LN^p",
		/* 10 */	"LN^p",
		/* 11 */	"LN^p",
		/* 12 */	"LN^p",
		/* 13 */	"LN^p",
		/* 14 */	"LN^p",
		/* 15 */	"LN^p",
		/* 16 */	"LN^p",
		/* 17 */	"LN^p",
		/* 18 */	"LN^p",
		/* 19 */	"LN^p",
		/* 1a */	"LN^p",
		/* 1b */	"LN^p",
		/* 1c */	"LN^p",
		/* 1d */	"LN^p",
		/* 1e */	"LN^p",
		/* 1f */	"LN^p",
		/* 20 */	"LN^p",
		/* 21 */	"LN^p",
		/* 22 */	"LN^p",
		/* 23 */	"LN^p",
		/* 24 */	"LN^p",
		/* 25 */	"LN^p",
		/* 26 */	"LN^p",
		/* 27 */	"LN^p",
		/* 28 */	"LN^p",
		/* 29 */	"LN^p",
		/* 2a */	"LN^p",
		/* 2b */	"LN^p",
		/* 2c */	"LN^p",
		/* 2d */	"LN^p",
		/* 2e */	"LN^p",
		/* 2f */	"LN^p",
		/* 30 */	"LN^p",
		/* 31 */	"LN^p",
		/* 32 */	"LN^p",
		/* 33 */	"LN^p",
		/* 34 */	"LN^p",
		/* 35 */	"LN^p",
		/* 36 */	"LN^p",
		/* 37 */	"LN^p",
		/* 38 */	"LN^p",
		/* 39 */	"",
		/* 3a */	"",
		/* 3b */	"",
		/* 3c */	"",
		/* 3d */	"",
		/* 3e */	"",
		/* 3f */	"",
		/* 40 */	"",
		/* 41 */	"",
		/* 42 */	"",
		/* 43 */	"",
		/* 44 */	"",
		/* 45 */	"",
		/* 46 */	"",
		/* 47 */	"",
		/* 48 */	"",
		/* 49 */	"",
		/* 4a */	"",
		/* 4b */	"",
		/* 4c */	"",
		/* 4d */	"",
		/* 4e */	"",
		/* 4f */	"",
		/* 50 */	"",
		/* 51 */	"",
		/* 52 */	"",
		/* 53 */	"",
		/* 54 */	"",
		/* 55 */	"g",
		/* 56 */	"ȊO",
		/* 57 */	"",
		/* 58 */	"",
		/* 59 */	"",
		/* 5a */	"g",
		/* 5b */	"ȊO",
		/* 5c */	"g",
		/* 5d */	"ȊO",
		/* 5e */	"g",
		/* 5f */	"ȊO",
		/* 60 */	"",
		/* 61 */	"",
		/* 62 */	"",
		/* 63 */	"",
		/* 64 */	"",
		/* 65 */	"",
		/* 66 */	"",
		/* 67 */	"",
		/* 68 */	"{[bƂĂB",
		/* 69 */	" W Ă!",
		/* 6a */	"Ȃɂ ƂĂ!",
		/* 6b */	"ځ[ƂĂB",
		/* 6c */	"",
		/* 6d */	"",
		/* 6e */	"",
		/* 6f */	"",
		/* 70 */	"",
		/* 71 */	"_[W1/2",
		/* 72 */	"_[W1/4",
		/* 73 */	"",
		/* 74 */	"Ú~1̃_[W(m1/6)",
		/* 75 */	"Ú~5̃_[W(m100%)",
		/* 76 */	"",
		/* 77 */	"",
		/* 78 */	"",
		/* 79 */	"",
		/* 7a */	"ǂc 肳!!",
		/* 7b */	"͂ Ă!!",
		/* 7c */	"̂ǂ߂ ݂Ă!!",
		/* 7d */	"񂦂̃co ͂!!",
		/* 7e */	"Ȃ ӂ݂Ă!!",
		/* 7f */	"Ԃ݂Ȃ炢 ׂ ƂтĂ!!",
		/* 80 */	"Ղ[ ӂꂠ ̂!!",
		/* 81 */	" ǂ Ă!!",
		/* 82 */	"ĂԂ ͂ ӂ܂킵!!",
		/* 83 */	"   Ƃ΂!!",
		/* 84 */	"Ȃ 킵Â݂ɂ!!",
		/* 85 */	"",
		/* 86 */	"",
		/* 87 */	"",
		/* 88 */	"",
		/* 89 */	"炽 ܂!",
		/* 8a */	"",
		/* 8b */	"",
		/* 8c */	"",
		/* 8d */	"",
		/* 8e */	"",
		/* 8f */	"",
		/* 90 */	"",
		/* 91 */	"",
		/* 92 */	"",
		/* 93 */	"",
		/* 94 */	"",
		/* 95 */	"",
		/* 96 */	"",
		/* 97 */	"",
		/* 98 */	"",
		/* 99 */	"ǂ Ă܂B",
		/* 9a */	"낢肪 ӂ  !",
		/* 9b */	"Ȃނ ͂!",
		/* 9c */	"{[bƂĂB",
		/* 9d */	"{[bƂĂB",
		/* 9e */	"",
		/* 9f */	"",
		/* a0 */	"nԂɖ߂",
		/* a1 */	"",
		/* a2 */	"",
		/* a3 */	"",
		/* a4 */	"",
		/* a5 */	"",
		/* a6 */	"",
		/* a7 */	"nԂ̃hA߂",
		/* a8 */	"",
		/* a9 */	"͂",
		/* aa */	"̓",
		/* ab */	"ԂĂ()",
		/* ac */	"ԂĂ(h & Ԃɗ)",
		/* ad */	"ԂĂ(~8)",
		/* ae */	"ԂĂ(zC~XC)",
		/* af */	"ԂĂ(炢Ԃ)",
		/* b0 */	"ԂĂ(ւ)",
		/* b1 */	"ԂĂ(_[N}X)",
		/* b2 */	"ԂĂ(xz}XC)",
		/* b3 */	"ԂĂ(S[)",
		/* b4 */	"ԂĂ(u[C[^[)",
		/* b5 */	"ԂĂ(V[hbO)",
		/* b6 */	"ԂĂ(܂񂩂~2)",
		/* b7 */	"ԂĂ(L[}V~2)",
		/* b8 */	"Ă()",
		/* b9 */	"Ă(ǂ)",
		/* ba */	"Ă(Ȃ)",
		/* bb */	"",
		/* bc */	"",
		/* bd */	"",
		/* be */	"",
		/* bf */	"",
		/* c0 */	"",
		/* c1 */	"􂢂()",
		/* c2 */	"􂢂",
		/* c3 */	"􂢂()",
		/* c4 */	"􂢂(qbg|Cg)",
		/* c5 */	"􂢂(}WbNp[)",
		/* c6 */	"",
		/* c7 */	"",
		/* c8 */	"",
		/* c9 */	"",
		/* ca */	"",
		/* cb */	"",
		/* cc */	"",
		/* cd */	"",
		/* ce */	"",
		/* cf */	"",
		/* d0 */	"",
		/* d1 */	"",
		/* d2 */	"",
		/* d3 */	"",
		/* d4 */	"",
		/* d5 */	"₭",
		/* d6 */	"̂",
		/* d7 */	"܂ӂ̂",
		/* d8 */	"΂񂢂",
		/* d9 */	"̃h",
		/* da */	"̂",
	};

	assert(sizeof(tbl_strdesc) / sizeof(tbl_strdesc[0]) == NUM_SPELL);

	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	return tbl_strdesc[index];
}

spelldata_t *spell_readdata(void)
{
	int i;
	spelldata_t *buf_spelldata = NULL;
	struct range_tag
	{
		int range_min;	/* _[W̍ŏl */
		int range_max;	/* _[W̍ől */
	};
	struct range_tag tbl_range[NUM_SPELLRANGE];
	const int tbl_range_index[/* NUM_SPELL */] =
	{
		/* 00 */	 0,
		/* 01 */	 1,
		/* 02 */	 2,
		/* 03 */	 3,
		/* 04 */	 4,
		/* 05 */	 5,
		/* 06 */	 6,
		/* 07 */	 7,
		/* 08 */	 8,
		/* 09 */	 9,
		/* 0a */	10,
		/* 0b */	11,
		/* 0c */	12,
		/* 0d */	13,
		/* 0e */	14,
		/* 0f */	15,
		/* 10 */	16,
		/* 11 */	17,
		/* 12 */	18,
		/* 13 */	 0,
		/* 14 */	 0,
		/* 15 */	 0,
		/* 16 */	 0,
		/* 17 */	 0,
		/* 18 */	 0,
		/* 19 */	 0,
		/* 1a */	 0,
		/* 1b */	 0,
		/* 1c */	49,
		/* 1d */	 0,
		/* 1e */	 0,
		/* 1f */	 0,
		/* 20 */	 0,
		/* 21 */	 0,
		/* 22 */	 0,
		/* 23 */	 0,
		/* 24 */	 0,
		/* 25 */	 0,
		/* 26 */	 0,
		/* 27 */	13,
		/* 28 */	14,
		/* 29 */	 0,
		/* 2a */	15,
		/* 2b */	 0,
		/* 2c */	 0,
		/* 2d */	 0,
		/* 2e */	 0,
		/* 2f */	 0,
		/* 30 */	 0,
		/* 31 */	 0,
		/* 32 */	 0,
		/* 33 */	 0,
		/* 34 */	 0,
		/* 35 */	 0,
		/* 36 */	 0,
		/* 37 */	 0,
		/* 38 */	 0,
		/* 39 */	22,
		/* 3a */	23,
		/* 3b */	24,
		/* 3c */	25,
		/* 3d */	26,
		/* 3e */	27,
		/* 3f */	28,
		/* 40 */	29,
		/* 41 */	30,
		/* 42 */	31,
		/* 43 */	32,
		/* 44 */	33,
		/* 45 */	34,
		/* 46 */	35,
		/* 47 */	36,
		/* 48 */	 0,
		/* 49 */	 0,
		/* 4a */	 0,
		/* 4b */	 0,
		/* 4c */	 0,
		/* 4d */	 0,
		/* 4e */	 0,
		/* 4f */	 0,
		/* 50 */	50,
		/* 51 */	 0,
		/* 52 */	 0,
		/* 53 */	 0,
		/* 54 */	 0,
		/* 55 */	 0,
		/* 56 */	 0,
		/* 57 */	 0,
		/* 58 */	 0,
		/* 59 */	 0,
		/* 5a */	37,
		/* 5b */	37,
		/* 5c */	38,
		/* 5d */	38,
		/* 5e */	 0,
		/* 5f */	 0,
		/* 60 */	39,
		/* 61 */	40,
		/* 62 */	 0,
		/* 63 */	 0,
		/* 64 */	 0,
		/* 65 */	 0,
		/* 66 */	 0,
		/* 67 */	 0,
		/* 68 */	 0,
		/* 69 */	 0,
		/* 6a */	 0,
		/* 6b */	 0,
		/* 6c */	 0,
		/* 6d */	 0,
		/* 6e */	 0,
		/* 6f */	 0,
		/* 70 */	 0,
		/* 71 */	 0,
		/* 72 */	 0,
		/* 73 */	 0,
		/* 74 */	 0,
		/* 75 */	 0,
		/* 76 */	 0,
		/* 77 */	 0,
		/* 78 */	 0,
		/* 79 */	 0,
		/* 7a */	 0,
		/* 7b */	 0,
		/* 7c */	 0,
		/* 7d */	 0,
		/* 7e */	 0,
		/* 7f */	 0,
		/* 80 */	 0,
		/* 81 */	 0,
		/* 82 */	 0,
		/* 83 */	 0,
		/* 84 */	 0,
		/* 85 */	 0,
		/* 86 */	 0,
		/* 87 */	 0,
		/* 88 */	 0,
		/* 89 */	 0,
		/* 8a */	 0,
		/* 8b */	51,
		/* 8c */	52,
		/* 8d */	53,
		/* 8e */	41,
		/* 8f */	42,
		/* 90 */	43,
		/* 91 */	44,
		/* 92 */	45,
		/* 93 */	46,
		/* 94 */	47,
		/* 95 */	 0,
		/* 96 */	 0,
		/* 97 */	 0,
		/* 98 */	 0,
		/* 99 */	 0,
		/* 9a */	 0,
		/* 9b */	 0,
		/* 9c */	 0,
		/* 9d */	 0,
		/* 9e */	 0,
		/* 9f */	 0,
		/* a0 */	 0,
		/* a1 */	 0,
		/* a2 */	 0,
		/* a3 */	 0,
		/* a4 */	 0,
		/* a5 */	55,
		/* a6 */	 0,
		/* a7 */	 0,
		/* a8 */	 0,
		/* a9 */	 0,
		/* aa */	 0,
		/* ab */	 0,
		/* ac */	 0,
		/* ad */	 0,
		/* ae */	 0,
		/* af */	 0,
		/* b0 */	 0,
		/* b1 */	 0,
		/* b2 */	 0,
		/* b3 */	 0,
		/* b4 */	 0,
		/* b5 */	 0,
		/* b6 */	 0,
		/* b7 */	 0,
		/* b8 */	 0,
		/* b9 */	 0,
		/* ba */	 0,
		/* bb */	 0,
		/* bc */	 0,
		/* bd */	 0,
		/* be */	 0,
		/* bf */	 0,
		/* c0 */	 0,
		/* c1 */	 0,
		/* c2 */	 0,
		/* c3 */	 0,
		/* c4 */	 0,
		/* c5 */	 0,
		/* c6 */	 0,
		/* c7 */	 0,
		/* c8 */	 0,
		/* c9 */	 0,
		/* ca */	 0,
		/* cb */	 0,
		/* cc */	 0,
		/* cd */	 0,
		/* ce */	 0,
		/* cf */	 0,
		/* d0 */	 0,
		/* d1 */	 0,
		/* d2 */	 0,
		/* d3 */	 0,
		/* d4 */	 0,
		/* d5 */	37,
		/* d6 */	26,
		/* d7 */	 0,
		/* d8 */	 8,
		/* d9 */	 0,
		/* da */	 0,
	};

	assert(sizeof(tbl_range_index) / sizeof(tbl_range_index[0]) == NUM_SPELL);

	/* ̊ef[^i[obt@mۂ */
	if ((buf_spelldata = malloc(sizeof(spelldata_t) * NUM_SPELL)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ̃_[W͈̓f[^ǂݍ */
	for (i = 0; i < NUM_SPELLRANGE; i++)
	{
		unsigned char buf[SIZEOF_SPELLRANGE];

		file_read_sfc(buf, FILEPOS_SPELLRANGE + SIZEOF_SPELLRANGE * i, SIZEOF_SPELLRANGE);

		tbl_range[i].range_min = buf[0];
		if (tbl_range[i].range_min == 254)	/* ʈ */
			tbl_range[i].range_min = 300;

		tbl_range[i].range_max = tbl_range[i].range_min;
		if (buf[1] > 0)
			tbl_range[i].range_max = tbl_range[i].range_min + buf[1] - 1;
	}

	/* ̊ef[^ǂݍ */
	for (i = 0; i < NUM_SPELL; i++)
	{
		unsigned char byte;

		file_read_sfc(&byte, FILEPOS_SPELLMP + SIZEOF_SPELLMP * i, SIZEOF_SPELLMP);

		/* lnf[^ */
		buf_spelldata[i].magic_power = byte;

		assert(tbl_range_index[i] < sizeof(tbl_range) / sizeof(tbl_range[0]));

		buf_spelldata[i].range_min = tbl_range[tbl_range_index[i]].range_min;
		buf_spelldata[i].range_max = tbl_range[tbl_range_index[i]].range_max;
	}

	return buf_spelldata;
}

int spell_writeparam(const char *ptr_filename, const spelldata_t *ptr_spelldata)
{
	int i;
	FILE *fp = NULL;

	/* `FbN */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spelldata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ̐lnf[^o͂t@CJ */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ̐lnf[^o͂ */
	fprintf(fp, "No.      O               "
				"MP ŏl ől\n");
	for (i = 0; i < NUM_SPELL; i++)
	{
		fprintf(fp, "%03d(%02X): %-16s :  %5d, %5d, %5d\n", i, i,
				spell_getname(i),
				ptr_spelldata[i].magic_power,
				ptr_spelldata[i].range_min,
				ptr_spelldata[i].range_max);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
