/*
 *	dq6decode.c
 *		Copyright (C)2001-2004 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "dq6decode.h"

/* hSNGXgVI̕R[h\(VXep) */
static const char *tbl_charcode[] =
{
	" ",  " ",  "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "H",  "M",  "P",  "G",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z",
	"\", "^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z",
	"}", "~", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"b", "", "", "", "@", "B", "F", "H", "[", "?",  "!",  "", "", "", "B", ".",
	"u", "c", "/",  "K", "J", ":",  "Ex", "Lv", "\", "*",  "", ".",  "A",  "B",  "C",  "D",
	"E",  "F",  "G",  "H",  "I",  "J",  "K",  "L",  "M",  "N",  "O",  "P",  "Q",  "R",  "S",  "T",
	"U",  "V",  "W",  "X",  "Y",  "Z",  "", "", "", "", "E",  "", "", "", "", "",
	"", "", "", "", "", "", "", "`", "+",  " ",  "U", "C", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "K", "M",
	"O", "Q", "S", "U", "W", "Y", "[", "]", "_", "a", "d", "f", "h", "o", "r", "u",
	"", "{", "", "", "", "", "", "p", "s", "v", "y", "|", "`", "", "+",  "",
};

/* hSNGXgVI̕R[h\(bZ[Wp) */
static const char *tbl_charcode_mes[] =
{
	/* 0x00 */
	" ",  "", "", "", "", "", "", "h", "i", "j", "p", "", "", "g", "h", "j",
	"s", "t", "w", "z", "{", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "K", "P", "W", "X", "\", "a", "i", "n", "",
	"", "", "", "", "", "", "", "", "", "@", "E", "K", "R", "V", "Y", "[",
	"]", "h", "k", "v", "{", "t", "v", "w", "z", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "B", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "C", "E", "F", "G", "O", "R", "g", "i", "m",
	"o", "w", "y", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "W", "Y", "`", "b", "i", "n", "o", "v", "y", "|", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "@", "C", "F", "G", "M", "P", "R", "S", "V", "Z",
	"`", "c", "q", "v", "x", "z", "{", "}", "~", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "D", "F",

	/* 0x01 */
	"K", "L", "U", "X", "`", "l", "q", "r", "s", "z", "~", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "@", "A", "N", "P", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "L", "M", "N", "O", "", "", "C", "F", "[", "\", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "A", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "H", "J", "S", "V", "^", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"E", "Q", "U", "Y", "a", "c", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "D", "I", "O", "R", "S", "g", "n", "o", "p",
	"q", "s", "u", "x", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "C", "G", "I", "K", "M",
	"T", "W", "Z", "\", "d", "h", "j", "o", "p", "t", "", "", "", "", "", "",

	/* 0x02 */
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "F", "H", "M", "Q", "T", "V",
	"X", "[", "^", "_", "e", "g", "i", "f", "g", "m", "q", "z", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "E", "I", "N", "P", "T", "Y", "Z", "a", "c", "f", "i",
	"j", "k", "", "", "", "", "", "", "G", "I", "J", "N", "S", "X", "\", "]",
	"_", "`", "a", "l", "m", "n", "p", "u", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "f", "k", "n", "o", "r", "s",
	"w", "x", "y", "z", "{", "|", "}", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"E", "^", "_", "a", "b", "", "", "", "", "", "", "\", "^", "a", "c", "d",
	"l", "m", "o", "p", "r", "t", "x", "z", "{", "~", "", "", "D", "E", "F", "L",
	"R", "U", "V", "Y", "[", "0",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "g", "",
	"1",  "A",  "H",  "K",  "N",  "Q",  "R",  "T",  "V",  "Z",  "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "m", "q", "", "", "B",  "E",  "F",  "L", 

	/* 0x03 */
	"O",  "P",  "S",  "", "", "", "", "", "", "", "", "~", "", "C",  "D",  "G", 
	"J",  "*",  "", "I",  "M",  "W",  "X",  "Y",  "+",  "", "", "", "", "", "", "",
	"", "", "", "", "Z", "", "", "", "", "", "", "H", "", "M", "", "",
	"U",  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "A", "V", "c", "e", "", "", "e",  "l",  "(",  ")",  "A", "B", ".",  "E", "",
	"?",  "!",  "", "E", "J", "d", "X", "~", "[", "`", "", "/",  "10", "", "", "",
	"", "M", "Q", "S", "U", "Y", "]", "_", "a", "d", "o", "p", "r", "u", "v", "x",
	"{", "|", "", "c", "\"", "t", "w", "u", "v", "x", "", "B", "-",  "", "%",  "",
	"", "", "I", "L", "P", "`", "i", "", "", "", "i", "b", "l", "", "~", "",
	"n", "", "", "", "", "C", "", "S", "s", "", "", "", "", "", "[]", "",
	"", "", "", "", "", "J", "K", "", "", "K", "O", "T", "l", "s", "z", "",
	"", "Z", "", "", "", "", "A", "L", "N", "", "", "", "", "", "c", "",
	"", "", "", "", "R", "", "", "", "", "", "R", "", "", "", "", "",
	"", "M", "d", "m", "v", "w", "~", "", "", "", "", "", "S", "}", "V", "c",
	"", "H", "J", "v", "", "", "", "H", "b", "", "", "", "", "", "`", "",
	"", "", "", "", "", "e", "", "@", "", "", "", "t", "", "", "n", "",

	/* 0x04 */
	"", "N", "", "b", "", "", "", "\", "", "", "n", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "W", "[", "f", "", "", "", "",
	"", "", "", "@", "", "G", "", "}", "", "", "", ":",  "R", "X", "\", "k",
	"t", "", "", "", "", "", "C", "N", "^", "h", "F", "j", "", "w", "y", "",
	"", "", "", "E", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
};

/* nt}f[^pe[u */
struct hufftbl_t
{
	int flag_term;	/* I[tO */
	int value;		/* R[h(I[) / ̃CfbNXl(p) */
};

/* nt}f[^pe[u(rbgON) */
static const struct hufftbl_t tbl_decode_on[] =
{
	{1, 0x03ee},	/* K */
	{1, 0x03f0},	/* T */
	{1, 0x0635},	/*  */
	{1, 0x063f},	/*  */
	{1, 0x0642},	/*  */
	{1, 0x040a},	/*  */
	{1, 0x02f3},	/*  */
	{1, 0x0418},	/*  */
	{1, 0x0221},	/*  */
	{1, 0x02ff},	/* F */
	{1, 0x00df},
	{1, 0x0436},	/*  */
	{1, 0x030b},	/*  */
	{1, 0x043f},	/*  */
	{1, 0x0312},	/*  */
	{1, 0x0275},	/*  */
	{1, 0x0454},	/*  */
	{1, 0x045c},	/* a */
	{1, 0x046b},	/* N */
	{1, 0x0325},	/*  */
	{1, 0x0476},	/* p */
	{1, 0x0282},	/*  */
	{1, 0x0334},	/*  */
	{1, 0x0335},	/*  */
	{1, 0x0493},	/* z */
	{1, 0x049e},	/*  */
	{1, 0x04a4},	/*  */
	{1, 0x0232},	/*  */
	{1, 0x04ac},	/*  */
	{1, 0x028d},	/* g */
	{1, 0x0348},	/* F */
	{1, 0x034c},	/*  */
	{1, 0x04be},	/* c */
	{1, 0x04c8},	/* { */
	{1, 0x04d1},	/* U */
	{1, 0x035c},	/*  */
	{1, 0x029b},	/*  */
	{1, 0x0361},	/*  */
	{1, 0x029f},	/*  */
	{1, 0x04fd},	/* E */
	{1, 0x0373},	/*  */
	{1, 0x0375},	/*  */
	{1, 0x0376},	/*  */
	{1, 0x02aa},	/* n */
	{1, 0x0241},	/*  */
	{1, 0x0385},	/*  */
	{1, 0x038a},	/*  */
	{1, 0x038c},	/*  */
	{1, 0x038e},	/*  */
	{1, 0x0392},	/* U */
	{1, 0x0569},	/* d */
	{1, 0x020f},	/* j */
	{1, 0x0580},	/*  */
	{1, 0x024a},	/* E */
	{1, 0x058e},	/* ~ */
	{1, 0x03a8},	/*  */
	{1, 0x024d},	/* V */
	{1, 0x059d},	/*  */
	{1, 0x02c6},	/* @ */
	{1, 0x05b4},	/*  */
	{1, 0x05ba},	/*  */
	{1, 0x05bc},	/*  */
	{1, 0x02cd},	/* S */
	{1, 0x05cc},	/*  */
	{1, 0x03c9},	/*  */
	{1, 0x03ca},	/*  */
	{1, 0x05e2},	/* J */
	{1, 0x0216},	/*  */
	{1, 0x05f1},	/*  */
	{1, 0x05f3},	/*  */
	{1, 0x03d9},	/*  */
	{1, 0x0600},	/*  */
	{1, 0x0603},	/* b */
	{1, 0x02dd},	/*  */
	{1, 0x02e1},	/*  */
	{0,     18},
	{0,      0},
	{1, 0x021b},	/*  */
	{0,      1},
	{1, 0x02f2},	/*  */
	{1, 0x02fa},	/*  */
	{0,      6},
	{1, 0x026c},	/*  */
	{1, 0x042a},	/* q */
	{1, 0x042f},	/*  */
	{1, 0x0271},	/* B */
	{0,     11},
	{1, 0x0444},	/*  */
	{1, 0x0225},	/*  */
	{1, 0x044c},	/*  */
	{1, 0x0452},	/*  */
	{0,     13},
	{1, 0x0278},	/*  */
	{1, 0x031c},	/* A */
	{1, 0x0464},	/*  */
	{0,     16},
	{0,     38},
	{1, 0x0326},	/*  */
	{1, 0x0330},	/*  */
	{0,     20},
	{1, 0x048d},	/* o */
	{1, 0x0337},	/*  */
	{1, 0x049d},	/*  */
	{1, 0x0231},	/*  */
	{0,     26},
	{0,     24},
	{0,     28},
	{0,     29},
	{0,     32},
	{1, 0x04c7},	/* z */
	{0,     31},
	{0,     33},
	{1, 0x04dd},	/* 9 */
	{1, 0x029a},	/*  */
	{0,     36},
	{0,     35},
	{0,     44},
	{1, 0x036d},	/*  */
	{1, 0x0516},	/* X */
	{0,     39},
	{1, 0x0529},	/*  */
	{0,     41},
	{1, 0x02ac},	/* v */
	{0,     42},
	{1, 0x0386},	/*  */
	{0,     48},
	{0,     46},
	{1, 0x02b8},	/*  */
	{0,     50},
	{1, 0x057e},	/* % */
	{0,     51},
	{1, 0x0593},	/*  */
	{0,     63},
	{1, 0x03aa},	/*  */
	{1, 0x059b},	/*  */
	{1, 0x05a3},	/*  */
	{0,     55},
	{0,     56},
	{0,     59},
	{0,     62},
	{0,     60},
	{0,     61},
	{0,     68},
	{1, 0x00c7},
	{1, 0x02d5},	/* z */
	{1, 0x03d4},	/*  */
	{0,     67},
	{0,     72},
	{0,     70},
	{1, 0x03e6},	/*  */
	{1, 0x03ef},	/* M */
	{1, 0x02eb},	/*  */
	{1, 0x02ef},	/*  */
	{1, 0x0264},	/*  */
	{1, 0x0411},	/*  */
	{1, 0x0222},	/*  */
	{1, 0x030a},	/* ~ */
	{1, 0x0448},	/*  */
	{1, 0x031b},	/* @ */
	{1, 0x047c},	/*  */
	{1, 0x0481},	/*  */
	{1, 0x0490},	/* w */
	{1, 0x04cb},	/*  */
	{1, 0x0357},	/*  */
	{1, 0x04e1},	/* A */
	{1, 0x0365},	/*  */
	{1, 0x036a},	/*  */
	{1, 0x051a},	/*  */
	{1, 0x02a7},	/* ` */
	{1, 0x0540},	/*  */
	{1, 0x0389},	/*  */
	{1, 0x020e},	/* h */
	{1, 0x03a2},	/*  */
	{1, 0x05a1},	/*  */
	{1, 0x03be},	/* o */
	{1, 0x05fe},	/* n */
	{1, 0x02de},	/*  */
	{0,     77},
	{0,     76},
	{0,     81},
	{1, 0x040e},	/*  */
	{0,     78},
	{0,     79},
	{1, 0x0304},	/* ` */
	{0,     86},
	{0,     84},
	{0,     85},
	{0,     87},
	{0,     88},
	{1, 0x045e},	/* f */
	{1, 0x0461},	/* k */
	{0,     92},
	{0,     95},
	{1, 0x0477},	/* u */
	{0,     98},
	{1, 0x0489},	/*  */
	{0,    103},
	{0,     99},
	{1, 0x0342},	/* M */
	{0,    101},
	{0,    108},
	{0,    105},
	{1, 0x034e},	/*  */
	{0,    106},
	{1, 0x0294},	/*  */
	{0,    109},
	{0,    110},
	{1, 0x0207},	/* h */
	{0,    111},
	{0,    115},
	{0,    130},
	{0,    116},
	{0,    122},
	{0,    118},
	{0,    121},
	{0,    125},
	{0,    123},
	{0,    127},
	{1, 0x039b},	/*  */
	{1, 0x039f},	/*  */
	{0,    128},
	{0,    135},
	{1, 0x02c1},	/*  */
	{0,    131},
	{0,    134},
	{0,    136},
	{0,    139},
	{1, 0x0255},	/* t */
	{0,    144},
	{0,    143},
	{1, 0x05fc},	/*  */
	{1, 0x02dc},	/*  */
	{0,    147},
	{1, 0x03f8},	/* p */
	{0,    150},
	{1, 0x02f9},	/*  */
	{1, 0x0433},	/*  */
	{1, 0x0226},	/*  */
	{1, 0x027e},	/*  */
	{1, 0x048c},	/* n */
	{1, 0x0349},	/* [ */
	{1, 0x0239},	/* W */
	{1, 0x02a5},	/* W */
	{1, 0x0384},	/*  */
	{1, 0x0574},	/* " */
	{1, 0x02bc},	/*  */
	{1, 0x0595},	/* C */
	{1, 0x03ba},	/* R */
	{1, 0x03c7},	/*  */
	{1, 0x0258},	/* z */
	{0,    151},
	{1, 0x02ec},	/*  */
	{1, 0x0263},	/*  */
	{1, 0x040f},	/*  */
	{1, 0x0301},	/* L */
	{0,    154},
	{1, 0x0450},	/*  */
	{1, 0x0279},	/*  */
	{0,    159},
	{0,    158},
	{1, 0x04b2},	/* _ */
	{1, 0x0205},	/*  */
	{1, 0x028f},	/* m */
	{1, 0x04bb},	/* \ */
	{0,    160},
	{1, 0x04e2},	/* H */
	{0,    163},
	{1, 0x0372},	/*  */
	{1, 0x02a6},	/* Y */
	{0,    168},
	{0,    167},
	{1, 0x02b4},	/*  */
	{1, 0x02b6},	/*  */
	{0,    170},
	{1, 0x0212},	/* w */
	{0,    175},
	{1, 0x03dc},	/*  */
	{1, 0x0218},	/*  */
	{1, 0x03fc},	/*  */
	{0,    177},
	{1, 0x0455},	/* E */
	{1, 0x0327},	/*  */
	{1, 0x032f},	/*  */
	{1, 0x0346},	/*  */
	{1, 0x04d3},	/* Y */
	{1, 0x05d6},	/* ~ */
	{1, 0x00d1},
	{1, 0x038f},	/*  */
	{1, 0x02bd},	/*  */
	{1, 0x05c9},	/*  */
	{1, 0x03c6},	/*  */
	{1, 0x0602},	/*  */
	{1, 0x02e0},	/*  */
	{0,    180},
	{1, 0x02f6},	/*  */
	{1, 0x0419},	/*  */
	{1, 0x0306},	/* q */
	{0,    184},
	{0,    183},
	{0,    186},
	{1, 0x031d},	/* N */
	{1, 0x027a},	/*  */
	{0,    188},
	{0,    191},
	{1, 0x032c},	/*  */
	{0,    207},
	{0,    192},
	{0,    195},
	{1, 0x04ab},	/*  */
	{0,    200},
	{1, 0x0353},	/*  */
	{0,    201},
	{0,    203},
	{0,    205},
	{1, 0x023b},	/* \ */
	{0,    213},
	{0,    210},
	{0,    232},
	{0,    214},
	{0,    216},
	{1, 0x03a6},	/*  */
	{1, 0x02c0},	/*  */
	{0,    221},
	{0,    222},
	{1, 0x05c5},	/*  */
	{0,    223},
	{1, 0x0257},	/* w */
	{0,    227},
	{1, 0x02d9},	/*  */
	{1, 0x0605},	/*  */
	{1, 0x03fa},	/*  */
	{1, 0x02f4},	/*  */
	{1, 0x043d},	/*  */
	{1, 0x031e},	/* P */
	{1, 0x0331},	/*  */
	{1, 0x0230},	/*  */
	{1, 0x0359},	/*  */
	{1, 0x0399},	/*  */
	{1, 0x0597},	/* S */
	{1, 0x03cd},	/*  */
	{1, 0x0269},	/*  */
	{1, 0x0587},	/*  */
	{1, 0x0435},	/*  */
	{0,    235},
	{0,    237},
	{0,    238},
	{1, 0x049c},	/*  */
	{1, 0x0356},	/*  */
	{1, 0x023a},	/* X */
	{0,    249},
	{0,    241},
	{1, 0x0387},	/*  */
	{0,    244},
	{1, 0x03a3},	/*  */
	{0,    246},
	{1, 0x05e6},	/*  */
	{1, 0x05ef},	/*  */
	{0,    250},
	{1, 0x0426},	/* i */
	{1, 0x03d6},	/*  */
	{1, 0x0445},	/*  */
	{1, 0x04b0},	/* E */
	{1, 0x0290},	/* o */
	{1, 0x04d2},	/* V */
	{1, 0x0514},	/* M */
	{1, 0x05d9},	/*  */
	{1, 0x03fb},	/*  */
	{0,    277},
	{1, 0x02fc},	/*  */
	{0,    252},
	{1, 0x02d8},	/* ~ */
	{1, 0x026e},	/*  */
	{0,    256},
	{0,    255},
	{1, 0x0281},	/*  */
	{0,    265},
	{0,    258},
	{0,    260},
	{0,    261},
	{0,    263},
	{1, 0x036c},	/*  */
	{0,    272},
	{0,    268},
	{0,    269},
	{0,    271},
	{0,    276},
	{0,    275},
	{1, 0x02e3},	/*  */
	{1, 0x0261},	/*  */
	{1, 0x0430},	/*  */
	{1, 0x0332},	/*  */
	{1, 0x04a2},	/*  */
	{1, 0x0291},	/* w */
	{1, 0x0296},	/*  */
	{1, 0x02ae},	/* | */
	{1, 0x055f},	/*  */
	{1, 0x0599},	/*  */
	{1, 0x0634},	/*  */
	{0,    285},
	{0,    278},
	{1, 0x032d},	/*  */
	{0,    281},
	{1, 0x04bd},	/* a */
	{0,    283},
	{1, 0x00c3},
	{0,    291},
	{1, 0x05bd},	/*  */
	{1, 0x05c8},	/*  */
	{1, 0x05cf},	/*  */
	{0,    290},
	{1, 0x0432},	/*  */
	{1, 0x0322},	/*  */
	{1, 0x0362},	/*  */
	{1, 0x02d7},	/* } */
	{0,    294},
	{1, 0x021d},	/*  */
	{0,    293},
	{0,    296},
	{0,    297},
	{0,    298},
	{0,    299},
	{1, 0x00b0},
	{1, 0x0480},	/*  */
	{0,    304},
	{0,    312},
	{0,    305},
	{0,    309},
	{0,    310},
	{0,    320},
	{0,    315},
	{1, 0x02b7},	/*  */
	{0,    329},
	{0,    318},
	{0,    323},
	{0,    328},
	{0,    325},
	{1, 0x02db},	/*  */
	{1, 0x03f5},	/* h */
	{1, 0x02f7},	/*  */
	{1, 0x048f},	/* s */
	{1, 0x0344},	/* O */
	{1, 0x03e1},	/*  */
	{1, 0x05dd},	/* } */
	{1, 0x0428},	/* g */
	{1, 0x044e},	/*  */
	{0,    331},
	{1, 0x03cc},	/*  */
	{0,    339},
	{1, 0x0378},	/* J */
	{1, 0x0382},	/*  */
	{0,    335},
	{1, 0x02bb},	/*  */
	{1, 0x05a6},	/* K */
	{1, 0x03c2},	/* u */
	{1, 0x0421},	/* [ */
	{0,    340},
	{1, 0x0323},	/*  */
	{1, 0x0339},	/*  */
	{1, 0x0390},	/* E */
	{1, 0x0572},	/*  */
	{0,    356},
	{0,    341},
	{0,    343},
	{0,    347},
	{0,    345},
	{0,    344},
	{1, 0x04d0},	/* R */
	{1, 0x0370},	/*  */
	{0,    349},
	{0,    350},
	{0,    351},
	{0,    355},
	{1, 0x05eb},	/*  */
	{1, 0x03df},	/*  */
	{1, 0x0262},	/*  */
	{1, 0x0511},	/* * */
	{1, 0x037f},	/*  */
	{0,    357},
	{1, 0x042e},	/*  */
	{1, 0x0468},	/* G */
	{0,    362},
	{0,    361},
	{1, 0x0623},	/* @ */
	{1, 0x03b4},	/*  */
	{0,    364},
	{1, 0x03f1},	/* W */
	{1, 0x063c},	/*  */
	{1, 0x0316},	/*  */
	{1, 0x0463},	/*  */
	{1, 0x00d0},
	{1, 0x03d0},	/*  */
	{0,    369},
	{0,    366},
	{0,    367},
	{0,    370},
	{1, 0x02c3},	/*  */
	{0,    374},
	{1, 0x05e0},	/*  */
	{0,    376},
	{0,    375},
	{0,    377},
	{0,    383},
	{0,    379},
	{0,    382},
	{1, 0x03bd},	/* n */
	{1, 0x05b7},	/* L */
	{0,    385},
	{0,    387},
	{1, 0x04c5},	/* t */
	{1, 0x0596},	/*  */
	{1, 0x0244},	/*  */
	{1, 0x05b8},	/* N */
	{1, 0x0457},	/* N */
	{0,    392},
	{1, 0x062f},	/* k */
	{1, 0x04c9},	/* ~ */
	{0,    396},
	{0,    393},
	{0,    395},
	{0,    397},
	{1, 0x0495},	/* | */
	{1, 0x024e},	/* Y */
	{1, 0x0598},	/* s */
	{0,    398},
	{0,    409},
	{1, 0x04b1},	/* ^ */
	{0,    402},
	{0,    403},
	{0,    404},
	{0,    405},
	{0,    407},
	{1, 0x0236},	/*  */
	{1, 0x0467},	/*  */
	{1, 0x02fb},	/*  */
	{1, 0x043a},	/*  */
	{0,    411},
	{1, 0x04b8},	/*  */
	{0,    413},
	{0,    412},
	{1, 0x03d3},	/*  */
	{1, 0x0485},	/*  */
	{1, 0x0400},	/*  */
	{0,    419},
	{0,    416},
	{0,    426},
	{0,    421},
	{0,    422},
	{1, 0x04d8},	/* 4 */
	{0,    436},
	{0,    428},
	{0,    430},
	{0,    432},
	{1, 0x03e2},	/*  */
	{0,    433},
	{0,    437},
	{1, 0x0413},	/*  */
	{1, 0x0498},	/*  */
	{1, 0x05f0},	/*  */
	{1, 0x0314},	/*  */
	{1, 0x043e},	/*  */
	{1, 0x0472},	/* a */
	{1, 0x022f},	/*  */
	{0,    440},
	{0,    441},
	{1, 0x03e8},	/*  */
	{1, 0x0431},	/*  */
	{1, 0x0499},	/*  */
	{1, 0x02b1},	/*  */
	{0,    444},
	{1, 0x043b},	/*  */
	{0,    446},
	{0,    445},
	{0,    447},
	{0,    450},
	{0,    448},
	{1, 0x05bb},	/*  */
	{0,    452},
	{1, 0x026d},	/*  */
	{0,    454},
	{1, 0x058b},	/* b */
	{0,    457},
	{1, 0x0406},	/*  */
	{0,    459},
	{0,    458},
	{1, 0x05f9},	/*  */
	{1, 0x0391},	/* Q */
	{0,    460},
	{0,    461},
	{0,    462},
	{0,    465},
	{0,    467},
	{0,    466},
	{1, 0x0576},	/* w */
	{0,    468},
	{0,    470},
	{1, 0x03e9},	/*  */
	{1, 0x041f},	/* V */
	{1, 0x0267},	/*  */
	{1, 0x02bf},	/*  */
	{1, 0x0407},	/*  */
	{0,    476},
	{1, 0x02d4},	/* x */
	{0,    478},
	{0,    477},
	{0,    479},
	{1, 0x0367},	/*  */
	{0,    482},
	{1, 0x0401},	/*  */
	{1, 0x0238},	/* P */
	{1, 0x0424},	/* e */
	{0,    486},
	{0,    490},
	{1, 0x03ed},	/* I */
	{0,    491},
	{0,    492},
	{0,    496},
	{0,    494},
	{0,    497},
	{1, 0x0297},	/*  */
	{1, 0x04f8},	/* m */
	{0,    502},
	{0,    501},
	{0,    504},
	{0,    505},
	{0,    507},
	{1, 0x03a4},	/*  */
	{1, 0x03b5},	/*  */
	{0,    508},
	{1, 0x0633},	/*  */
	{0,    510},
	{1, 0x00b3},
	{1, 0x04b5},	/*  */
	{1, 0x04cd},	/* E */
	{0,    515},
	{0,    513},
	{0,    514},
	{0,    517},
	{1, 0x039c},	/*  */
	{1, 0x046d},	/* X */
	{1, 0x023c},	/* a */
	{1, 0x025d},	/*  */
	{0,    519},
	{0,    521},
	{1, 0x0379},	/* S */
	{1, 0x0442},	/*  */
	{1, 0x0250},	/* ] */
	{0,    526},
	{0,    530},
	{0,    525},
	{1, 0x02a3},	/*  */
	{1, 0x0213},	/* z */
	{0,    528},
	{1, 0x03c8},	/*  */
	{0,    532},
	{0,    531},
	{1, 0x0203},	/*  */
	{1, 0x04d7},	/* 3 */
	{0,    538},
	{0,    533},
	{1, 0x0292},	/* y */
	{0,    537},
	{1, 0x028b},	/* O */
	{0,    539},
	{0,    540},
	{0,    551},
	{0,    542},
	{0,    544},
	{0,    546},
	{0,    553},
	{0,    550},
	{0,    554},
	{1, 0x0305},	/* l */
	{1, 0x03de},	/*  */
	{1, 0x02ea},	/*  */
	{0,    558},
	{0,    559},
	{0,    561},
	{0,    563},
	{1, 0x044b},	/*  */
	{1, 0x05b1},	/* Z */
	{0,    567},
	{0,    568},
	{1, 0x033d},	/*  */
	{1, 0x063d},	/* w */
	{0,    576},
	{0,    570},
	{0,    571},
	{0,    572},
	{1, 0x05ad},	/* s */
	{0,    577},
	{0,    578},
	{0,    580},
	{1, 0x03e7},	/*  */
	{1, 0x05b3},	/*  */
	{0,    584},
	{0,    582},
	{1, 0x0202},	/*  */
	{1, 0x00ce},
	{0,    585},
	{0,    586},
	{0,    595},
	{0,    587},
	{0,    591},
	{0,    590},
	{0,    593},
	{0,    596},
	{1, 0x04d6},	/* 2 */
	{1, 0x022e},	/*  */
	{0,    599},
	{1, 0x0381},	/*  */
	{1, 0x0248},	/*  */
	{1, 0x058a},	/* i */
	{0,    603},
	{0,    605},
	{0,    607},
	{1, 0x02f1},	/*  */
	{0,    609},
	{1, 0x05a4},	/*  */
	{0,    612},
	{1, 0x02d2},	/* q */
	{1, 0x03b7},	/* D */
	{1, 0x03b1},	/*  */
	{1, 0x0402},	/*  */
	{0,    614},
	{0,    615},
	{0,    617},
	{0,    616},
	{0,    620},
	{0,    622},
	{0,    626},
	{1, 0x00cc},
	{1, 0x0559},	/* ` */
	{1, 0x04b3},	/* a */
	{0,    629},
	{1, 0x00b2},
	{0,    628},
	{0,    632},
	{1, 0x0475},	/* n */
	{1, 0x05d7},	/*  */
	{0,    634},
	{1, 0x035e},	/*  */
	{0,    635},
	{1, 0x0277},	/*  */
	{0,    638},
	{0,    637},
	{1, 0x0245},	/*  */
	{1, 0x060b},	/*  */
	{1, 0x00da},
	{1, 0x0425},	/* g */
	{1, 0x0561},	/* M */
	{0,    641},
	{1, 0x04c3},	/* p */
	{1, 0x0543},	/* c */
	{0,    645},
	{0,    644},
	{0,    648},
	{0,    647},
	{0,    649},
	{1, 0x0343},	/* N */
	{1, 0x0215},	/*  */
	{1, 0x059f},	/*  */
	{0,    653},
	{1, 0x03cf},	/*  */
	{1, 0x0604},	/*  */
	{1, 0x056e},	/* v */
	{1, 0x0625},	/* G */
	{1, 0x04e0},	/* 1 */
	{0,    657},
	{0,    658},
	{0,    661},
	{0,    663},
	{1, 0x05db},	/*  */
	{0,    666},
	{0,    667},
	{0,    668},
	{0,    671},
	{0,    672},
	{0,    675},
	{0,    676},
	{0,    677},
	{1, 0x0266},	/*  */
	{1, 0x03b3},	/*  */
	{1, 0x0471},	/* ` */
	{0,    681},
	{1, 0x0562},	/* Q */
	{1, 0x0512},	/*  */
	{0,    684},
	{0,    685},
	{0,    687},
	{0,    689},
	{0,    691},
	{0,    692},
	{0,    696},
	{0,    697},
	{0,    699},
	{1, 0x05cd},	/*  */
	{0,    700},
	{1, 0x03cb},	/*  */
	{0,    702},
	{0,    704},
	{1, 0x025b},	/*  */
	{1, 0x0553},	/* E */
	{0,    707},
	{0,    708},
	{1, 0x060a},	/* n */
	{0,    711},
	{1, 0x055e},	/*  */
	{0,    714},
	{1, 0x00c0},
	{1, 0x05dc},	/* S */
	{0,    718},
	{0,    719},
	{0,    721},
	{0,    723},
	{0,    725},
	{0,    726},
	{1, 0x062e},	/* \ */
	{1, 0x056d},	/* u */
	{0,    731},
	{1, 0x05a7},	/*  */
	{0,    735},
	{0,    736},
	{0,    737},
	{0,    738},
	{0,    739},
	{0,    740},
	{0,    743},
	{1, 0x060f},	/*  */
	{0,    744},
	{0,    747},
	{1, 0x05aa},	/* O */
	{0,    749},
	{0,    751},
	{1, 0x00ca},
	{0,    754},
	{0,    753},
	{0,    755},
	{0,    757},
	{1, 0x047a},	/*  */
	{1, 0x00ae},
	{1, 0x0254},	/* { */
	{0,    762},
	{0,    764},
	{1, 0x0544},	/* e */
	{0,    767},
	{1, 0x0610},	/*  */
	{1, 0x03e3},	/*  */
	{1, 0x0280},	/*  */
	{0,    771},
	{1, 0x036f},	/*  */
	{1, 0x0631},	/*  */
	{0,    774},
	{0,    775},
	{1, 0x04b4},	/* b */
	{1, 0x0567},	/* _ */
	{1, 0x0423},	/* _ */
	{1, 0x059a},	/*  */
	{0,    779},
	{0,    780},
	{0,    782},
	{1, 0x0615},	/*  */
	{1, 0x05d3},	/* m */
	{1, 0x05d4},	/* v */
	{0,    786},
	{0,    789},
	{1, 0x0224},	/*  */
	{1, 0x00db},
	{0,    793},
	{1, 0x0440},	/*  */
	{0,    795},
	{1, 0x061c},	/*  */
	{0,    799},
	{0,    798},
	{1, 0x0354},	/*  */
	{0,    801},
	{0,    802},
	{1, 0x051f},	/*  */
	{1, 0x05ab},	/* T */
	{0,    804},
	{0,    805},
	{0,    806},
	{1, 0x00de},
	{0,    808},
	{0,    809},
	{1, 0x0617},	/*  */
	{0,    811},
	{1, 0x0451},	/*  */
	{0,    813},
	{0,    815},
	{1, 0x057b},	/* B */
	{1, 0x0484},	/*  */
	{0,    817},
	{0,    820},
	{1, 0x057d},	/*  */
	{0,    822},
	{1, 0x0619},	/* W */
	{0,    825},
	{0,    827},
	{0,    828},
	{1, 0x063b},	/* j */
	{0,    831},
	{0,    833},
	{0,    835},
	{0,    837},
	{0,    838},
	{0,    840},
	{1, 0x0638},	/* ^ */
	{1, 0x02c7},	/* C */
	{1, 0x0582},	/* I */
	{1, 0x053c},	/*  */
	{0,    844},
	{0,    846},
	{0,    847},
	{0,    848},
	{1, 0x05ae},	/* z */
	{0,    850},
	{1, 0x04de},	/* g */
	{0,    853},
	{0,    855},
	{0,    857},
	{0,    858},
	{1, 0x03c4},	/*  */
	{1, 0x00c9},
	{0,    860},
	{0,    862},
	{0,    864},
	{1, 0x057a},	/*  */
	{0,    865},
	{0,    866},
	{1, 0x0541},	/* A */
	{0,    869},
	{0,    871},
	{0,    873},
	{1, 0x0613},	/*  */
	{1, 0x0525},	/*  */
	{0,    877},
	{1, 0x058c},	/* l */
	{0,    879},
	{0,    880},
	{0,    882},
	{0,    884},
	{0,    885},
	{0,    887},
	{0,    889},
	{0,    891},
	{0,    893},
	{0,    894},
	{0,    895},
	{0,    897},
	{1, 0x0616},	/*  */
	{0,    900},
	{1, 0x062d},	/* X */
	{0,    903},
	{0,    905},
	{1, 0x0637},	/* N */
	{1, 0x05e8},	/* b */
	{0,    909},
	{0,    910},
	{0,    912},
	{1, 0x0537},	/*  */
	{0,    915},
	{1, 0x0639},	/* h */
	{0,    918},
	{0,    920},
	{0,    922},
	{0,    924},
	{0,    925},
	{0,    926},
	{0,    928},
	{1, 0x04f5},	/*  */
	{0,    931},
	{0,    933},
	{0,    935},
	{0,    937},
	{0,    939},
	{0,    941},
	{1, 0x051c},	/*  */
	{1, 0x052c},	/*  */
	{0,    945},
	{1, 0x0628},	/*  */
	{1, 0x0535},	/*  */
	{0,    949},
	{1, 0x053d},	/*  */
	{0,    952},
	{1, 0x0550},	/* ? */
	{0,    955},
	{1, 0x0532},	/*  */
	{1, 0x0624},	/*  */
	{0,    958},
	{0,    959},
	{0,    960},
	{0,    961},
	{0,    963},
	{0,    964},
	{0,    966},
	{0,    968},
	{1, 0x050a},	/*  */
	{0,    970},
	{0,    972},
	{1, 0x04ee},	/*  */
	{1, 0x0558},	/* [ */
	{0,    975},
	{0,    977},
	{0,    979},
	{0,    981},
	{1, 0x0505},	/*  */
	{1, 0x00d4},
	{0,    983},
	{0,    984},
	{0,    985},
	{0,    987},
	{0,    988},
	{1, 0x0522},	/*  */
	{0,    990},
	{1, 0x0551},	/* ! */
	{1, 0x0539},	/*  */
	{1, 0x0531},	/*  */
	{1, 0x04f2},	/*  */
	{0,    994},
	{1, 0x055d},	/*  */
	{0,    996},
	{1, 0x061f},	/*  */
	{1, 0x00af},
	{0,    999},
	{1, 0x0508},	/*  */
	{1, 0x04f0},	/*  */
	{1, 0x0629},	/*  */
	{0,   1002},
	{0,   1003},
	{1, 0x0534},	/*  */
	{1, 0x00ac},
	{0,   1006},
	{0,   1008},
	{0,   1010},
	{0,   1011},
	{0,   1013},
	{0,   1015},
	{1, 0x053a},	/*  */
	{1, 0x0538},	/*  */
	{0,   1019},
	{0,   1020},
	{1, 0x054c},	/* B */
	{0,   1023},
	{0,   1024},
	{0,   1026},
	{0,   1028},
	{0,   1030},
	{0,   1032},
	{0,   1034},
	{0,   1036},
	{0,   1038},
	{1, 0x00ad},
	{0,   1041},
	{0,   1043},
	{0,   1045},
	{0,   1046},
	{0,   1048},
	{0,   1050},
	{0,   1052},
	{0,   1054},
	{0,   1056},
	{0,   1058},
	{0,   1060},
	{0,   1062},
};

/* nt}f[^pe[u(rbgOFF) */
static const struct hufftbl_t tbl_decode_off[] =
{
	{1, 0x03ec},	/* G */
	{1, 0x025e},	/*  */
	{1, 0x02e7},	/*  */
	{1, 0x03f9},	/* t */
	{1, 0x0640},	/*  */
	{1, 0x0403},	/*  */
	{1, 0x040b},	/*  */
	{1, 0x0416},	/*  */
	{1, 0x041e},	/* T */
	{1, 0x026b},	/*  */
	{1, 0x0427},	/* f */
	{1, 0x042d},	/*  */
	{1, 0x0437},	/*  */
	{1, 0x00e0},
	{1, 0x0272},	/*  */
	{1, 0x00e1},
	{1, 0x0227},	/*  */
	{1, 0x031a},	/*  */
	{1, 0x027c},	/*  */
	{1, 0x046c},	/* S */
	{1, 0x027d},	/*  */
	{1, 0x047e},	/*  */
	{1, 0x0487},	/*  */
	{1, 0x048a},	/* f */
	{1, 0x0285},	/*  */
	{1, 0x033a},	/*  */
	{1, 0x028a},	/* G */
	{1, 0x0340},	/*  */
	{1, 0x028c},	/* R */
	{1, 0x04ae},	/*  */
	{1, 0x0233},	/*  */
	{1, 0x04ba},	/*  */
	{1, 0x034d},	/*  */
	{1, 0x04c4},	/* r */
	{1, 0x0352},	/*  */
	{1, 0x04d4},	/* [ */
	{1, 0x04e6},	/* R */
	{1, 0x0360},	/*  */
	{1, 0x029c},	/*  */
	{1, 0x0368},	/*  */
	{1, 0x02a1},	/*  */
	{1, 0x0374},	/*  */
	{1, 0x023e},	/* n */
	{1, 0x02a8},	/* b */
	{1, 0x052d},	/* M */
	{1, 0x053f},	/*  */
	{1, 0x02b0},	/*  */
	{1, 0x038b},	/*  */
	{1, 0x0557},	/* ~ */
	{1, 0x0246},	/*  */
	{1, 0x0394},	/* a */
	{1, 0x0397},	/*  */
	{1, 0x039e},	/*  */
	{1, 0x0581},	/*  */
	{1, 0x03a5},	/*  */
	{1, 0x024c},	/* R */
	{1, 0x0211},	/* t */
	{1, 0x03ac},	/*  */
	{1, 0x024f},	/* [ */
	{1, 0x03b6},	/*  */
	{1, 0x02c9},	/* G */
	{1, 0x02ca},	/* M */
	{1, 0x02cb},	/* P */
	{1, 0x0253},	/* v */
	{1, 0x05d1},	/* M */
	{1, 0x05da},	/*  */
	{1, 0x05df},	/* c */
	{1, 0x05e4},	/*  */
	{1, 0x05ec},	/*  */
	{1, 0x05f2},	/*  */
	{1, 0x05f6},	/*  */
	{1, 0x0259},	/*  */
	{1, 0x0601},	/* N */
	{1, 0x025a},	/*  */
	{1, 0x060d},	/*  */
	{0,     74},
	{0,      8},
	{0,      3},
	{1, 0x03ff},	/*  */
	{0,      2},
	{0,      4},
	{0,      7},
	{0,      5},
	{1, 0x0429},	/* m */
	{0,     12},
	{0,      9},
	{0,     10},
	{1, 0x0273},	/*  */
	{1, 0x0311},	/*  */
	{0,     17},
	{1, 0x0276},	/*  */
	{0,     14},
	{1, 0x0458},	/* P */
	{1, 0x045b},	/* Z */
	{1, 0x0462},	/*  */
	{1, 0x0321},	/*  */
	{0,     15},
	{0,     21},
	{1, 0x022c},	/*  */
	{1, 0x0482},	/*  */
	{0,     19},
	{0,     27},
	{0,     22},
	{0,     23},
	{1, 0x04a6},	/*  */
	{0,     25},
	{0,     30},
	{1, 0x0234},	/*  */
	{1, 0x04c1},	/* m */
	{1, 0x04c6},	/* x */
	{1, 0x0351},	/*  */
	{0,     37},
	{1, 0x035a},	/*  */
	{1, 0x0299},	/*  */
	{0,     34},
	{1, 0x029d},	/*  */
	{0,     54},
	{1, 0x0209},	/* j */
	{1, 0x036e},	/*  */
	{0,     40},
	{1, 0x02a9},	/* i */
	{1, 0x037c},	/*  */
	{1, 0x037e},	/*  */
	{0,     43},
	{1, 0x02ad},	/* y */
	{0,     45},
	{0,     47},
	{1, 0x0396},	/*  */
	{0,     53},
	{1, 0x039a},	/*  */
	{0,     49},
	{0,     52},
	{0,     73},
	{0,     58},
	{1, 0x03ab},	/*  */
	{1, 0x00c5},
	{1, 0x03b0},	/*  */
	{0,     57},
	{1, 0x00d6},
	{1, 0x02cc},	/* R */
	{1, 0x0214},	/* { */
	{1, 0x03c5},	/*  */
	{1, 0x02d1},	/* c */
	{0,     64},
	{1, 0x05e1},	/* H */
	{0,     66},
	{0,     65},
	{1, 0x03d7},	/*  */
	{0,     69},
	{1, 0x03e5},	/*  */
	{0,     71},
	{1, 0x02e8},	/*  */
	{1, 0x0641},	/*  */
	{1, 0x0409},	/*  */
	{1, 0x040c},	/*  */
	{1, 0x042b},	/* z */
	{1, 0x0309},	/* z */
	{1, 0x0438},	/*  */
	{1, 0x0318},	/*  */
	{1, 0x0473},	/* l */
	{1, 0x047d},	/*  */
	{1, 0x0284},	/*  */
	{1, 0x034f},	/*  */
	{1, 0x0355},	/*  */
	{1, 0x035d},	/*  */
	{1, 0x04e8},	/* V */
	{1, 0x04ff},	/* L */
	{1, 0x050d},	/* C */
	{1, 0x020a},	/* p */
	{1, 0x020b},	/*  */
	{1, 0x02af},	/*  */
	{1, 0x054f},	/*  */
	{1, 0x0393},	/* Y */
	{1, 0x0210},	/* s */
	{1, 0x05c0},	/*  */
	{1, 0x02d0},	/* ` */
	{1, 0x060c},	/* j */
	{1, 0x060e},	/*  */
	{0,     75},
	{1, 0x021c},	/*  */
	{1, 0x00dc},
	{1, 0x021e},	/*  */
	{0,     80},
	{0,     82},
	{0,     94},
	{1, 0x030f},	/*  */
	{0,     83},
	{1, 0x0313},	/*  */
	{0,     90},
	{0,     89},
	{0,     93},
	{0,     91},
	{0,    114},
	{1, 0x0470},	/* _ */
	{1, 0x027f},	/*  */
	{0,     96},
	{0,     97},
	{1, 0x049a},	/*  */
	{0,    100},
	{0,    102},
	{1, 0x0345},	/*  */
	{1, 0x04b9},	/*  */
	{1, 0x04bc},	/* ^ */
	{0,    104},
	{0,    107},
	{1, 0x0295},	/*  */
	{1, 0x04db},	/* 7 */
	{0,    113},
	{0,    112},
	{0,    117},
	{1, 0x050f},	/* G */
	{0,    149},
	{1, 0x0377},	/* H */
	{0,    119},
	{0,    120},
	{1, 0x054b},	/* A */
	{1, 0x02b3},	/*  */
	{0,    124},
	{0,    126},
	{1, 0x039d},	/*  */
	{0,    129},
	{0,    140},
	{0,    133},
	{1, 0x059c},	/*  */
	{0,    132},
	{1, 0x05b9},	/*  */
	{0,    137},
	{0,    138},
	{0,    141},
	{0,    142},
	{1, 0x05f5},	/* e */
	{0,    148},
	{0,    145},
	{0,    146},
	{1, 0x02ed},	/*  */
	{1, 0x0408},	/*  */
	{1, 0x0307},	/* r */
	{1, 0x0434},	/*  */
	{1, 0x046f},	/* ] */
	{1, 0x0478},	/*  */
	{1, 0x048e},	/* r */
	{1, 0x04b6},	/*  */
	{1, 0x0369},	/*  */
	{1, 0x0383},	/*  */
	{1, 0x020d},	/* g */
	{1, 0x057f},	/*  */
	{1, 0x0588},	/*  */
	{1, 0x02c2},	/*  */
	{1, 0x05d0},	/*  */
	{1, 0x02d3},	/* v */
	{1, 0x02da},	/*  */
	{0,    165},
	{0,    157},
	{0,    153},
	{1, 0x0220},	/*  */
	{0,    152},
	{0,    155},
	{0,    156},
	{1, 0x0466},	/*  */
	{1, 0x022d},	/*  */
	{1, 0x0338},	/*  */
	{0,    161},
	{1, 0x034a},	/* \ */
	{0,    164},
	{1, 0x04ce},	/* F */
	{0,    162},
	{1, 0x0208},	/* i */
	{0,    166},
	{1, 0x02cf},	/* Z */
	{0,    176},
	{1, 0x02ab},	/* o */
	{0,    171},
	{0,    169},
	{1, 0x03a1},	/*  */
	{0,    173},
	{0,    172},
	{1, 0x03da},	/*  */
	{0,    174},
	{1, 0x03f3},	/* \ */
	{1, 0x0647},	/*  */
	{1, 0x0317},	/*  */
	{1, 0x046a},	/* J */
	{1, 0x0328},	/*  */
	{1, 0x033e},	/*  */
	{1, 0x0206},	/*  */
	{1, 0x04da},	/* 6 */
	{1, 0x05d5},	/* w */
	{1, 0x0380},	/*  */
	{1, 0x0247},	/*  */
	{1, 0x05c4},	/* R */
	{1, 0x03c3},	/* x */
	{1, 0x03d2},	/*  */
	{1, 0x03dd},	/*  */
	{0,    190},
	{1, 0x040d},	/*  */
	{0,    178},
	{0,    179},
	{0,    181},
	{0,    182},
	{0,    189},
	{0,    185},
	{1, 0x045f},	/* i */
	{0,    187},
	{0,    198},
	{1, 0x032b},	/*  */
	{1, 0x047f},	/*  */
	{0,    193},
	{0,    194},
	{0,    196},
	{0,    197},
	{0,    199},
	{0,    202},
	{0,    204},
	{0,    206},
	{0,    219},
	{0,    209},
	{0,    208},
	{0,    212},
	{0,    211},
	{0,    215},
	{0,    218},
	{0,    217},
	{0,    225},
	{0,    220},
	{1, 0x03b8},	/* I */
	{0,    224},
	{0,    228},
	{0,    231},
	{0,    226},
	{0,    229},
	{0,    230},
	{0,    233},
	{1, 0x041d},	/* Q */
	{1, 0x0310},	/*  */
	{1, 0x0469},	/* I */
	{1, 0x0492},	/* y */
	{1, 0x0204},	/*  */
	{1, 0x037d},	/*  */
	{1, 0x03a7},	/*  */
	{1, 0x05a8},	/*  */
	{1, 0x05e5},	/*  */
	{0,    236},
	{0,    234},
	{1, 0x0453},	/*  */
	{1, 0x027b},	/*  */
	{0,    240},
	{1, 0x0488},	/*  */
	{1, 0x04a8},	/*  */
	{0,    239},
	{0,    245},
	{1, 0x0528},	/*  */
	{1, 0x0242},	/*  */
	{0,    242},
	{1, 0x05c7},	/*  */
	{0,    243},
	{0,    247},
	{0,    248},
	{1, 0x02e2},	/*  */
	{1, 0x02fd},	/*  */
	{1, 0x0302},	/* U */
	{1, 0x0441},	/*  */
	{1, 0x02d6},	/* { */
	{1, 0x0347},	/* C */
	{1, 0x04cf},	/* L */
	{1, 0x0501},	/* P */
	{1, 0x0592},	/*  */
	{1, 0x03f4},	/* d */
	{0,    253},
	{1, 0x041a},	/* F */
	{1, 0x0420},	/* X */
	{1, 0x03fd},	/*  */
	{0,    251},
	{1, 0x0443},	/*  */
	{0,    254},
	{0,    257},
	{1, 0x0483},	/*  */
	{1, 0x0494},	/* { */
	{0,    259},
	{0,    262},
	{0,    264},
	{1, 0x02a2},	/*  */
	{0,    266},
	{0,    267},
	{0,    270},
	{1, 0x057c},	/* - */
	{0,    273},
	{1, 0x00d8},
	{0,    274},
	{1, 0x021a},	/*  */
	{1, 0x05f7},	/* @ */
	{1, 0x030e},	/*  */
	{1, 0x04a0},	/*  */
	{1, 0x04a3},	/*  */
	{1, 0x0358},	/*  */
	{1, 0x052a},	/*  */
	{1, 0x00c4},
	{1, 0x03a0},	/*  */
	{1, 0x05be},	/* c */
	{0,    292},
	{0,    279},
	{0,    280},
	{1, 0x032e},	/*  */
	{0,    282},
	{0,    284},
	{0,    287},
	{0,    286},
	{1, 0x03ae},	/*  */
	{0,    288},
	{1, 0x03c1},	/* s */
	{0,    289},
	{1, 0x03f6},	/* j */
	{1, 0x0447},	/*  */
	{1, 0x028e},	/* i */
	{1, 0x05a2},	/*  */
	{1, 0x0594},	/*  */
	{0,    301},
	{1, 0x0412},	/*  */
	{0,    295},
	{1, 0x044a},	/*  */
	{0,    308},
	{0,    300},
	{0,    302},
	{1, 0x0479},	/*  */
	{0,    307},
	{0,    303},
	{0,    306},
	{1, 0x0293},	/*  */
	{0,    311},
	{0,    313},
	{0,    316},
	{0,    314},
	{0,    317},
	{0,    319},
	{0,    321},
	{0,    322},
	{0,    326},
	{0,    324},
	{0,    327},
	{1, 0x0410},	/*  */
	{0,    330},
	{1, 0x0336},	/*  */
	{1, 0x020c},	/*  */
	{1, 0x02c8},	/* F */
	{1, 0x0219},	/*  */
	{0,    332},
	{1, 0x05ee},	/* ` */
	{0,    334},
	{0,    333},
	{0,    337},
	{1, 0x00d2},
	{1, 0x0556},	/* X */
	{0,    336},
	{1, 0x03af},	/*  */
	{1, 0x03b2},	/*  */
	{0,    338},
	{1, 0x0223},	/*  */
	{1, 0x0446},	/*  */
	{1, 0x05e3},	/* v */
	{1, 0x04dc},	/* 8 */
	{1, 0x0566},	/* ] */
	{1, 0x05fb},	/* t */
	{0,    342},
	{1, 0x0201},	/*  */
	{1, 0x0632},	/*  */
	{1, 0x04a1},	/*  */
	{1, 0x04ad},	/*  */
	{1, 0x00c1},
	{0,    346},
	{1, 0x037b},	/* ^ */
	{0,    348},
	{0,    352},
	{1, 0x05a0},	/*  */
	{0,    354},
	{0,    353},
	{1, 0x02e5},	/*  */
	{1, 0x0646},	/*  */
	{1, 0x0527},	/*  */
	{0,    365},
	{0,    358},
	{0,    359},
	{0,    360},
	{1, 0x04c0},	/* l */
	{1, 0x035b},	/*  */
	{0,    363},
	{1, 0x03bb},	/* S */
	{1, 0x03eb},	/* C */
	{1, 0x025f},	/*  */
	{1, 0x044d},	/*  */
	{1, 0x045d},	/* c */
	{1, 0x0283},	/*  */
	{1, 0x02ce},	/* V */
	{1, 0x02df},	/*  */
	{0,    372},
	{1, 0x0300},	/* K */
	{0,    368},
	{0,    371},
	{0,    378},
	{1, 0x049f},	/*  */
	{1, 0x04aa},	/*  */
	{1, 0x04cc},	/* D */
	{1, 0x052b},	/* H */
	{0,    386},
	{0,    380},
	{0,    381},
	{1, 0x0251},	/* h */
	{1, 0x0237},	/* K */
	{0,    373},
	{0,    384},
	{1, 0x04a9},	/*  */
	{1, 0x0398},	/*  */
	{1, 0x02a4},	/*  */
	{1, 0x05b2},	/*  */
	{0,    388},
	{1, 0x0324},	/*  */
	{0,    390},
	{0,    389},
	{0,    391},
	{1, 0x052e},	/*  */
	{0,    394},
	{1, 0x02f5},	/*  */
	{1, 0x0465},	/*  */
	{1, 0x034b},	/*  */
	{1, 0x0243},	/*  */
	{1, 0x03d1},	/*  */
	{1, 0x0422},	/* ^ */
	{0,    399},
	{0,    400},
	{0,    401},
	{1, 0x03a9},	/*  */
	{0,    408},
	{0,    406},
	{1, 0x054e},	/* E */
	{1, 0x038d},	/*  */
	{0,    410},
	{1, 0x02c5},	/*  */
	{1, 0x043c},	/*  */
	{1, 0x05fd},	/*  */
	{1, 0x0364},	/* A */
	{1, 0x05c1},	/*  */
	{0,    414},
	{1, 0x049b},	/*  */
	{1, 0x0217},	/*  */
	{1, 0x0417},	/*  */
	{0,    415},
	{0,    418},
	{0,    420},
	{0,    423},
	{0,    424},
	{0,    425},
	{0,    431},
	{0,    427},
	{0,    429},
	{0,    417},
	{0,    435},
	{0,    434},
	{1, 0x02ee},	/*  */
	{1, 0x042c},	/*  */
	{1, 0x03d5},	/*  */
	{1, 0x0333},	/*  */
	{1, 0x05a5},	/* J */
	{0,    442},
	{0,    438},
	{0,    439},
	{1, 0x0607},	/* \ */
	{1, 0x03e0},	/*  */
	{1, 0x02e4},	/*  */
	{1, 0x022b},	/*  */
	{1, 0x0363},	/*  */
	{1, 0x0571},	/* | */
	{1, 0x04b7},	/*  */
	{1, 0x030c},	/*  */
	{0,    443},
	{1, 0x052f},	/*  */
	{0,    453},
	{0,    449},
	{0,    451},
	{1, 0x0256},	/* v */
	{1, 0x02f8},	/*  */
	{1, 0x0229},	/*  */
	{1, 0x0388},	/*  */
	{1, 0x05b5},	/*  */
	{1, 0x0643},	/* E */
	{0,    455},
	{0,    456},
	{1, 0x0579},	/* x */
	{1, 0x0235},	/*  */
	{1, 0x0395},	/* c */
	{0,    473},
	{0,    463},
	{0,    464},
	{0,    469},
	{1, 0x0240},	/*  */
	{1, 0x02b2},	/*  */
	{1, 0x02be},	/*  */
	{0,    472},
	{0,    471},
	{1, 0x0268},	/*  */
	{1, 0x033f},	/*  */
	{1, 0x0560},	/*  */
	{0,    474},
	{1, 0x02fe},	/* D */
	{0,    475},
	{1, 0x0491},	/* x */
	{1, 0x05f4},	/*  */
	{0,    481},
	{0,    480},
	{0,    484},
	{0,    483},
	{0,    485},
	{0,    487},
	{1, 0x044f},	/*  */
	{0,    488},
	{0,    489},
	{1, 0x03d8},	/*  */
	{1, 0x041b},	/* H */
	{0,    493},
	{1, 0x00cd},
	{0,    495},
	{0,    498},
	{0,    499},
	{0,    506},
	{0,    500},
	{0,    503},
	{1, 0x05de},	/* V */
	{1, 0x0439},	/*  */
	{1, 0x035f},	/*  */
	{1, 0x05d8},	/*  */
	{1, 0x026a},	/*  */
	{0,    511},
	{0,    509},
	{1, 0x026f},	/*  */
	{1, 0x022a},	/*  */
	{1, 0x0289},	/* F */
	{1, 0x05fa},	/*  */
	{0,    518},
	{0,    512},
	{0,    516},
	{1, 0x0405},	/*  */
	{1, 0x063e},	/* y */
	{1, 0x04af},	/*  */
	{1, 0x05ce},	/*  */
	{0,    520},
	{0,    522},
	{1, 0x03f2},	/* Z */
	{0,    523},
	{1, 0x023d},	/* i */
	{1, 0x0260},	/*  */
	{1, 0x02ba},	/*  */
	{1, 0x0249},	/* @ */
	{0,    524},
	{1, 0x0252},	/* k */
	{0,    527},
	{0,    529},
	{1, 0x04d9},	/* 5 */
	{1, 0x0270},	/*  */
	{1, 0x05c3},	/*  */
	{1, 0x05ca},	/* R */
	{1, 0x05d2},	/* d */
	{0,    536},
	{0,    534},
	{0,    535},
	{1, 0x0449},	/*  */
	{1, 0x025c},	/*  */
	{1, 0x03bf},	/* p */
	{0,    541},
	{0,    547},
	{0,    543},
	{0,    545},
	{0,    548},
	{0,    549},
	{0,    552},
	{1, 0x0460},	/* j */
	{0,    555},
	{0,    556},
	{0,    557},
	{1, 0x02f0},	/*  */
	{0,    564},
	{0,    560},
	{0,    562},
	{0,    566},
	{0,    565},
	{1, 0x030d},	/*  */
	{1, 0x04a5},	/*  */
	{1, 0x041c},	/* M */
	{0,    569},
	{1, 0x04a7},	/*  */
	{0,    573},
	{1, 0x05c2},	/*  */
	{0,    575},
	{0,    574},
	{1, 0x0350},	/*  */
	{0,    579},
	{1, 0x00bb},
	{1, 0x036b},	/*  */
	{0,    581},
	{1, 0x0274},	/*  */
	{1, 0x061a},	/* [ */
	{0,    583},
	{1, 0x05ea},	/*  */
	{1, 0x0287},	/* C */
	{1, 0x00cf},
	{0,    588},
	{0,    589},
	{0,    592},
	{0,    594},
	{1, 0x0614},	/*  */
	{0,    598},
	{0,    597},
	{0,    601},
	{0,    600},
	{0,    602},
	{1, 0x033c},	/*  */
	{0,    604},
	{0,    606},
	{1, 0x03fe},	/*  */
	{0,    608},
	{1, 0x04fb},	/*  */
	{0,    610},
	{0,    611},
	{1, 0x0308},	/* s */
	{1, 0x03bc},	/* g */
	{1, 0x047b},	/*  */
	{0,    613},
	{1, 0x063a},	/* F */
	{1, 0x032a},	/*  */
	{0,    623},
	{0,    618},
	{0,    619},
	{0,    621},
	{1, 0x0622},	/*  */
	{0,    624},
	{1, 0x0404},	/*  */
	{0,    625},
	{1, 0x05b6},	/* A */
	{0,    627},
	{1, 0x0524},	/* Z */
	{1, 0x04f9},	/* q */
	{0,    631},
	{0,    630},
	{0,    636},
	{0,    633},
	{1, 0x0415},	/*  */
	{1, 0x0591},	/*  */
	{1, 0x03ce},	/*  */
	{1, 0x0645},	/*  */
	{0,    639},
	{1, 0x00b5},
	{0,    640},
	{0,    642},
	{1, 0x00cb},
	{1, 0x05e7},	/* H */
	{1, 0x056b},	/* p */
	{1, 0x02e9},	/*  */
	{0,    643},
	{1, 0x037a},	/* V */
	{1, 0x03ad},	/*  */
	{0,    646},
	{0,    651},
	{0,    650},
	{1, 0x05ac},	/* l */
	{0,    652},
	{1, 0x05bf},	/*  */
	{0,    654},
	{0,    656},
	{1, 0x02b5},	/*  */
	{0,    655},
	{1, 0x0590},	/* n */
	{0,    659},
	{0,    660},
	{1, 0x0564},	/* U */
	{0,    662},
	{1, 0x0584},	/* P */
	{0,    664},
	{0,    665},
	{0,    669},
	{0,    670},
	{0,    673},
	{0,    674},
	{1, 0x0644},	/*  */
	{1, 0x056f},	/* x */
	{0,    678},
	{1, 0x05f8},	/*  */
	{0,    679},
	{0,    680},
	{1, 0x0606},	/*  */
	{0,    682},
	{0,    683},
	{0,    686},
	{0,    688},
	{1, 0x05af},	/*  */
	{0,    690},
	{0,    693},
	{0,    695},
	{0,    694},
	{0,    698},
	{1, 0x033b},	/*  */
	{1, 0x0546},	/*  */
	{1, 0x056c},	/* r */
	{0,    701},
	{0,    703},
	{1, 0x0565},	/* Y */
	{0,    705},
	{0,    706},
	{1, 0x0618},	/*  */
	{0,    709},
	{0,    710},
	{0,    713},
	{0,    712},
	{0,    715},
	{0,    716},
	{0,    717},
	{0,    720},
	{1, 0x05ff},	/*  */
	{0,    722},
	{0,    728},
	{0,    724},
	{0,    727},
	{0,    729},
	{0,    730},
	{0,    732},
	{0,    733},
	{0,    734},
	{1, 0x04d5},	/* 0 */
	{1, 0x0570},	/* { */
	{1, 0x00d3},
	{0,    741},
	{0,    742},
	{1, 0x062c},	/* R */
	{0,    745},
	{0,    746},
	{1, 0x05e9},	/*  */
	{0,    748},
	{0,    750},
	{1, 0x00d5},
	{0,    752},
	{1, 0x0589},	/*  */
	{1, 0x0585},	/* ` */
	{0,    758},
	{0,    756},
	{0,    760},
	{0,    759},
	{0,    761},
	{0,    763},
	{0,    765},
	{0,    766},
	{0,    768},
	{0,    769},
	{1, 0x0586},	/* i */
	{0,    770},
	{1, 0x053b},	/*  */
	{0,    772},
	{0,    773},
	{1, 0x056a},	/* o */
	{1, 0x0474},	/* m */
	{0,    776},
	{1, 0x0542},	/* V */
	{0,    777},
	{0,    778},
	{1, 0x0519},	/*  */
	{0,    781},
	{0,    783},
	{0,    784},
	{0,    785},
	{0,    788},
	{0,    787},
	{0,    790},
	{0,    791},
	{0,    792},
	{0,    794},
	{1, 0x03f7},	/* o */
	{0,    796},
	{1, 0x0563},	/* S */
	{0,    797},
	{0,    800},
	{1, 0x0288},	/* E */
	{1, 0x053e},	/*  */
	{1, 0x0265},	/*  */
	{0,    803},
	{1, 0x03b9},	/* O */
	{1, 0x0414},	/*  */
	{1, 0x050b},	/* ~ */
	{0,    807},
	{1, 0x0583},	/* L */
	{1, 0x0630},	/* t */
	{1, 0x05a9},	/* K */
	{0,    810},
	{1, 0x061d},	/*  */
	{0,    812},
	{0,    814},
	{0,    816},
	{1, 0x03db},	/*  */
	{0,    818},
	{0,    819},
	{1, 0x05cb},	/*  */
	{0,    821},
	{0,    823},
	{0,    824},
	{0,    826},
	{1, 0x0627},	/* } */
	{0,    829},
	{0,    830},
	{0,    832},
	{0,    834},
	{0,    836},
	{1, 0x03c0},	/* q */
	{0,    839},
	{1, 0x0315},	/*  */
	{1, 0x031f},	/*  */
	{0,    841},
	{0,    842},
	{0,    843},
	{0,    845},
	{1, 0x04df},	/*  */
	{1, 0x051d},	/*  */
	{1, 0x0486},	/*  */
	{0,    849},
	{0,    851},
	{0,    852},
	{0,    854},
	{0,    856},
	{1, 0x02b9},	/*  */
	{1, 0x061b},	/* f */
	{1, 0x051e},	/*  */
	{0,    859},
	{0,    861},
	{0,    863},
	{1, 0x0611},	/*  */
	{1, 0x0612},	/*  */
	{1, 0x00d9},
	{0,    867},
	{0,    868},
	{0,    870},
	{0,    872},
	{0,    874},
	{0,    875},
	{0,    876},
	{0,    878},
	{1, 0x0554},	/* J */
	{1, 0x062a},	/*  */
	{0,    881},
	{0,    883},
	{1, 0x04fa},	/*  */
	{0,    886},
	{0,    888},
	{0,    890},
	{0,    892},
	{1, 0x0520},	/*  */
	{1, 0x0521},	/*  */
	{0,    896},
	{0,    898},
	{0,    899},
	{0,    901},
	{0,    902},
	{0,    904},
	{0,    906},
	{0,    907},
	{0,    908},
	{1, 0x0636},	/* C */
	{0,    911},
	{0,    913},
	{0,    914},
	{0,    916},
	{0,    917},
	{0,    919},
	{0,    921},
	{0,    923},
	{1, 0x0526},	/*  */
	{1, 0x0545},	/*  */
	{0,    927},
	{0,    929},
	{0,    930},
	{0,    932},
	{0,    934},
	{0,    936},
	{0,    938},
	{0,    940},
	{0,    942},
	{0,    943},
	{0,    944},
	{0,    946},
	{0,    947},
	{0,    948},
	{0,    950},
	{0,    951},
	{0,    953},
	{0,    954},
	{1, 0x0507},	/*  */
	{0,    956},
	{0,    957},
	{1, 0x0621},	/*  */
	{1, 0x04ed},	/*  */
	{1, 0x051b},	/*  */
	{0,    962},
	{1, 0x04ef},	/*  */
	{0,    965},
	{0,    967},
	{0,    969},
	{1, 0x0523},	/*  */
	{0,    971},
	{1, 0x0536},	/*  */
	{0,    973},
	{0,    974},
	{0,    976},
	{0,    978},
	{0,    980},
	{1, 0x0504},	/*  */
	{0,    982},
	{1, 0x0577},	/* u */
	{1, 0x04f6},	/*  */
	{1, 0x0509},	/*  */
	{0,    986},
	{1, 0x04f4},	/*  */
	{1, 0x0533},	/*  */
	{0,    989},
	{1, 0x04f3},	/*  */
	{0,    991},
	{1, 0x061e},	/*  */
	{0,    992},
	{0,    993},
	{0,    995},
	{1, 0x04f1},	/*  */
	{0,    997},
	{1, 0x0573},	/* c */
	{0,    998},
	{0,   1000},
	{1, 0x04f7},	/*  */
	{0,   1001},
	{1, 0x0503},	/*  */
	{1, 0x0506},	/*  */
	{1, 0x0626},	/*  */
	{0,   1004},
	{0,   1005},
	{0,   1007},
	{0,   1009},
	{1, 0x0620},	/*  */
	{0,   1012},
	{0,   1014},
	{0,   1016},
	{0,   1017},
	{0,   1018},
	{1, 0x0609},	/*  */
	{0,   1021},
	{0,   1022},
	{1, 0x0608},	/*  */
	{0,   1025},
	{0,   1027},
	{0,   1029},
	{0,   1031},
	{0,   1033},
	{0,   1035},
	{0,   1037},
	{0,   1039},
	{0,   1040},
	{0,   1042},
	{0,   1044},
	{1, 0x0200},	/*   */
	{0,   1047},
	{0,   1049},
	{0,   1051},
	{0,   1053},
	{0,   1055},
	{0,   1057},
	{0,   1059},
	{0,   1061},
};

static const char *str_chrname[] =
{
	"(l̖O)",
	"nbT",
	"~[",
	"o[o",
	"e[",
	"`",
	"AX",
	"[L[",
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, int flag_message)
{
	int i;
	char *buf_dstbuf = NULL;
	char *ptr_buf = NULL;
	const size_t len_buf = srcbufsize * 4;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	if (!flag_message)
	{
		for (i = 0; i < (int)srcbufsize; i++)
			strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
	}
	else
	{
		/* }`oCg͖T|[g */
		assert(0);
	}

	/* ̋󔒂 */
	while ((ptr_buf = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr_buf + 1) == '\0')
		*ptr_buf = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_message)
{
	int ch;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read  = NULL;
		return 0;
	}

	/* fR[h */
	if (!flag_message)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		int index = 0x0427;		/* lݒ */
		assert(0x0427 == sizeof(tbl_decode_on) / sizeof(tbl_decode_on[0]) - 1);

		while ((ch = fgetc(fp_read)) != EOF)
		{
			int index_bit = 0;

			while (index_bit < 8)
			{
				/* 1rbgǂŁAQƂe[u肷 */
				const int bit = ((ch & (1U << (7 - index_bit))) != 0);
				const struct hufftbl_t *ptr_tbl = (bit) ? tbl_decode_on : tbl_decode_off;

				index_bit++;

				/* CfbNX̒l̓e[u̗vfɎ܂Ă邩? */
				assert(!bit || (0 <= index && index < sizeof(tbl_decode_on)  / sizeof(tbl_decode_on[0])));
				assert(bit  || (0 <= index && index < sizeof(tbl_decode_off) / sizeof(tbl_decode_off[0])));

				/* m肵Ȃꍇ́ACfbNXݒ肵ďp */
				if (!ptr_tbl[index].flag_term)
				{
					/* e[uQƐCfbNXݒ肷 */
					index = ptr_tbl[index].value;
					continue;
				}

				/* o͂ */
				if (ptr_tbl[index].value < 0x200)	/* R[h */
				{
					switch (ptr_tbl[index].value)
					{
					case 0xac:	/* bZ[W̏I */
					case 0xae:
						fprintf(fp_write, "\n\n");
						break;
					case 0xad:	/* s */
						fprintf(fp_write, "\n");
						break;
					case 0xaf:	/* ͑҂ */
						fprintf(fp_write, "\n");
						break;
					case 0xd4:	/* ŏ"*u"\Ȃ */
					case 0xde:
						break;
					case 0xd5:	/* EBhE */
						break;
					case 0xd6:
					case 0xe1:
						break;
					case 0xd9:	/* g[(p) */
					case 0xda:	/* g[(jp) */
					case 0xdb:	/* g[(X^[p) */
					case 0xdc:	/* g[() */
						break;
					case 0xb0:	/* EFCg */
						break;
					case 0xb2:
						fprintf(fp_write, "()");
						break;
					case 0xb3:
					case 0xc0:
					case 0xc1:
						fprintf(fp_write, "(LN^)");
						break;
					case 0xb5:
					case 0xc7:
						fprintf(fp_write, "()");
						break;
					case 0xbb:
					case 0xc5:
						fprintf(fp_write, "(l)");
						break;
					case 0xc3:
						fprintf(fp_write, "(ӂ)");
						break;
					case 0xc4:	/* ` */
						fprintf(fp_write, "()");
						break;
					case 0xdf:	/* ` */
						fprintf(fp_write, "()");
						break;
					case 0xe0:	/* ` */
						fprintf(fp_write, "(݂Ȃ)");
						break;
					case 0xd1:
						fprintf(fp_write, "(̖O)");
						break;
					case 0xd2:
						fprintf(fp_write, "(l/擪LN^̖O)");
						break;
					case 0xd3:
						fprintf(fp_write, "(擪LN^̖O)");
						break;
					case 0xd8:
						fprintf(fp_write, "(Op)");
						break;
					case 0xc9:	/* eLN^̖O */
					case 0xca:
					case 0xcb:
					case 0xcc:
					case 0xcd:
					case 0xce:
					case 0xcf:
					case 0xd0:
						{
							const int index_name = ptr_tbl[index].value - 0xc9;

							assert(sizeof(str_chrname) / sizeof(str_chrname[0]) == 8);
							assert(0 <= index_name && index_name < 8);
							fprintf(fp_write, "%s", str_chrname[index_name]);
						}
						break;
					default:
/*						fprintf(fp_write, "[%02x]", ptr_tbl[index].value);	*/
						break;
					}
				}
				else	/* ʏ̕ */
				{
					const int index_code = ptr_tbl[index].value - 0x200;

					assert(0 <= index_code && index_code < sizeof(tbl_charcode_mes) / sizeof(tbl_charcode_mes[0]));
					fprintf(fp_write, "%s", tbl_charcode_mes[index_code]);
				}

				index = 0x0427;		/* lݒ */
			}
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
