/*
 *	dq6spell.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filesfc.h"
#include "dq6define.h"
#include "dq6spell.h"

#define FILEPOS_SPELLDATA	0x08c65d
#define FILEPOS_SPELLRANGE	0x08fc9b
#define NUM_SPELL			410
#define NUM_SPELLRANGE		64
#define SIZEOF_SPELLDATA	25
#define SIZEOF_SPELLRANGE	5

static void spell_setnameindex(void);

static int tbl_spellnameindex[NUM_SPELL];	/* \̃CfbNXi[e[u */
static int flag_spellnameindex = 0;			/* tbl_spellnameindexɃf[^i[Ă邩ǂ */

const char *spell_getname(int index)
{
	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	/* e[uɒlݒ肳ĂȂꍇ́Alݒ肷 */
	if (!flag_spellnameindex)
		spell_setnameindex();

	return str_getdef(tbl_spellnameindex[index]);
}

const char *spell_getdesc(int index)
{
	static const char *str_desc[/* NUM_SPELL */] =
	{
		/* 000 */	"",
		/* 001 */	"",
		/* 002 */	"",
		/* 003 */	"",
		/* 004 */	"",
		/* 005 */	"",
		/* 006 */	"",
		/* 007 */	"",
		/* 008 */	"",
		/* 009 */	"",
		/* 00a */	"",
		/* 00b */	"",
		/* 00c */	"",
		/* 00d */	"",
		/* 00e */	"",
		/* 00f */	"",
		/* 010 */	"",
		/* 011 */	"",
		/* 012 */	"",
		/* 013 */	"",
		/* 014 */	"",
		/* 015 */	"",
		/* 016 */	"",
		/* 017 */	"",
		/* 018 */	"",
		/* 019 */	"",
		/* 01a */	"",
		/* 01b */	"",
		/* 01c */	"",
		/* 01d */	"",
		/* 01e */	"",
		/* 01f */	"",
		/* 020 */	"",
		/* 021 */	"",
		/* 022 */	"",
		/* 023 */	"",
		/* 024 */	"",
		/* 025 */	"",
		/* 026 */	"",
		/* 027 */	"",
		/* 028 */	"",
		/* 029 */	"",
		/* 02a */	"",
		/* 02b */	"",
		/* 02c */	"",
		/* 02d */	"",
		/* 02e */	"",
		/* 02f */	"",
		/* 030 */	"",
		/* 031 */	"",
		/* 032 */	"",
		/* 033 */	"",
		/* 034 */	"",
		/* 035 */	"",
		/* 036 */	"",
		/* 037 */	"",
		/* 038 */	"",
		/* 039 */	"",
		/* 03a */	"",
		/* 03b */	"",
		/* 03c */	"",
		/* 03d */	"",
		/* 03e */	"",
		/* 03f */	"",
		/* 040 */	"",
		/* 041 */	"",
		/* 042 */	"U",
		/* 043 */	"",
		/* 044 */	"",
		/* 045 */	"",
		/* 046 */	"",
		/* 047 */	"",
		/* 048 */	"",
		/* 049 */	"",
		/* 04a */	"",
		/* 04b */	" B(ꂢ̂)",
		/* 04c */	"",
		/* 04d */	"",
		/* 04e */	"",
		/* 04f */	"肩B(܂˂܂)",
		/* 050 */	"",
		/* 051 */	"",
		/* 052 */	"",
		/* 053 */	"",
		/* 054 */	"",
		/* 055 */	"",
		/* 056 */	"",
		/* 057 */	"ǂ !(KU_X)",
		/* 058 */	"",
		/* 059 */	"",
		/* 05a */	"",
		/* 05b */	"",
		/* 05c */	"",
		/* 05d */	"",
		/* 05e */	"",
		/* 05f */	"",
		/* 060 */	"",
		/* 061 */	"",
		/* 062 */	"",
		/* 063 */	"",
		/* 064 */	"",
		/* 065 */	"",
		/* 066 */	"",
		/* 067 */	"",
		/* 068 */	"",
		/* 069 */	"",
		/* 06a */	"",
		/* 06b */	"",
		/* 06c */	"",
		/* 06d */	"",
		/* 06e */	"",
		/* 06f */	"",
		/* 070 */	"",
		/* 071 */	"",
		/* 072 */	"",
		/* 073 */	"",
		/* 074 */	"",
		/* 075 */	"",
		/* 076 */	"",
		/* 077 */	"",
		/* 078 */	"",
		/* 079 */	"",
		/* 07a */	"",
		/* 07b */	"",
		/* 07c */	"",
		/* 07d */	"",
		/* 07e */	"",
		/* 07f */	"",
		/* 080 */	"",
		/* 081 */	"",
		/* 082 */	"",
		/* 083 */	"",
		/* 084 */	"",
		/* 085 */	"",
		/* 086 */	"",
		/* 087 */	"",
		/* 088 */	"",
		/* 089 */	"",
		/* 08a */	"",
		/* 08b */	"",
		/* 08c */	"",
		/* 08d */	"",
		/* 08e */	"",
		/* 08f */	"",
		/* 090 */	"",
		/* 091 */	"",
		/* 092 */	"",
		/* 093 */	"",
		/* 094 */	"",
		/* 095 */	"",
		/* 096 */	"",
		/* 097 */	"",
		/* 098 */	"",
		/* 099 */	"",
		/* 09a */	"",
		/* 09b */	"",
		/* 09c */	"",
		/* 09d */	"",
		/* 09e */	"",
		/* 09f */	"",
		/* 0a0 */	"",
		/* 0a1 */	"",
		/* 0a2 */	"",
		/* 0a3 */	"",
		/* 0a4 */	"",
		/* 0a5 */	"",
		/* 0a6 */	"",
		/* 0a7 */	"",
		/* 0a8 */	"",
		/* 0a9 */	"",
		/* 0aa */	"",
		/* 0ab */	"",
		/* 0ac */	"",
		/* 0ad */	"",
		/* 0ae */	"",
		/* 0af */	"U(̖ɑ΂)",
		/* 0b0 */	"",	/* U */
		/* 0b1 */	"ɂ!  ܂肱܂Ă܂!",
		/* 0b2 */	"肵!(~X)",
		/* 0b3 */	"X^[ gbV!",
		/* 0b4 */	"߂Ⴍ Ԃ ӂ܂킵!",
		/* 0b5 */	"傤Ă Ԃ  X^[ Ă݂!",
		/* 0b6 */	"܂  ȂƂ΂!",
		/* 0b7 */	"ǂ΂悢̂ 킩Ȃ!",
		/* 0b8 */	"킯 킩ȂȂ !",
		/* 0b9 */	"U(̖ɑ΂)",
		/* 0ba */	"Ȃ΂  Ȃ!",
		/* 0bb */	" !(̂܂ Ƃ肷 ǂ Ă܂!)",
		/* 0bc */	" 炾 Ă䂩 傭 Ȃɂ łȂ!",
		/* 0bd */	"Ԃ݂ قĂ!",
		/* 0be */	"Ȃ܂!   Ȃ!",
		/* 0bf */	"ւĂȂǂǂ!",
		/* 0c0 */	"тĂ!",
		/* 0c1 */	"ɂ!",
		/* 0c2 */	"ƂĂȂ 낵̂ тĂ܂!",
		/* 0c3 */	"GS̃qbg|CgS񕜂",
		/* 0c4 */	"GSӂU",
		/* 0c5 */	"炾 ӂ 肪 ӂ  ݂!",
		/* 0c6 */	"S̍US̈ꌂɂȂ",
		/* 0c7 */	"GS",
		/* 0c8 */	"GS̃}WbNp[0ɂȂ",
		/* 0c9 */	"̂ ₪  Ȃ݂ Ȃ  ߂ ܂!",
		/* 0ca */	"SɃhS",
		/* 0cb */	"܂̂悤  ܂ 낵 炢Ȃ Ă!",
		/* 0cc */	" Ⴍǂ肵!",
		/* 0cd */	"S̃qbg|Cg񕜂 & Ԃ",
		/* 0ce */	"GS",
		/* 0cf */	"SԂ",
		/* 0d0 */	"GS̃}WbNp[S񕜂",
		/* 0d1 */	"肢߂ Ă񂭂 イ ӂ肻!",
		/* 0d2 */	"悤 ĂB",
		/* 0d3 */	"{[bƂĂB",
		/* 0d4 */	"ǂĂ 킩ȂB",
		/* 0d5 */	"uL~ ققłB",
		/* 0d6 */	"ww ĂB",
		/* 0d7 */	"ȂɂȂ6!",
		/* 0d8 */	" ߂ĂB",
		/* 0d9 */	" 񂾁B",
		/* 0da */	"~X",
		/* 0db */	"",
		/* 0dc */	"ɍ̈ꌂ(Ú~0.9̃_[W)",
		/* 0dd */	"ɍ̈ꌂ(ʏ2.5{̃_[W)",
		/* 0de */	"U",
		/* 0df */	"ōU",
		/* 0e0 */	"}qU",
		/* 0e1 */	"_pjU",
		/* 0e2 */	"Ԃ݂Ȃ炢 ׂ ƂтĂ!!",
		/* 0e3 */	"Ղ[ ӂꂠ ̂!!",
		/* 0e4 */	"Ȃ 킵Â݂ɂ!!",
		/* 0e5 */	"ĂԂ ͂ ӂ܂킵!!",
		/* 0e6 */	"݂Ђڂ  ͂Ȃ!",
		/* 0e7 */	"炽 ܂ !",
		/* 0e8 */	"Efӂ肠 ǂc ӂ肨낵!",
		/* 0e9 */	"  ǂLo ݂!",
		/* 0ea */	"͂ Ă!!",
		/* 0eb */	"bZ[W10!",
		/* 0ec */	"ۂ ӂ܂킵!",
		/* 0ed */	"܂ ǂcm !",
		/* 0ee */	"Ȃ ӂ݂Ă!",
		/* 0ef */	"Ԃ!",
		/* 0f0 */	"߂ɂƂ܂ ͂킴!",
		/* 0f1 */	"͂ 炢Ȃ Ȃ͂!",
		/* 0f2 */	"",
		/* 0f3 */	"",
		/* 0f4 */	"",
		/* 0f5 */	"",
		/* 0f6 */	"",
		/* 0f7 */	"",
		/* 0f8 */	"ǂƂȂ  ccB()",
		/* 0f9 */	"Ȃނ ͂!",
		/* 0fa */	"Ԃ݂ 񂱂͂Ȃ",
		/* 0fb */	"  Ƃ񂵂Ă!",
		/* 0fc */	" Ȃ߂܂킵!",
		/* 0fd */	"",
		/* 0fe */	"т !",
		/* 0ff */	"炾イ ܂΂䂢 Ђ ͂Ȃ!",
		/* 100 */	"͂ Ȃ܂ т悹!",
		/* 101 */	"܂肱 ΂̃hA ߂Ă܂!",
		/* 102 */	"(l)̂ !",
		/* 103 */	"͂Ƃ!",
		/* 104 */	"ԂĂ()",
		/* 105 */	"ԂĂ(EoX^[ɍs)",
		/* 106 */	"ԂĂ(~8)",
		/* 107 */	"ԂĂ(̂ǂꂢ)",
		/* 108 */	"ԂĂ(zC~XC)",
		/* 109 */	"ԂĂ(ʂւ)",
		/* 10a */	"ԂĂ(_[Nz[)",
		/* 10b */	"ԂĂ(g)",
		/* 10c */	"ԂĂ(v̂܂)",
		/* 10d */	"ԂĂ(xz}XC)",
		/* 10e */	"ԂĂ(q[gMY)",
		/* 10f */	"ԂĂ(v̂܂)",
		/* 110 */	"ԂĂ(肳sG)",
		/* 111 */	"Ă()",
		/* 112 */	"Ă(_XLbg)",
		/* 113 */	"Ă(frA[}[)",
		/* 114 */	"sp^[ω",
		/* 115 */	"sp^[ω",
		/* 116 */	"sp^[ω",
		/* 117 */	"sp^[ω",
		/* 118 */	"sp^[ω",
		/* 119 */	"",
		/* 11a */	"sp^[ω",
		/* 11b */	"sp^[ω",
		/* 11c */	"sp^[ω",
		/* 11d */	"sp^[ω",
		/* 11e */	"Jb ߂ ݂Ђ炫 TL̂ЂƂ݂ ɂ݂!",
		/* 11f */	"͂  ق̂ ȂĂ!",
		/* 120 */	"Ă ꂢ ͂Ȃ!",
		/* 121 */	"˂񂶂 ӂ ܂ ߂!",
		/* 122 */	"Ƃ  点 Ƃ񂵂!",
		/* 123 */	"݂ 悤 ܂ т !",
		/* 124 */	"ЂƂ݂ ₵ Ђ!",
		/* 125 */	"Ƃc 킵Â ߂ ͂ !",
		/* 126 */	"߂Ƃ ̂͂߂!",
		/* 127 */	"",
		/* 128 */	"",
		/* 129 */	"",
		/* 12a */	"",
		/* 12b */	"",
		/* 12c */	"",
		/* 12d */	"",
		/* 12e */	"",
		/* 12f */	"",
		/* 130 */	"",
		/* 131 */	"",
		/* 132 */	"",
		/* 133 */	"",
		/* 134 */	"",
		/* 135 */	"",
		/* 136 */	"",
		/* 137 */	"",
		/* 138 */	"",
		/* 139 */	"",
		/* 13a */	"",
		/* 13b */	"",
		/* 13c */	"",
		/* 13d */	"",
		/* 13e */	"",
		/* 13f */	"",
		/* 140 */	"",
		/* 141 */	"",
		/* 142 */	"",
		/* 143 */	"",
		/* 144 */	"",
		/* 145 */	"",
		/* 146 */	"",
		/* 147 */	"",
		/* 148 */	"",
		/* 149 */	"",
		/* 14a */	"",
		/* 14b */	"",
		/* 14c */	"",
		/* 14d */	"",
		/* 14e */	"",
		/* 14f */	"",
		/* 150 */	"",
		/* 151 */	"",
		/* 152 */	"",
		/* 153 */	"",
		/* 154 */	"",
		/* 155 */	"",
		/* 156 */	"",
		/* 157 */	"",
		/* 158 */	"",
		/* 159 */	"",
		/* 15a */	"",
		/* 15b */	"",
		/* 15c */	"",
		/* 15d */	"",
		/* 15e */	"",
		/* 15f */	"",
		/* 160 */	"",
		/* 161 */	"",
		/* 162 */	"",
		/* 163 */	"",
		/* 164 */	"",
		/* 165 */	"",
		/* 166 */	"",
		/* 167 */	"",
		/* 168 */	"",
		/* 169 */	"",
		/* 16a */	"",
		/* 16b */	"",
		/* 16c */	"",
		/* 16d */	"",
		/* 16e */	"",
		/* 16f */	"",
		/* 170 */	"",
		/* 171 */	"",
		/* 172 */	"",
		/* 173 */	"",
		/* 174 */	"",
		/* 175 */	"",
		/* 176 */	"",
		/* 177 */	"",
		/* 178 */	"",
		/* 179 */	"",
		/* 17a */	"",
		/* 17b */	"",
		/* 17c */	"",
		/* 17d */	"",
		/* 17e */	"",
		/* 17f */	"",
		/* 180 */	"",
		/* 181 */	"",
		/* 182 */	"",
		/* 183 */	"",
		/* 184 */	"",
		/* 185 */	"",
		/* 186 */	"",
		/* 187 */	"",
		/* 188 */	"",
		/* 189 */	"",
		/* 18a */	"",
		/* 18b */	"",
		/* 18c */	"",
		/* 18d */	"",
		/* 18e */	"",
		/* 18f */	"",
		/* 190 */	"",
		/* 191 */	"",
		/* 192 */	"",
		/* 193 */	"",
		/* 194 */	"",
		/* 195 */	"",
		/* 196 */	"",
		/* 197 */	"",
		/* 198 */	"",
		/* 199 */	"",
	};

	assert(sizeof(str_desc) / sizeof(str_desc[0]) == NUM_SPELL);

	/* `FbN */
	if (index < 0 || NUM_SPELL <= index)
	{
		assert(0);
		return "";
	}

	return str_desc[index];
}

static void spell_setnameindex(void)
{
	int i;

	/* ̃CfbNXǂݍ */
	for (i = 0; i < NUM_SPELL; i++)
	{
		unsigned char buf[SIZEOF_SPELLDATA];

		file_read_sfc(buf, FILEPOS_SPELLDATA + SIZEOF_SPELLDATA * i, SIZEOF_SPELLDATA);
		tbl_spellnameindex[i] = (buf[24] << 8) | buf[23];
	}

	flag_spellnameindex = 1;
}

spelldata_t *spell_readdata(void)
{
	int i;
	spelldata_t *buf_spelldata = NULL;
	struct range_tag
	{
		int range_min_enemy;	/* Gɗ^_[W̍ŏl */
		int range_max_enemy;	/* Gɗ^_[W̍ől */
		int range_min_party;	/* 󂯂_[W̍ŏl */
		int range_max_party;	/* 󂯂_[W̍ől */
	};
	struct range_tag tbl_range[NUM_SPELLRANGE];

	/* ̊ef[^i[obt@mۂ */
	if ((buf_spelldata = malloc(sizeof(spelldata_t) * NUM_SPELL)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ̃_[W͈̓f[^ǂݍ */
	for (i = 0; i < NUM_SPELLRANGE; i++)
	{
		unsigned char buf[SIZEOF_SPELLRANGE];

		file_read_sfc(buf, FILEPOS_SPELLRANGE + SIZEOF_SPELLRANGE * i, SIZEOF_SPELLRANGE);

		tbl_range[i].range_min_enemy = ((buf[1] & 0x03) << 8) | buf[0];
		tbl_range[i].range_min_party = ((buf[2] & 0x0f) << 6) | ((buf[1] & 0xfc) >> 2);
		tbl_range[i].range_max_enemy = ((buf[3] & 0x3f) << 4) | ((buf[2] & 0xf0) >> 4);
		tbl_range[i].range_max_party = (buf[4] << 2) | ((buf[3] & 0xc0) >> 6);
	}

	/* ̊ef[^ǂݍ */
	for (i = 0; i < NUM_SPELL; i++)
	{
		unsigned char buf[SIZEOF_SPELLDATA];

		file_read_sfc(buf, FILEPOS_SPELLDATA + SIZEOF_SPELLDATA * i, SIZEOF_SPELLDATA);

		/* lnf[^ */
		buf_spelldata[i].name_index      = (buf[24] << 8) | buf[23];
		buf_spelldata[i].magic_power     = buf[ 3] & 0x3f;
		buf_spelldata[i].range_min_enemy = tbl_range[buf[11] & 0x3f].range_min_enemy;
		buf_spelldata[i].range_max_enemy = tbl_range[buf[11] & 0x3f].range_max_enemy;
		buf_spelldata[i].range_min_party = tbl_range[buf[11] & 0x3f].range_min_party;
		buf_spelldata[i].range_max_party = tbl_range[buf[11] & 0x3f].range_max_party;
	}

	return buf_spelldata;
}

int spell_writeparam(const char *ptr_filename, const spelldata_t *ptr_spelldata)
{
	int i;
	FILE *fp = NULL;

	/* `FbN */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spelldata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ̐lnf[^o͂t@CJ */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ̐lnf[^o͂ */
	fprintf(fp, "No.       O                   "
				"MP Gŏ Gő ŏ ő\n");
	for (i = 0; i < NUM_SPELL; i++)
	{
		fprintf(fp, "%03d(%03X): %-20s :  %5d, %5d, %5d, %5d, %5d\n", i, i,
				spell_getname(i),
				ptr_spelldata[i].magic_power,
				ptr_spelldata[i].range_min_enemy,
				ptr_spelldata[i].range_max_enemy,
				ptr_spelldata[i].range_min_party,
				ptr_spelldata[i].range_max_party);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
