/*
 *	ff6rndenc.c
 *		Copyright (C)2001 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define CHR_GROUP_A			'A'
#define CHR_GROUP_B			'B'
#define CHR_GROUP_C			'C'
#define CHR_GROUP_D			'D'
#define CHR_CHRMUTCH		'.'		/* Cӂ̕Ƃ̃}b` */
#define CHR_CHRCLASS_B		'['		/* NX̊Jn */
#define CHR_CHRCLASS_E		']'		/* NX̏I */

#define NUM_RANDOM			65536	/* ̎ */
#define NUM_RANDOM_TBL		256		/* \̗vf */
#define NUM_AIRFORCE		6		/* 嗤ł(XJCA[}[ & Xsbgt@CAƂ)퓬 */
#define NUM_MONPARTY_N		4		/* ʏ탉_GJEgł̃X^[p[eB̎ */
#define NUM_MONPARTY_F		2		/* ŒGƂ̃GJEgł̃X^[p[eB̎ */

#define DEF_NUM_MAXDISP		100
#define DEF_NUM_BATTLE		10
#define DEF_NUM_AIRFORCE	3

#define get_rnd(index)		((tbl_rnd[((index) % NUM_RANDOM_TBL)] + ((index) / 256) * 23) % 256)
#define is_doublet(num)		(monenc_f(num) == chr_to_index(CHR_GROUP_B))
#define make_maskbit(index)	(1U << (index))
#define index_to_chr(index)	(CHR_GROUP_A + (index))	/* ASCIIO */
#define chr_to_index(chr)	((chr) - CHR_GROUP_A)	/* ASCIIO */

static int monenc_n(int num);
static int monenc_f(int num);
static int monenc_b(int num);

/* t@Cit@^W[VI̗\ */
static const int tbl_rnd[NUM_RANDOM_TBL] =
{
	0x07, 0xb6, 0xf0, 0x1f, 0x55, 0x5b, 0x37, 0xe3, 0xae, 0x4f, 0xb2, 0x5e, 0x99, 0xf6, 0x77, 0xcb,
	0x60, 0x8f, 0x43, 0x3e, 0xa7, 0x4c, 0x2d, 0x88, 0xc7, 0x68, 0xd7, 0xd1, 0xc2, 0xf2, 0xc1, 0xdd,
	0xaa, 0x93, 0x16, 0xf7, 0x26, 0x04, 0x36, 0xa1, 0x46, 0x4e, 0x56, 0xbe, 0x6c, 0x6e, 0x80, 0xd5,
	0xb5, 0x8e, 0xa4, 0x9e, 0xe7, 0xca, 0xce, 0x21, 0xff, 0x0f, 0xd4, 0x8c, 0xe6, 0xd3, 0x98, 0x47,
	0xf4, 0x0d, 0x15, 0xed, 0xc4, 0xe4, 0x35, 0x78, 0xba, 0xda, 0x27, 0x61, 0xab, 0xb9, 0xc3, 0x7d,
	0x85, 0xfc, 0x95, 0x6b, 0x30, 0xad, 0x86, 0x00, 0x8d, 0xcd, 0x7e, 0x9f, 0xe5, 0xef, 0xdb, 0x59,
	0xeb, 0x05, 0x14, 0xc9, 0x24, 0x2c, 0xa0, 0x3c, 0x44, 0x69, 0x40, 0x71, 0x64, 0x3a, 0x74, 0x7c,
	0x84, 0x13, 0x94, 0x9c, 0x96, 0xac, 0xb4, 0xbc, 0x03, 0xde, 0x54, 0xdc, 0xc5, 0xd8, 0x0c, 0xb7,
	0x25, 0x0b, 0x01, 0x1c, 0x23, 0x2b, 0x33, 0x3b, 0x97, 0x1b, 0x62, 0x2f, 0xb0, 0xe0, 0x73, 0xcc,
	0x02, 0x4a, 0xfe, 0x9b, 0xa3, 0x6d, 0x19, 0x38, 0x75, 0xbd, 0x66, 0x87, 0x3f, 0xaf, 0xf3, 0xfb,
	0x83, 0x0a, 0x12, 0x1a, 0x22, 0x53, 0x90, 0xcf, 0x7a, 0x8b, 0x52, 0x5a, 0x49, 0x6a, 0x72, 0x28,
	0x58, 0x8a, 0xbf, 0x0e, 0x06, 0xa2, 0xfd, 0xfa, 0x41, 0x65, 0xd2, 0x4d, 0xe2, 0x5c, 0x1d, 0x45,
	0x1e, 0x09, 0x11, 0xb3, 0x5f, 0x29, 0x79, 0x39, 0x2e, 0x2a, 0x51, 0xd9, 0x5d, 0xa6, 0xea, 0x31,
	0x81, 0x89, 0x10, 0x67, 0xf5, 0xa9, 0x42, 0x82, 0x70, 0x9d, 0x92, 0x57, 0xe1, 0x3d, 0xf1, 0xf9,
	0xee, 0x08, 0x91, 0x18, 0x20, 0xb1, 0xa5, 0xbb, 0xc6, 0x48, 0x50, 0x9a, 0xd6, 0x7f, 0x7b, 0xe9,
	0x76, 0xdf, 0x32, 0x6f, 0x34, 0xa8, 0xd0, 0xb8, 0x63, 0xc8, 0xc0, 0xec, 0x4b, 0xe8, 0x17, 0xf8,
};

/* 쌠\L */
static const char *str_copyright = "ff6rndenc - Copyright (C)2001 Shingo Endo <s-endo@yk.rim.or.jp>";

int main(int argc, char **argv)
{
	int i, j;
	int rnd_index;
	int match_num;
	int encptn_num;
	int encptn_len;
	int flag_chrclass;
	int flag_parseerror;

	int max_disp_num   = DEF_NUM_MAXDISP;
	int max_battle_num = DEF_NUM_BATTLE;
	int airforce_num   = DEF_NUM_AIRFORCE;
	int flag_disp_airforce = 0;
	int flag_disp_battle   = 1;
	int flag_usage         = 0;

	char *str_encptn = NULL;
	unsigned int *tbl_encptn = NULL;
	int *tbl_doublet = NULL;
	int (*tbl_count_n)[NUM_MONPARTY_N] = NULL;
	int (*tbl_count_f)[NUM_MONPARTY_F] = NULL;

	/* mۂ */
	str_encptn  = (char *)malloc(NUM_RANDOM + 1);
	tbl_encptn  = (unsigned int *)malloc(sizeof(unsigned int) * NUM_RANDOM);
	tbl_doublet = (int *)malloc(sizeof(int) * NUM_RANDOM);
	tbl_count_n = (int (*)[NUM_MONPARTY_N])malloc(sizeof(int [NUM_MONPARTY_N]) * NUM_RANDOM);
	tbl_count_f = (int (*)[NUM_MONPARTY_F])malloc(sizeof(int [NUM_MONPARTY_F]) * NUM_RANDOM);

	if (str_encptn  == NULL ||
		tbl_encptn  == NULL ||
		tbl_doublet == NULL ||
		tbl_count_n == NULL ||
		tbl_count_f == NULL)
	{
		fprintf(stderr, "%s: sĂ܂\n", argv[0]);

		free(str_encptn);
		free(tbl_encptn);
		free(tbl_doublet);
		free(tbl_count_n);
		free(tbl_count_f);

		exit(EXIT_FAILURE);
	}

	*str_encptn = '\0';
	for (i = 0; i < NUM_RANDOM; i++)
	{
		tbl_encptn[i]  = 0;
		tbl_doublet[i] = 0;
		for (j = 0; j < NUM_MONPARTY_N; j++)
			tbl_count_n[i][j] = 0;
		for (j = 0; j < NUM_MONPARTY_F; j++)
			tbl_count_f[i][j] = 0;
	}

	/* R}hC͂ */
	for (i = 1; i < argc; i++)
	{
		if (argv[i] == NULL)
			continue;

		if (argv[i][0] != '-')
		{
			/* GJEgp^[ǂݍ */
			if (str_encptn[0] == '\0')
			{
				strncpy(str_encptn, argv[i], NUM_RANDOM);
				str_encptn[NUM_RANDOM] = '\0';
			}
		}
		else
		{
			const char *ptr = argv[i];

			/* IvV͂ */
			while (*++ptr != '\0')
			{
				/* lϊp̕ϐ */
				int num = -1;
				char *ptr_err = NULL;

				switch (tolower(*ptr))
				{
				case 'h':	/* gp@̕\ */
					flag_usage = 1;
					break;

				case 'a':	/* 鍑Rop^[̗\ʂ̕\ */
				case 'b':	/* Ȍ̓Go\̕\ */
				case 'm':	/* ő\ */
					/* lϊ */
					if (*(ptr + 1) != '\0')
					{
						int tmp = strtol(ptr + 1, &ptr_err, 10);
						if (*ptr_err == '\0')
							num = tmp;
					}
					else if (i < argc - 1)
					{
						int tmp = strtol(argv[i + 1], &ptr_err, 10);
						if (*ptr_err == '\0')
						{
							num = tmp;
							i++;
						}
					}

					switch (tolower(*ptr))
					{
					case 'a':
						airforce_num = (0 <= num && num <= NUM_AIRFORCE) ? num : DEF_NUM_AIRFORCE;
						flag_disp_airforce = 1;
						break;
					case 'b':
						max_battle_num = (0 <= num && num <= NUM_RANDOM) ? num : DEF_NUM_BATTLE;
						flag_disp_battle = 1;
						break;
					case 'm':
						max_disp_num = (0 <= num && num <= NUM_RANDOM) ? num : DEF_NUM_MAXDISP;
						break;
					}
					break;
				}
			}
		}
	}

	/* gp@\ */
	if (flag_usage)
	{
		puts(str_copyright);
		printf("%s: [option] [encount-pattern]\n", argv[0]);
		printf("  -a [NUMBER]  嗤ł̒鍑RƂ̐퓬̗\\\n");
		printf("               lw肵ꍇ́u2̑g(NUMBER)vȏ̗\̂ݕ\\n");
		printf("               (lw肵Ȃꍇ́u2̑g3vȏ)\n");
		printf("  -b NUMBER    ̓Go\܂ŕ\邩(0w肷Ɣ\)\n");
		printf("  -m NUMBER    ܂ŕ\邩(0w肷Ɣ\)\n");
		printf("  -h           gp@\ďI\n");
		printf("\n");

		free(str_encptn);
		free(tbl_encptn);
		free(tbl_doublet);
		free(tbl_count_n);
		free(tbl_count_f);

		exit(EXIT_SUCCESS);
	}

	/* ɃGJEgp^[ȂꍇAW͂ǂݍ */
	if (str_encptn[0] == '\0')
	{
		fgets(str_encptn, NUM_RANDOM, stdin);
		if (str_encptn[strlen(str_encptn) - 1] == '\n')
			str_encptn[strlen(str_encptn) - 1] = '\0';
	}

	/* GJEgp^[͂ */
	flag_chrclass   = 0;
	flag_parseerror = 0;
	encptn_num      = 0;
	encptn_len = (int)strlen(str_encptn);
	for (i = 0; i < encptn_len; i++)
	{
		int chr = toupper(str_encptn[i]);

		if (chr == CHR_GROUP_A ||
			chr == CHR_GROUP_B ||
			chr == CHR_GROUP_C ||
			chr == CHR_GROUP_D)
		{
			tbl_encptn[encptn_num] |= make_maskbit(chr_to_index(chr));
			if (!flag_chrclass)
				encptn_num++;
		}
		else if (chr == CHR_CHRMUTCH)
		{
			if (flag_chrclass)	/* JbRɃhbgꍇ̓G[ */
			{
				flag_parseerror = 1;
				break;
			}
			tbl_encptn[encptn_num] |= ~0;
			encptn_num++;
		}
		else if (chr == CHR_CHRCLASS_B)
		{
			if (flag_chrclass)	/* łɕJbRꍇ̓G[ */
			{
				flag_parseerror = 1;
				break;
			}
			flag_chrclass = 1;
		}
		else if (chr == CHR_CHRCLASS_E)
		{
			if (!flag_chrclass)	/* ΉJbRȂꍇ̓G[ */
			{
				flag_parseerror = 1;
				break;
			}
			flag_chrclass = 0;
			encptn_num++;
		}
		else	/* FłȂꍇ̓G[ */
		{
			flag_parseerror = 1;
			break;
		}
	}
	if (flag_chrclass)	/* ܂ŉ͂ĂΉJbRȂꍇ̓G[ */
		flag_parseerror = 1;

	/* GJEgp^[񂪕sȌ`łꍇ͏I */
	if (flag_parseerror)
	{
		fprintf(stderr, "%s: Gop^[񂪕sł\n", argv[0]);
		fprintf(stderr, "%s\n", str_encptn);
		fprintf(stderr, "%*s^\n", i, "");

		free(str_encptn);
		free(tbl_encptn);
		free(tbl_doublet);
		free(tbl_count_n);
		free(tbl_count_f);

		exit(EXIT_FAILURE);
	}

	/* u2̑gvo񐔂vZĂ */
	for (i = 0; i < NUM_RANDOM; i++)
	{
		int num_doublet = 0;

		for (j = 0; j < NUM_AIRFORCE; j++)
		{
			if (is_doublet(get_rnd(i + j)))
				num_doublet++;
		}

		tbl_doublet[i] = num_doublet;
	}

	/* ͂ꂽop^[\ */
	printf("͏op^[:\n  ");
	for (i = 0; i < encptn_num; i++)
	{
		if (i != 0)
			printf(", ");

		for (j = 0; j < NUM_MONPARTY_N; j++)
		{
			if ((tbl_encptn[i] & make_maskbit(j)) != 0)
				putchar(index_to_chr(j));
		}
	}
	printf("\n\n");

	/* \Jn */
	match_num = 0;
	for (rnd_index = 0; rnd_index < NUM_RANDOM; rnd_index++)
	{
		int flag_match = 1;

		/* ͂ꂽop^[Ɨe[uƂv邩ǂ肷 */
		for (i = 0; i < encptn_num; i++)
		{
			int rnd = get_rnd(rnd_index + i);

			if ((tbl_encptn[i] & make_maskbit(monenc_n(rnd))) == 0)
			{
				flag_match = 0;
				break;
			}
		}

		/* vꍇA\ */
		if (flag_match)
		{
			int battle_num[NUM_AIRFORCE + 1];
			int battle_num2[NUM_AIRFORCE + 1];

			/* u2̑gvn(n = 0`6)o܂ł̐퓬񐔂vZĂ */
			for (i = 0; i <= NUM_AIRFORCE; i++)
			{
				battle_num[i] = 0;
				for (j = 0; j < NUM_RANDOM; j++)
				{
					if (i == tbl_doublet[(rnd_index + encptn_num + j) % NUM_RANDOM])
					{
						battle_num[i] = j;
						break;
					}
				}

				battle_num2[i] = 0;
				for (j = 0; j < NUM_RANDOM; j++)
				{
					if (i == tbl_doublet[(rnd_index + j) % NUM_RANDOM])
					{
						battle_num2[i] = j;
						break;
					}
				}
			}

			/* ̃GJEgp^[\ */
			for (i = 0; i < max_battle_num; i++)
			{
				tbl_count_n[i][monenc_n(get_rnd(rnd_index + encptn_num + i))]++;
				tbl_count_f[i][monenc_f(get_rnd(rnd_index + encptn_num + i))]++;
			}

			/* ␔ꍇA\𒆒f */
			match_num++;
			if (match_num > max_disp_num)
				continue;

			printf("No.%d: ݗʒu: %04Xh, ʒu: %04Xh\n", match_num,
					(rnd_index + encptn_num) % NUM_RANDOM, rnd_index);
			if (flag_disp_airforce)
			{
				for (i = airforce_num; i <= NUM_AIRFORCE; i++)
				{
					printf("  2̑g%d: %4d퓬ɏo", i, battle_num[i]);
					printf(", ʒu: %04Xh", (rnd_index + encptn_num + battle_num[i]) % NUM_RANDOM);
					printf(", p^[: ");
					for (j = 0; j < NUM_AIRFORCE; j++)
					{
						if (j != 0)
							printf(", ");
						putchar((is_doublet(get_rnd(rnd_index + encptn_num + battle_num[i] + j))) ? CHR_GROUP_B : CHR_GROUP_A);
					}
					printf("\n");

					if (battle_num2[i] < battle_num[i])
					{
						printf("          SŌ%4d퓬ɏo", i, battle_num2[i]);
						printf(", ʒu: %04Xh", (rnd_index + battle_num2[i]) % NUM_RANDOM);
						printf(", p^[: ");
						for (j = 0; j < NUM_AIRFORCE; j++)
						{
							if (j != 0)
								printf(", ");
							putchar((is_doublet(get_rnd(rnd_index + battle_num2[i] + j))) ? CHR_GROUP_B : CHR_GROUP_A);
						}
						printf("\n");
					}
				}
				printf("\n");
			}
		}
	}

	/* ␔\ */
	if (match_num > max_disp_num && max_disp_num > 0)
		printf("₪%dẑŒf܂\n", max_disp_num);

	printf("␔: %d\n", match_num);

	/* ̃GJEgp^[̗\ʂ\ */
	if (flag_disp_battle && match_num > 0 && max_battle_num > 0)
	{
		printf("\n");
		printf("̓Go\:\n");

		printf("  퓬   ʏA ʏB ʏC ʏD   ŒA ŒB\n");

		for (i = 0; i < max_battle_num; i++)
		{
			printf("  %4d:   ", i + 1);

			for (j = 0; j < NUM_MONPARTY_N; j++)
			{
				if (j != 0)
					printf(", ");
				printf("%4d", tbl_count_n[i][j]);
			}

			printf("    ");

			for (j = 0; j < NUM_MONPARTY_F; j++)
			{
				if (j != 0)
					printf(", ");
				printf("%4d", tbl_count_f[i][j]);
			}

			printf("\n");
		}
	}

	/*  */
	free(str_encptn);
	free(tbl_encptn);
	free(tbl_doublet);
	free(tbl_count_n);
	free(tbl_count_f);

	return 0;
}

static int monenc_n(int num)
{
	if (0x00 <= num && num < 0x50)
		return 0;
	else if (0x50 <= num && num < 0xa0)
		return 1;
	else if (0xa0 <= num && num < 0xf0)
		return 2;
	else
		return 3;
}

static int monenc_f(int num)
{
	if (0x00 <= num && num < 0xc0)
		return 0;
	else
		return 1;
}

static int monenc_b(int num)
{
	return num % 8;
}
