/*
 *	rs2character.h
 *		Copyright (C)2002, 2004 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS2CHARACTER_H
#define RS2CHARACTER_H

#define NUM_CHRLV			50
#define NUM_CHRLV_ALL		39

typedef struct chrdata_tag
{
	int life_point;			/* Ct|Cg */
	int strength;			/* r */
	int dexterity;			/* p */
	int magic_power;		/*  */
	int unknown;			/* s */
	int speed;				/* f */
	int stamina;			/* ̗ */
	int level_tech_cng;		/* Zx␳ */
	int level_mag_cng;		/* px␳ */
	int type_tech_learn;	/* ZM̃^Cv */
	int flag_skill_sword;	/* E匕̋Z\Ă邩 */
	int flag_skill_axe;		/* E_̋Z\Ă邩 */
	int flag_skill_spear;	/* E̋Z\Ă邩 */
	int flag_skill_bow;		/* |̋Z\Ă邩 */
	int flag_skill_punch;	/* ̏p̋Z\Ă邩 */
	int flag_skill_fire;	/* ΂̏p̋Z\Ă邩 */
	int flag_skill_water;	/* ̏p̋Z\Ă邩 */
	int flag_skill_earth;	/* n̏p̋Z\Ă邩 */
	int flag_skill_wind;	/* ̏p̋Z\Ă邩 */
	int flag_skill_holy;	/* V̏p̋Z\Ă邩 */
	int flag_skill_dark;	/* ̏p̋Z\Ă邩 */
	int flag_frying;		/* ł */
	int flag_boss;			/* {Xł */
	int flag_undead;		/* Afbhnł */
	int flag_woman;			/* ł */
	int type_race;			/* 푰 */
} chrdata_t;

typedef struct chrdatasp_tag
{
	int life_point;			/* Ct|Cg */
	int tech_point;			/* Z|Cg */
	int mag_point;			/* p|Cg */
	int strength;			/* r */
	int dexterity;			/* p */
	int magic_power;		/*  */
	int unknown;			/* s */
	int speed;				/* f */
	int stamina;			/* ̗ */
	int level_sword;		/* E匕x */
	int level_axe;			/* E_x */
	int level_spear;		/* Ex */
	int level_bow;			/* |x */
	int level_punch;		/* ̏px */
	int level_fire;			/* ΂̏p̃x */
	int level_water;		/* ̏p̃x */
	int level_earth;		/* n̏p̃x */
	int level_wind;			/* ̏p̃x */
	int level_holy;			/* V̏p̃x */
	int level_dark;			/* ̏p̃x */
	int type_tech_learn;	/* ZM̃^Cv */
	int flag_frying;		/* ł */
	int flag_boss;			/* {Xł */
	int flag_undead;		/* Afbhnł */
	int flag_woman;			/* ł */
	int type_race;			/* 푰 */
	int tech_no[8];			/* CĂZ */
	int mag_no[8];			/* CĂp */
	int equipment_no[8];	/* ACe */
} chrdatasp_t;

typedef struct chrlvup_tag
{
	long technical_point[NUM_CHRLV];			/* Z\x㏸ɕKvȋZp_ */
	long technical_point_all[NUM_CHRLV_ALL];	/* S̋Z\x㏸ɕKvȋZp_ */
} chrlvup_t;

const char *chr_getname(int index);
const char *chr_getnamesp(int index);
chrdata_t *chr_readdata(void);
chrdatasp_t *chr_readdatasp(void);
chrlvup_t *chr_readlvup(void);
int chr_writeparam(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writeflag(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writespparam(const char *ptr_filename, const chrdatasp_t *ptr_chrdatasp);
int chr_writespflag(const char *ptr_filename, const chrdatasp_t *ptr_chrdatasp);
int chr_writespequip(const char *ptr_filename, const chrdatasp_t *ptr_chrdatasp);
int chr_writelvup(const char *ptr_filename, const chrlvup_t *ptr_chrlvup);

#endif /* RS2CHARACTER_H */
