/*
 *	rs2decoder.c
 *		Copyright (C)2002, 2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "errmes.h"
#include "utility.h"
#include "rs2decode.h"

#define STR_TOO_FEW_ARGUMENTS	"Too few arguments"
#define STR_INVALID_OPTION		"Invalid option"
#define STR_CANNOT_DECODE		"Cannot decode"

/* 쌠\L */
static const char *str_copyright = "rs2decoder - Copyright (C)2002 Shingo Endo <s-endo@yk.rim.or.jp>";

int main(int argc, char **argv)
{
	int i;
	int flag_invalid = 0;
	int flag_usage   = 0;
	char str_srcfilename[1024] = "";
	char str_dstfilename[1024] = "";

	errno = 0;
	err_setprogname(argv[0]);

	/* R}hC͂ */
	for (i = 1; i < argc; i++)
	{
		if (argv[i] == NULL)
			continue;

		if (*argv[i] == '-')
		{
			const char *ptr = argv[i];

			while (*++ptr != '\0')
			{
				switch (tolower(*ptr))
				{
				case 'h':	/* gp@̕\ */
					flag_usage = 1;
					break;
				default:
					flag_invalid = 1;
					break;
				}
			}
		}
		else
		{
			if (*str_srcfilename == '\0')
			{
				strncpy(str_srcfilename, argv[i], sizeof(str_srcfilename));
				str_srcfilename[sizeof(str_srcfilename) - 1] = '\0';
			}
			else if (*str_dstfilename == '\0')
			{
				strncpy(str_dstfilename, argv[i], sizeof(str_dstfilename));
				str_srcfilename[sizeof(str_dstfilename) - 1] = '\0';
			}
		}
	}

	/* gp@\ */
	if (flag_usage)
	{
		puts(str_copyright);
		printf("%s: [option] src-filename dst-filename\n", err_getprogname());
		printf("\t-s\tdecode in single-byte mode\n");
		printf("\t-m\tdecode in multi-byte mode\n");
		printf("\t-h\tdisplay this help and exit\n");
		printf("\n");

		exit(EXIT_SUCCESS);
	}

	/* R}hC`FbN */
	if (flag_invalid)
		err_printf(STR_INVALID_OPTION);
	if (*str_srcfilename == '\0' || *str_dstfilename == '\0')
		err_printf(STR_TOO_FEW_ARGUMENTS);

	/* t@CfR[hďo͂ */
	if (!dec_file(str_srcfilename, str_dstfilename))
		err_printf(STR_CANNOT_DECODE);

	return 0;
}
