/*
 *	rs3decode.c
 *		Copyright (C)2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "rs3decode.h"

/* }VO TEK3̕R[h\(VOoCg) */
static const char *tbl_charcode[] =
{
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	" ",  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z",
	"\", "^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z",
	"}", "~", "", "", "", "", "", "", "", "", "", "", "", "", "", "@",
	"B", "D", "F", "H", "", "", "", "b", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "K", "M", "O", "Q", "S",
	"U", "W", "Y", "[", "]", "_", "a", "d", "f", "h", "o", "r", "u", "x", "{", "p",
	"s", "v", "y", "|", "", "", " ",  "B", "A", "d", "!",  "?",  "E", "l", "s", "",
	"l", "o", "", "", "`", "", "", "", "O", "", "", "", "", "", "", "",
};

/* }VO TEK3̕R[h\(bZ[WpE}`oCg2oCg) */
static const char *tbl_charcode_mb2[] =
{
	/* 0x20 */
	" ",  "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "A", "C", "E", "G", "I", "J", "L", "N", "P", "R", "T", "V", "X", "Z",
	"\", "^", "`", "c", "e", "g", "i", "j", "k", "l", "m", "n", "q", "t", "w", "z",
	"}", "~", "", "", "", "", "", "", "", "", "", "", "", "", "", "@",
	"B", "D", "F", "H", "", "", "", "b", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "K", "M", "O", "Q", "S",
	"U", "W", "Y", "[", "]", "_", "a", "d", "f", "h", "o", "r", "u", "x", "{", "p",
	"s", "v", "y", "|", "", "", " ",  "B", "A", "d", "!",  "?",  "E", "l", "s", "",
	"l", "o", "", "", "`", "", "", "", "O", "", "", "", "", "", "", "",
	"", "", "", "", "b", "", "", "B", "C", "J", "", "", "", "", "", "q",
	"", "m", "", "p", "N", "", "", "", "", "", "a", "", "R", "", "", "",
	"", "C", "", "", "", "", "", "", "", "n", "", "_", "{", "v", "", "",
	"A", "G", "c", "", "", "c", "", "", "", "S", "", "", "", "", "E", "",
	"", "", "x", "", "", "", "D", "", "", "", "", "x", "A", "", "", "",

	/* 0x21 */
	"", "", "", "v", "", "", "", "j", "", "H", "", "", "X", "N", "", "z",
	"z", "", "P", "", "", "", "j", "m", "", "", "~", "M", "h", "V", "Z", "",
	"", "", "K", "", "", "d", "", "", "k", "Z", "", "", "g", "n", "D", "",
	"", "O", "", "", "", "", "v", "|", "", "", "{", "", "V", "", "R", "",
	"", "q", "", "~", "", "", "W", "", "", "", "", "\", "", "", "B", "W",
	"", "L", "o", "", "V", "", "", "", "s", "", "", "", "", "s", "", "T",
	"w", "", "E", "H", "[", "", "", "", "", "", "", "e", "", "", "", "",
	"", "", "q", "", "Q", "", "w", "", "", "V", "", "", "", "O", "p", "i",
	"", "X", "", "", "Q", "", "", "", "K", "", "", "", "i", "", "", "",
	"k", "", "", "", "u", "g", "t", "`", "", "x", "o", "", "", "", "\", "",
	"U", "S", "h", "", "", "Z", "", "Y", "", "", "", "", "`", "", "", "",
	"", "", "^", "", "", "", "", "", "", "", "@", "", "", "|", "", "",
	"D", "", "", "", "", "", "", "", "", "O", "Z", "d", "", "", "", "d",
	"", "_", "", "", "", "", "", "", "", "", "z", "", "e", "", "", "",
	"p", "D", "I", "", "r", "", "", "", "", "n", "i", "a", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "M", "",

	/* 0x22 */
	"", "", "g", "", "f", "", "", "", "", "", "^", "", "", "", "y", "",
	"", "X", "", "", "", "", "", "", "s", "", "N", "", "", "", "", "f",
	"", "A", "", "t", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "S", "", "R", "", "\", "f", "", "", "I", "", "X", "E", "", "", "\",
	"\", "", "", "I", "", "", "M", "", "", "", "", "", "", "G", "", "",
	"y", "z", "S", "", "", "", "", "", "P", "", "F", "N", "", "", "t", "l",
	"", "", "", "", "}", "", "b", "", "", "]", "", "L", "", "", "", "",
	"", "X", "j", "", "", "`", "", "", "b", "s", "", "", "@", "", "", "",
	"", "z", "q", "", "", "E", "c", "", "F", "U", "", "", "", "^", "l", "",
	"", "", "m", "U", "", "w", "z", "", "R", "_", "", "%",  "", "", "b", "",
	"@", "", "", "", "z", "", "", "", "Q", "", "", "", "", "", "", "",
	"h", "", "a", "", "", "~", "K", "", "", "", "", "", "", "[", "c", "k",
	"", "", "", "", "", "", "Q", "k", "t", "", "", "", "", "", "", "",
	"]", "]", "", "", "", "`", "", "", "`", "i", "", "", "J", "\", "F", "",
	"|", "", "~", "", "v", "", "D", "", "", "l", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "v", "", "", "J", "d", "", "", "r", "",

	/* 0x23 */
	"0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "H",  "L",  "P" , "/",  "", ":",
	"|", "", "i", "x", "", "", "", "", "", "", "\", "", "W", "w", "", "",
	"", "", "", "", "", "R", "", "n", "", "", "", "", "", "", "p", "q",
	"", "", "", "", "", "", "", "", "", "u", "", "", "", "", "", "",
	"U", "", "", "", "", "", "f", "", "", "", "", "", "t", "t", "", "",
	"", "Y", "", "p", "", "", "", "", "T", "", "", "m", "", "p", "n", "",
	"", "h", "", "_", "R", "", "p", "", "", "", "", "W", "", "", "z", "",
	"_", "S", "", "C", "", "S", "", "", "v", "E", "", "", "", "", "", "c",
	"", "z", "F", "a", "u", "V", "", "", "x", "", "A", "", "U", "", "", "",
	"Z", "", "", "T", "Q", "", "", "t", "", "", "", "n", "", "", "", "",
	"]", "", "Z", "", "", "", "", "", "", "", "", "", "", "", "", "a",
	"", "", "", "", "", "", "", "", "@", "", "", "d", "n", "", "y", "",
	"", "", "", "R", "", "_", "", "", "", "v", "", "", "P", "C", "", "b",
	"", "", "r", "M", "o", "", "", "", "", "", "", "", "", "", "", "e",
	"", "u", "", "", "h", "", "", "", "", "", "", "i", "", "{", "j", "",
	"", "", "", "m", "", "", "", "", "", "_", "", "q", "", "", "", "",
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize)
{
	int i;
	char *buf_dstbuf = NULL;
	char *ptr = NULL;
	const size_t len_buf = srcbufsize * 4;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 1024);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	for (i = 0; i < (int)srcbufsize; i++)
	{
		if (0x20 <= ptr_srcbuf[i] && ptr_srcbuf[i] <= 0x23)
		{
			if (i < (int)srcbufsize - 1)
			{
				strcat(buf_dstbuf, tbl_charcode_mb2[((int)(ptr_srcbuf[i] - 0x20) << 8) | ptr_srcbuf[i + 1]]);
				i++;
			}
		}
		else
			strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
	}

	/* ̋󔒂 */
	while ((ptr = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr + 1) == '\0')
		*ptr = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename)
{
	int ch, ch2;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 1024);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read = NULL;
		return 0;
	}

	/* fR[h */
	while ((ch = fgetc(fp_read)) != EOF)
	{
		if (0x20 <= ch && ch <= 0x23)	/* }`oCg */
		{
			if ((ch2 = fgetc(fp_read)) == EOF)
				break;

			fputs(tbl_charcode_mb2[((ch - 0x20) << 8) | ch2], fp_write);
		}
		else if (ch == 0x00)	/* Kxɉs邽 */
			fputc('\n', fp_write);
		else
			fputs(tbl_charcode[ch], fp_write);
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
