/*
 *	rs3monster.h
 *		Copyright (C)2002, 2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS3MONSTER_H
#define RS3MONSTER_H

#include "rs3item.h"

typedef struct monsize_tag
{
	int width;		/*  */
	int height;		/*  */
} monsize_t;

typedef struct mondata_tag
{
	long hit_point;				/* qbg|Cg */
	int life_point;				/* Ct|Cg */
	int tech_point;				/* Z|Cg */
	int mag_point;				/* p|Cg */
	int strength;				/* r */
	int dexterity;				/* p */
	int speed;					/* f */
	int stamina;				/* ̗ */
	int magic_power;			/*  */
	int will_power;				/* ӎu */
	int charm;					/*  */
	int level_tech;				/* Zx */
	int level_mag;				/* px */
	int level_lvup;				/* Z\㏸x */
	int level_tech_learn;		/* Mx */
	int type_race;				/* 푰 */
	int type_healing;			/* 񕜃^Cv */
	int flag_unknown;			/* stO */
	int flag_undead;			/* Afbhnł */
	int flag_woman;				/* ł */
	int flag_man;				/* jł */
	int flag_regist_water;		/* Uɑ΂ϐ */
	int flag_regist_throw;		/* Uɑ΂ϐ */
	int flag_regist_soundwave;	/* gUɑ΂ϐ */
	int flag_regist_gaze;		/* ÎUɑ΂ϐ */
	int flag_regist_ground;		/* nUɑ΂ϐ */
	int flag_catch_weapon[2];	/* 肪\ǂ */
	int equipment_no[5];		/* ACe */
	int item_no[4];				/* ACe */
	int credit;					/*  */
	int action_no[2][8];		/* sp^[ */
	monsize_t size;				/* TCY */
} mondata_t;

typedef struct monparty_tag
{
	int max_num;		/* X^[̍ő吔 */
	monsize_t max_size;	/* X^[̍őTCY */
	struct
	{
		int x;				/* XW */
		int y;				/* YW */
	} pos[5];
} monparty_t;

typedef struct monencmain_tag
{
	struct
	{
		int monster_no;		/* X^[ԍ */
		monparty_t party;
	} level[16];
} monencmain_t;

typedef struct monencsub_tag
{
	struct
	{
		int monster_no;		/* X^[ԍ */
		int monster_level;	/* X^[x */
	} level[48];
} monencsub_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monencmain_t *mon_readencmain(void);
monencsub_t *mon_readencsub(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata, const itemdata_t *ptr_itemdata);
int mon_writeregist(const char *ptr_filename, const mondata_t *ptr_mondata, const itemdata_t *ptr_itemdata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeequip(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeencmain(const char *ptr_filename, const monencmain_t *ptr_monencmain);
int mon_writeencsub(const char *ptr_filename, const monencsub_t *ptr_monencsub);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);

#endif /* RS3MONSTER_H */
